close all
clc
clear all

ln_wd = 4;
ln_wd2 = 3;
fn_sz = 15;
lg_sz = 8;

fn_sz2 = 16;
lg_sz2 = 10;

t_sz = 12;

nondur_coh = csvread('nondur_coh.csv',1,0);
income_coh = csvread('income_coh.csv',1,0);
pbuy_coh = csvread('pbuy_coh.csv',1,0);
stock_coh = csvread('stock_coh.csv',1,0);
stock_ndur_coh = csvread('stock_ndur_coh.csv',1,0);
stock_ndur_year = csvread('stock_ndur_year.csv',1,0);

nondur_coh(nondur_coh==0)=nan;
stock_coh(stock_coh==0)=nan;
stock_ndur_coh(stock_ndur_coh==0)=nan;
stock_ndur_year(stock_ndur_year==0)=nan;
pbuy_coh(pbuy_coh==0) = nan;
income_coh(income_coh==0) = nan;


nondur_coh = [nondur_coh(:,1),nondur_coh(:,end),nondur_coh(:,2:end-1)];
income_coh = [income_coh(:,1), income_coh(:,end), income_coh(:,2:end-1)];
pbuy_coh = [pbuy_coh(:,1), pbuy_coh(:,end), pbuy_coh(:,2:end-1)];
stock_coh = [stock_coh(:,1),stock_coh(:,end),stock_coh(:,2:end-1)];
stock_ndur_coh = [stock_ndur_coh(:,1),stock_ndur_coh(:,end),stock_ndur_coh(:,2:end-1)];
stock_ndur_year = [stock_ndur_year(:,1),stock_ndur_year(:,end),stock_ndur_year(:,2:end-1)];

% Recessions
r_time0 = [1981.5 1982.75 1982.75 1981.5];
r_time1 = [1990.5 1991,1991,1990.5];
r_time2 = [2001, 2001.75, 2001.75, 2001];
r_time3 = [2007.75 2009.25, 2009.25, 2007.75];
recess_c = [.7, .7, .7];
recess_e = 'none';

figure(1)
plot(nondur_coh(:,1),nondur_coh(:,2:end),'LineWidth',ln_wd2)
set(gca,'FontSize',fn_sz2)
xlabel('age')
ylabel('$000s')
% title('Non-durables','FontSize',t_sz)
%legend({'Born: 80-89','70-79','60-69','50-59','40-49','30-39','20-29','10-19'},'FontSize',lg_sz2,'Location','SouthEast')
set(gcf, 'Name', 'Non-durables')

figure(2)
plot(income_coh(:,1),income_coh(:,2:end),'LineWidth',ln_wd2)
set(gca,'FontSize',fn_sz2)
xlabel('age')
ylabel('$000s')
% title('Income','FontSize',t_sz)
%legend({'Born: 80-89','70-79','60-69','50-59','40-49','30-39','20-29','10-19'},'FontSize',lg_sz2,'Location','SouthEast')
set(gcf, 'Name', 'Income')

figure(3)
plot(pbuy_coh(:,1),pbuy_coh(:,2:end),'LineWidth',ln_wd2)
set(gca,'FontSize',fn_sz2)
xlabel('age')
ylabel('%')
% title('Percentage of households buying car','FontSize',t_sz)
%legend({'Born: 80-89','70-79','60-69','50-59','40-49','30-39','20-29','10-19'},'FontSize',lg_sz2,'Location','SouthEast')
set(gcf, 'Name', '% of hh purchasing')

figure(4)
plot(stock_coh(:,1),stock_coh(:,2:end),'LineWidth',ln_wd2)
set(gca,'FontSize',fn_sz2)
xlabel('age')
ylabel('$000s')
% title('Value of car stock','FontSize',t_sz)
%legend({'Born: 80-89','70-79','60-69','50-59','40-49','30-39','20-29','10-19'},'FontSize',lg_sz2,'Location','NorthWest')
set(gcf, 'Name', 'Value of car stock')

figure(5)
plot(stock_ndur_coh(:,1),stock_ndur_coh(:,2:end),'LineWidth',ln_wd2)
set(gca,'FontSize',fn_sz2)
xlabel('age')
% title('Ratio of stock of cars to non-durables consumption','FontSize',t_sz)
%legend({'Born: 80-89','70-79','60-69','50-59','40-49','30-39','20-29','10-19'},'FontSize',lg_sz2,'Location','SouthEast')
set(gcf, 'Name', 'Cars:non-durables (by lifecycle)')

figure(6)
r_blk = [min(min(stock_ndur_year(:,2:end))),min(min(stock_ndur_year(:,2:end))),...
    max(max(stock_ndur_year(:,2:end))),max(max(stock_ndur_year(:,2:end)))];
hold on
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
ax = gca;
ax.ColorOrderIndex = 1;
g1 = plot(stock_ndur_year(:,1),stock_ndur_year(:,2:end),'LineWidth',ln_wd2);
set(ax, 'box','on')
hold off
set(gca,'FontSize',fn_sz2)
% title('Ratio of stock of cars to non-durables consumption','FontSize',t_sz)
legend([g1],{'Born: 80-89','70-79','60-69','50-59','40-49','30-39','20-29','10-19'},'FontSize',lg_sz2,'Location','NorthWest')
axis tight
set(gcf, 'Name', 'Cars:non-durables (by year)')

