close all
clc
clear all

data = csvread('scaum-302.csv',1,0); % just indexes

t = 1978:1/12:2021;
% Prob of personal income increase 
pinc_mean  = data(:,23:25);

% Probability of job loss
pjob_mean  = data(:,26:28);

% Vehicle
veh_r = data(:,29:31);
% Prob of personal income increase 
pinc_ma = pinc_mean;
% Probability of job loss
pjob_ma = pjob_mean;
% Vehicle
veh_r_ma = veh_r;

wn=2;
for j = wn+1:length(t)-wn
% Prob of personal income increase
pinc_ma(j,:) = mean(pinc_mean(j-wn:j+wn,:));
% Probability of job loss
pjob_ma(j,:) = mean(pjob_mean(j-wn:j+wn,:));
% Vehicle
veh_r_ma(j,:) = mean(veh_r(j-wn:j+wn,:));
end

% rebase 
rb0 = 2007+8/12; 
rbT = 2007+10/12; 

tsht0 = 2005;
tshtT = 2014;

rb0_i = dsearchn(t',rb0);
rbT_i = dsearchn(t',rbT);

tsht0_i = dsearchn(t',tsht0);
tshtT_i = dsearchn(t',tshtT);

trb = t(tsht0_i:tshtT_i);

% Prob of personal income increase 
pinc_rb = pinc_ma(tsht0_i:tshtT_i,:) - mean(pinc_ma(rb0_i:rbT_i,:),1) + mean(pinc_ma(rb0_i:rbT_i,1));
% Probability of job loss
pjob_rb = pjob_ma(tsht0_i:tshtT_i,:) - mean(pjob_ma(rb0_i:rbT_i,:),1) + mean(pjob_ma(rb0_i:rbT_i,1));
% Vehicle
veh_r_rb = veh_r_ma(tsht0_i:tshtT_i,:) ./ mean(veh_r_ma(rb0_i:rbT_i,:),1) * 100 ; %mean(veh_r_ma(rb0_i:rbT_i,1));

r_time4 = [2007+11/12 2009+5/12, 2009+5/12, 2007+11/12];

lnwd=3;
recess_c = [.8, .8, .8];
recess_e = 'none';
fnt_sz = 16;

figure(1)
r_blk = [min(veh_r_rb(:)),min(veh_r_rb(:)),max(veh_r_rb(:)),max(veh_r_rb(:))];
hold on
plot(nan,nan)
plot(nan,nan)
plot(nan,nan)
plot(nan,nan)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
plot(nan,nan)
plot(nan,nan) 
g1 = plot(trb,veh_r_rb,'LineWidth',lnwd);
legend(g1,{'18-34','35-54','55+'})
hold off
axis tight
ylabel('index (2007=100)')
%title('Vehicle buying conditions')
set(gca,'FontSize',fnt_sz);
set(gcf, 'Name', 'vehbuycondition')

figure(2)
r_blk = [min(pinc_rb(:)),min(pinc_rb(:)),max(pinc_rb(:)),max(pinc_rb(:))];
hold on
plot(nan,nan)
plot(nan,nan)
plot(nan,nan)
plot(nan,nan)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
plot(nan,nan)
plot(nan,nan) 
g1 = plot(trb,pinc_rb,'LineWidth',lnwd);
hold off
axis tight
ylabel('% (rescaled)')
set(gca,'FontSize',fnt_sz);
set(gcf, 'Name', 'probincincrease5yr')

figure(3)
r_blk = [min(pjob_rb(:)),min(pjob_rb(:)),max(pjob_rb(:)),max(pjob_rb(:))];
hold on
plot(nan,nan)
plot(nan,nan)
plot(nan,nan)
plot(nan,nan)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
plot(nan,nan)
plot(nan,nan) 
g1 = plot(trb,pjob_rb,'LineWidth',lnwd);
hold off
axis tight
ylabel('% (rescaled)')
set(gca,'FontSize',fnt_sz);
set(gcf, 'Name', 'probjobloss5yr')

