clear all
clc
close all

datay_q1 = readmatrix(['21_q1.xlsx'],'Range',[1,2]);
datay_q2 = readmatrix(['21_q2.xlsx'],'Range',[1,2]);
datay_q = [datay_q1,datay_q2];

datan_q1 = readmatrix(['235_q1.xlsx'],'Range',[1,2]);
datan_q2 = readmatrix(['235_q2.xlsx'],'Range',[1,2]);
datan_q = [datan_q1,datan_q2];

datap_q1 = readmatrix(['234_q1.xlsx'],'Range',[1,2]);
datap_q2 = readmatrix(['234_q2.xlsx'],'Range',[1,2]);
datap_q = [datap_q1,datap_q2];

y1_q = 1979;
yn_q = 2012.75;

y1_a = 1979;
yn_a = 2012;

% NIPA
%Shares in 2012 (when index==100)
date = (1947:.25:2020.75)';

d =  datan_q(3,:)./datap_q(3,:);
car =  datan_q(4,:)./datap_q(4,:);
nd = datan_q(8,:)./datap_q(8,:);
s =  datan_q(13,:)./datap_q(13,:);
nds = nd + s;

y = datay_q(1,:)./datap_q(1,:);

d_yg = 100*[nan(1,4), log(d(5:end)) - log(d(1:end-4))];
car_yg = 100*[nan(1,4), log(car(5:end)) - log(car(1:end-4))];
nds_yg = 100*[nan(1,4), log(nds(5:end)) - log(nds(1:end-4))];

y_yg = 100*[nan(1,4), log(y(5:end)) - log(y(1:end-4))];

% Find elasticities
reg_y1 = 1950;
reg_yn = 2018;

b1_i = dsearchn(date,reg_y1); % fig 1 start
c1_i = dsearchn(date,reg_yn); % fig end

X1 = [ones(size(y_yg')),y_yg'];

beta_d_y = regress(d_yg(b1_i:c1_i)', X1(b1_i:c1_i,:) );
beta_car_y = regress(car_yg(b1_i:c1_i)', X1(b1_i:c1_i,:) );
beta_nds_y = regress(nds_yg(b1_i:c1_i)', X1(b1_i:c1_i,:) );

pred_d = X1*beta_d_y;
pred_car = X1*beta_car_y;
pred_nds = X1*beta_nds_y;

gap_d      = d_yg' - pred_d;
gap_car    = car_yg' - pred_car;
gap_nds    = nds_yg' - pred_nds;

b1_i = dsearchn(date,1980); % fig start
c1_i = dsearchn(date,2018); % fig end

recess_c = [.7, .7, .7];
recess_e = 'none';
fnt_sz = 14;
ln_wd = 2;

r_time2 = [1980 1980.5 1980.5 1980];
r_time3 = [1981.5 1982.75 1982.75 1981.5];
r_time4 = [1990.5 1991,1991,1990.5];
r_time5 = [2001, 2001.75, 2001.75, 2001];
r_time6 = [2007.75 2009.25, 2009.25, 2007.75];
r_time7 = [2020 date(end), date(end), 2020];

figure(1)
mn = min([d_yg(b1_i:c1_i),car_yg(b1_i:c1_i)]);
mx = max([d_yg(b1_i:c1_i),car_yg(b1_i:c1_i)]);
r_blk = [mn,mn,mx,mx];
hold on
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time5,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time6,r_blk,recess_c,'EdgeColor',recess_e)
plot(date(b1_i:c1_i),zeros(size(date(b1_i:c1_i))),'-k','LineWidth',1)
g2 = plot(date(b1_i:c1_i),car_yg(b1_i:c1_i),'-b','LineWidth',ln_wd);
g1 = plot(date(b1_i:c1_i),d_yg(b1_i:c1_i),'-r','LineWidth',ln_wd);
g0 = plot(date(b1_i:c1_i),nds_yg(b1_i:c1_i),'-m','LineWidth',ln_wd);
hold off
legend([g0,g1,g2],{'non-durables & services','durables','motor vehicles and parts'},'Location','NorthEast')
set(gca,'FontSize',fnt_sz)
ylabel('year-on-year growth')
axis tight

figure(6)
xx = [gap_nds(b1_i:c1_i);gap_d(b1_i:c1_i)];
r_blk = [min(xx),min(xx),max(xx),max(xx)];
hold on
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time5,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time6,r_blk,recess_c,'EdgeColor',recess_e)
plot(date(b1_i:c1_i),zeros(size(date(b1_i:c1_i))),'-k','LineWidth',1)
yyaxis left
ax = gca;
ax.YColor = 'black';
g2 = plot(date(b1_i:c1_i),gap_d(b1_i:c1_i),'-b','LineWidth',ln_wd);
ylabel('unpredicted growth')

yyaxis right
ax = gca;
ax.YColor = 'black';
g4 = plot(date(b1_i:c1_i),gap_nds(b1_i:c1_i),'-r','LineWidth',ln_wd);
ylabel('unpredicted growth')
hold off
legend([g2,g4],{'durables (LHS)','non-durables and services (RHS)'},'Location','NorthWest')
set(gca,'FontSize',fnt_sz)
axis tight
set(ax, 'OuterPosition', [0, 0, 0.98, 1]);

