close all
clc
clear all

ln_wd = 4;
ln_wd2 = 3;
fn_sz = 15;
lg_sz = 8;

fn_sz2 = 16;
lg_sz2 = 10;

t_sz = 12;

data_cex = csvread('cexdata_figure3.csv',1,0);  
date = data_cex(:,1);
pbuy = data_cex(:,2);
val = data_cex(:,3);

probit_dummies = csvread('probit_dummies.csv',1,0);
probit_dummies = [probit_dummies(:,1),probit_dummies(:,10:13)]; % + log income

data = [pbuy,val];
data2 = zeros(size(data));
    
% Apply seasonal adjustment
s = 4; % periods (4=quarterly)
n = size(data,2);

for j=1:n
y = data(:,j) ;
T = length(y);
sW13 = [1/(2*s) ;repmat(1/s,s-1,1);1/(2*s)];
yS = conv(y,sW13,'same');
yS(1:s/2) = yS(s/2+1); 
yS(T-s/2+1:T) = yS(T-s/2);

xt = y-yS;

sidx = cell(s,1);
for i = 1:s
 sidx{i,1} = i:s:T;
end

sst = cellfun(@(x) mean(xt(x)),sidx);

% Put smoothed values back into a vector of length N
nc = floor(T/s); % no. complete years
rm = mod(T,s); % no. extra months
sst = [repmat(sst,nc,1);sst(1:rm)];

% Center the seasonal estimate (additive)
sBar = mean(sst); % for centering
sst = sst-sBar;
dt = y - sst;

data2(:,j) = dt;
end

pbuy_sa =  data2(:,1);
val_sa =  data2(:,2)/1000;

% Recessions
r_time0 = [1980. 1980.5 1980.5 1980];
r_time1 = [1981.5 1982.75 1982.75 1981.5];
r_time2 = [1990.5 1991,1991,1990.5];
r_time3 = [2001, 2001.75, 2001.75, 2001];
r_time4 = [2007.75 2009.25, 2009.25, 2007.75];
recess_c = [.7, .7, .7];
recess_e = 'none';

ln_wd=3;
fn_sz=15;

figure(1)
r_blk = [min(pbuy_sa),min(pbuy_sa),max(pbuy_sa),max(pbuy_sa)];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
plot(date,pbuy_sa,'-b','LineWidth',ln_wd)
hold off
set(gca,'FontSize',fn_sz)
ylabel('%')
% title('Percentage of households buying car in each quarter','FontSize',t_sz)
axis tight
set(gcf, 'Name', 'Extensive margin')

figure(2)
r_blk = [min(val_sa),min(val_sa),max(val_sa),max(val_sa)];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
plot(date,val_sa,'-b','LineWidth',ln_wd)
hold off
set(gca,'FontSize',fn_sz)
ylabel('$000s')
axis tight
set(gcf, 'Name', 'Intensive margin')


figure(3)
r_blk = [min(min(probit_dummies(:,2:end))),min(min(probit_dummies(:,2:end))),...
    max(max(probit_dummies(:,2:end))),max(max(probit_dummies(:,2:end)))];
hold on
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
ax = gca;
ax.ColorOrderIndex = 1;
g1=plot(probit_dummies(:,1),probit_dummies(:,2:5),'o-','LineWidth',ln_wd);
hold off
set(gca,'FontSize',fn_sz)
% title('Year dummies from Probit model of purchase','FontSize',t_sz)
legend([g1],{'stock','stock*year','stock:ndur','stock:ndur*year'})
axis tight
set(gcf, 'Name', 'Time fixed effects')


