close all
clear all
clc

data_cex = csvread('cex_cohort_drop.csv',1,0);
data_cps = csvread('figure4/cps_data.csv',1,0);

data_cgr = data_cex(:,1);
data_iexts = data_cex(:,2);
data_p_buy = data_cex(:,3);
data_val = data_cex(:,4);
data_p_save = data_cex(:,5);
data_cloan = data_cex(:,6);
data_ly =data_cps(:,1);

fnt_sz = 12;
fnt_sz2 = 12;
wd = 0.95;
c1 = categorical(["car expenditure","car value | buy","% buy (p.p.)"]);  
c1 = reordercats(c1,string(c1));
c2 = categorical(["\Deltaconsump.","labor income","car loan","% saving (p.p.)"]);  
c2 = reordercats(c2,string(c2));

c1a = categorical(["car expenditure\newline        (%)","car value|buy\newline       (%)","% buy\newline  (p.p)"]);  
c1a = reordercats(c1a,string(c1a));
c2a = categorical(["\Deltaconsump.\newline      (%)",...
    "labor income\newline       (%)","car loan\newline   (%)","net saving\newline    (p.p)"]);  
c2a = reordercats(c2a,string(c2a));

bc1 = [0 0.4470 0.7410];
bc2 = [0.8500 0.3250 0.0980];
bc3 = [0.9290 0.6940 0.1250];

SLT1 = [data_iexts'; data_val'; data_p_buy'];
SLT2 = [data_cgr'; data_ly'; data_cloan'; data_p_save'];

SLT1_L = [SLT1(1,:); SLT1(2,:); nan(size(SLT1(3,:)))];
SLT1_R = [nan(size(SLT1(1,:))); nan(size(SLT1(2,:))); SLT1(3,:)];

SLT2_L = [SLT2(1,:); SLT2(2,:); SLT2(3,:); nan(size(SLT2(4,:)))];
SLT2_R = [nan(size(SLT2(1,:))); nan(size(SLT2(2,:))); nan(size(SLT2(3,:))); SLT2(4,:)];

f = figure(1);
hold on
g1 = bar(c1a,100*SLT1_L,wd); 
ylabel('% deviation')

yyaxis right
g2 = bar(c1a,100*SLT1_R,wd);  
ax = gca;
ax.YColor = 'black';
g2(1).FaceColor = bc1;
g2(2).FaceColor = bc2;
g2(3).FaceColor = bc3;
ylabel('p.p. deviation')
set(gca,'FontSize',fnt_sz)
set(gca,'XTickLabelRotation',0)
set(ax, 'OuterPosition', [0, 0.02, 0.98, 0.98]);


f = figure(2);
hold on
g1 = bar(c2a,100*SLT2_L,wd); 
ylabel('% deviation')

yyaxis right
g2 = bar(c2a,100*SLT2_R,wd);  
ax = gca;
ax.YColor = 'black';
g2(1).FaceColor = bc1;
g2(2).FaceColor = bc2;
g2(3).FaceColor = bc3;
ylabel('p.p. deviation')

%align zero for left and right
yyaxis right; ylimr = get(gca,'Ylim');ratio = ylimr(1)/ylimr(2);
yyaxis left; yliml = get(gca,'Ylim');
if yliml(2)*ratio<yliml(1)
    set(gca,'Ylim',[yliml(2)*ratio yliml(2)])
else
    set(gca,'Ylim',[yliml(1) yliml(1)/ratio])
end
set(gca,'FontSize',fnt_sz)
set(gca,'XTickLabelRotation',0)
legend([g1],{'25-34','35-44','45-54'},'Location','NorthWest','FontSize',fnt_sz2);   
set(ax, 'OuterPosition', [0, 0.02, 0.98, 0.98]);
box on
