local folder = "..\empirical\table2"
cd `folder'

clear

use cex_probitdata, replace

gen age_sq = age^2
gen age_cu = age^3
gen age_q = age^4

gen stock_ndur=(stock*10000/rcndur_q)

* Dummy for quarter
forval i=1985/2011 {
gen yseas`i'=(year(dofy(qintrvyr))==`i')
lab var yseas`i' "Dummy variable for quarter `i' "
}

** PROBIT MODEL with stock of cars
 * stock in 10 000 dollars
forval i=1985/2011 {
gen stock_yr`i'=stock*yseas`i'
}
probit car_buy stock black educ sex fam_size age age_sq age_cu age_q full_time weekssp lfincatax yseas*, iterate(30)
margins, dydx(*)
est store p1, title(Probit 1)

probit car_buy stock black educ sex fam_size age age_sq age_cu age_q full_time weekssp lfincatax yseas*  stock_yr*, iterate(30)
margins, dydx(*)
est store p2, title(Probit 2)



** PROBIT MODEL with stock of cars over nondurables
* stock of cars/ nondur over 10 000
forval i=1985/2011 {
gen stockndur_yr`i'= stock_ndur*yseas`i'
}
probit car_buy stock_ndur black educ sex fam_size age age_sq age_cu age_q full_time weekssp lfincatax yseas*, iterate(30)
margins, dydx(*)
est store p3, title(Probit 3)

probit car_buy stock_ndur black educ sex fam_size age age_sq age_cu age_q full_time weekssp lfincatax yseas* stockndur_yr*, iterate(30)
margins, dydx(*)
est store p4, title(Probit 4)

