program durables
 use share
 USE OMP_LIB
 use par_zig_mod

IMPLICIT NONE

  INTEGER :: i,j,k,l,m,i2,j2,iter,mx_thread, thread, chk_thread
  REAL(8) :: y_ss, c_h_ss, step, steph, steps, r_beta_cons
  REAL(8), DIMENSION(pen_yr-1) :: u_coef1
  REAL(8) :: u_coef2
  REAL(8) :: t0,t1,t2,t3,tcalc
  REAL(8) :: z_lb
  INTEGER :: AllocateStatus, status

! VALUE FUNCTIONS AND POLICIES
! --------------
    REAL(8), DIMENSION(nx,nD,ng,ndp,nc,ngp,nrk) :: &
	 Vnoadjust, Vadjust
    REAL(8), DIMENSION(nx,nD,ng,ndp,nc,ngp,nrk) :: a_adj,  &
	a_nadj,  D_adj, cchoice

   ! Monthly
   ! -------
    REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk) :: Vnoadjust_m, Vadjust_m
    REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk) :: a_adj_m,  a_nadj_m,  D_adj_m


    INTEGER, DIMENSION(:,:), ALLOCATABLE :: age_t
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: init_y_shock, init_x_shock, init_d_shock
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: init_d_nadj_shock, init_delta_shock
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: init_clunk_shock
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: alive_t_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: n_shck_shock, u_shck_shock, dp_shck_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: p_t_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: q_t_shock, w_shck_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: rk_t_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: v_shck_shock, m_shck_shock
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: g_shck_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: rk_shck_shock

   ! Monthly
   ! -------
   REAL(8), DIMENSION(agents,rep) :: &
	 ixcross_m, idcross_m
   INTEGER, DIMENSION(agents,rep) :: ideltacross_m

   REAL(8), DIMENSION(:,:), ALLOCATABLE :: &
	 init_x_shock_m, init_d_shock_m, init_p_shock_m, init_u_shock_m
   INTEGER, DIMENSION(:,:), ALLOCATABLE :: init_d_nadj_shock_m, init_delta_shock_m
   INTEGER, DIMENSION(:,:), ALLOCATABLE  :: age_t_m
   INTEGER, DIMENSION(:,:,:), ALLOCATABLE  :: init_clunk_shock_m
   INTEGER, DIMENSION(:,:,:), ALLOCATABLE  :: alive_t_shock_m
   REAL(8), DIMENSION(:,:,:), ALLOCATABLE  :: n_shck_shock_m, &
	  u_shck_shock_m, dp_shck_shock_m
   REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE  :: p_t_shock_m
   REAL(8), DIMENSION(:,:,:), ALLOCATABLE  :: v_shck_shock_m, m_shck_shock_m
   REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE  :: q_t_shock_m, w_shck_shock_m
   REAL(8), DIMENSION(:,:,:), ALLOCATABLE  :: rk_t_shock_m
   INTEGER, DIMENSION(:,:,:), ALLOCATABLE  :: g_shck_shock_m

  OPEN(UNIT=1,FILE='omp_thread',STATUS='OLD',ACTION='READ',IOSTAT=status)
  READ(1,*,IOSTAT=status) thread
  CLOSE(1)

  !$OMP PARALLEL
  mx_thread = OMP_GET_MAX_THREADS()
  thread = MIN(thread,mx_thread)
  !$OMP END PARALLEL
  CALL OMP_SET_NUM_THREADS(thread)
  !$OMP PARALLEL
  chk_thread = OMP_get_num_threads()
  !$OMP END PARALLEL

  t0 = omp_get_wtime()

  tau = (kappa-1.d0)/kappa
  delta = (/ delta_1, delta_2 /)
  delta_m = (/ delta_1_m, delta_2_m /)

  sigma_ar = SQRT( sigma_id**2 + sigma_ag**2 )
  sigma_ma_lc = SQRT( sigma_ma**2 + sigma_pve**2 )
  beta_pve = corr_pve_v*sigma_pve/sigma_ag
  sigma_pve_res = SQRT( sigma_pve**2 - beta_pve**2 * sigma_ag**2 )

  gnodes = 1.d0
  CALL sub_seriesin

  DO i=0,pen_yr-2
  u_coef1(i+1) = 1.d0/EXP( SUM( LOG(gnodes(twork-i:twork,2) ) ) )
  END DO
  u_coef2 = (1.d0 + SUM(u_coef1) )/pen_yr
  u_ret = zeta * u_coef2

  ! Monthly variables
  ! ----
  m_id = 0.d0
  m_ag = 0.d0
  m_ar = 0.d0
  m_ma = 0.d0
  CALL sub_tauchen(enodes,Probe,Probecum,0.d0,m_ar,sigma_ar,ne,cover_e)
  CALL sub_tauchen(unodes,Probu,Probucum,0.d0,m_ma,sigma_ma_lc,nu,cover_u)
  DO i =1,ng
  sigma_q(i) = SQRT( h_shr(i)**2 * sigma_q_h**2 + s_shr(i)**2 * sigma_q_s**2 + &
	2.d0 * cov_q_hs * h_shr(i) * s_shr(i) )
  m_q(i) = -0.5 * sigma_q(i)**2
  m_q_h(i) = -0.5d0 * sigma_q_h**2 * h_shr(i)**2
  CALL sub_tauchen(wnodes(:,i),Probw(:,:,i),Probwcum(:,:,i),0.d0,m_q(i),sigma_q(i),nw,cover_w)
  END DO
  CALL sub_tauchen(rknodes,Probrk,Probrkcum,rho_rk,LOG(rk),sigma_rk,nrk,cover_rk)
  enodes = exp(enodes)
  unodes = exp(unodes)
  wnodes = exp(wnodes)
  rknodes = exp(rknodes)
  emax = enodes(ne)
  emin = enodes(1)
  umax = unodes(nu)
  umin = unodes(1)
  wmax = MAXVAL( wnodes )
  wmin = MINVAL( wnodes )
  rkmax = rknodes(nrk)
  rkmin = rknodes(1)

  Probdp = reshape( (/ p_delta_1, 1.d0-p_delta_2, &
			1.d0-p_delta_1, p_delta_2 /), (/ndp,ndp/) )

  Probdpcum = reshape( (/ 1.d0-p_delta_2, 1.d0-p_delta_2, &
			p_delta_2, p_delta_2 /), (/ndp,ndp/) )

  Probdp_m = reshape( (/ p_delta_1_m, 1.d0-p_delta_2_m, &
			1.d0-p_delta_1_m, p_delta_2_m /), (/ndp,ndp/) )

  Probdpcum_m = reshape( (/ 1.d0-p_delta_2_m, 1.d0-p_delta_2_m, &
			p_delta_2_m, p_delta_2_m /), (/ndp,ndp/) )

  Probc = reshape( (/ p_clunk1, 1.d0-p_clunk2, &
			1.d0-p_clunk1, p_clunk2 /), (/nc,nc/) )
  Probccum = MATMUL(Probc,Probc)


  Probccum = reshape( (/ 1.d0-p_clunk2, 1.d0-p_clunk2, &
			p_clunk2, p_clunk2 /), (/nc,nc/) )


  eta=(1.d0-delta_2-F)/(r+rk)
  clunk = (/ clunk_disc , 1.d0 /)
  clunk_m = (/ clunk_disc_m , 1.d0 /)


  Probg = reshape( (/ 1.d0-1.d0/twork, 0.d0, 1.d0/twork, 1.d0 /), (/ngp,ngp/) )


  step = ((amax-amin)/(DBLE(na)-1.0d0))
  anodes = (/ (amin + step*i, i = 0, na-1) /)
  anodes(na) = amax

  step = ((Dmax-Dmin)/(DBLE(nD)-1.0d0))
  Dnodes = (/ (Dmin + step*i, i = 0, nD-1) /)
  Dnodes(nD) = Dmax

  IF (amin - eta*Dmax >= 0.d0) THEN
  xmin = (amin-eta*Dmax)*r/(MAXVAL(gnodes)*MAXVAL(enodes)) + &
	(1.d0-MAXVAL(delta) )*Dmin + MIN(MINVAL(unodes),u_ret)
  ELSE
  xmin = (amin*(r+rkmax) + (1.d0-MAXVAL(delta)-(r+rkmax)*eta)*Dmin) &
	 /(MAXVAL(gnodes)*MAXVAL(enodes)) + MIN(MINVAL(unodes),u_ret)

  END IF
  z_lb = 0.1d0
  xmin = MAX(xmin,z_lb)
  xmax = r*(amax - eta*Dmax)*MAXVAL(wnodes) + (1.d0-MINVAL(delta))*Dmax + MAXVAL(unodes)

  step = ((xmax-xmin)/(DBLE(nx)-1.0d0))
  xnodes = (/ (xmin + step*i, i = 0, nx-1) /)
  xnodes(nx) = xmax

  zmin = MAX(xmin-F*Dmax,z_lb)
  zmax = xmax-F*Dmin
  step = ((zmax-zmin)/(DBLE(nz)-1.0d0))
  znodes = (/ (zmin + step*i, i = 0, nz-1) /)
  znodes(nz) = zmax

  sigma_ar_m = SQRT( sigma_ar**2 / DBLE(mnth) )
  m_id_m = 0.d0
  m_ag_m = 0.d0
  m_ar_m = 0.d0
  m_ma_m = 0.d0
  CALL sub_tauchen(enodes_m,Probe_m,Probecum_m,0.d0,m_ar_m,sigma_ar_m,ne,cover_e)
  CALL sub_tauchen(unodes_m,Probu_m,Probucum_m,0.d0,m_ma_m,sigma_ma_lc,nu,cover_u)
  CALL sub_tauchen(rknodes_m,Probrk_m,Probrkcum_m,rho_rk_m,LOG(rk),sigma_rk_m,nrk,cover_rk)
  enodes_m = exp(enodes_m)
  unodes_m = exp(unodes_m)
  rknodes_m = exp(rknodes_m)
  rkmax_m = rknodes_m(nrk)
  rkmin_m = rknodes_m(1)
  Probc_m = reshape( (/ p_clunk1_m, 1.d0-p_clunk2_m, &
			1.d0-p_clunk1_m, p_clunk2_m /), (/nc,nc/) )
  Probg_m = reshape( (/ (1.d0-1.d0/(twork*mnth) )**(1.d0/DBLE(mnth)), 0.d0, &
		1.d0-(1.d0-1.d0/(twork*mnth) )**(1.d0/DBLE(mnth)), 1.d0 /), (/ngp,ngp/) )

  gnodes_m(1,:) = gnodes(1,:)**(1.d0/DBLE(mnth))
  DO i=1,ng
  IF (i .LT. ng) THEN

  steph = (h_shr(i+1)- h_shr(i))/DBLE(mnth)
  steps = (s_shr(i+1)- s_shr(i))/DBLE(mnth)
  ELSE
  steph = 0.d0
  steps = 0.d0
  END IF
   DO j=1,mnth
    l = (i-1)*mnth + j
    betanodes_m(l) = betanodes(i)**(1.d0/DBLE(mnth))
    h_shr_m(l) = h_shr(i)+(j-1)*steph
    s_shr_m(l) = s_shr(i)+(j-1)*steps
    DO k=1,2
    IF (i .LT. ng) THEN
    gnodes_m(l+1,k) = gnodes(i+1,k)**(1.d0/DBLE(mnth))

    ELSE
      IF (l+1 .LE. ng_m) THEN
      gnodes_m(l+1,k) = gnodes(ng,k)**(1.d0/DBLE(mnth))
      END IF
    END IF
    END DO
   END DO
  END DO


  DO i=ng,3,-1
  step = (eqvnodes(i)- eqvnodes(i-1))/DBLE(mnth)
     DO j=0,mnth-1
     l = i*mnth - j
     eqvnodes_m(l) = eqvnodes(i) - DBLE(j)*step
     END DO
  END DO
  step = (eqvnodes(2)- eqvnodes(1))/DBLE(2*mnth)
     DO j=0,2*mnth-1
     l = 2*mnth - j
     eqvnodes_m(l) = eqvnodes(2) - DBLE(j)*step
     END DO


  DO i =1,ng_m
  sigma_q_m(i) = SQRT( h_shr_m(i)**2 * sigma_q_h_m**2 + s_shr_m(i)**2 * sigma_q_s_m**2 + &

	2.d0 * cov_q_hs_m * h_shr_m(i) * s_shr_m(i) )
  m_q_m(i) = -0.5 * sigma_q_m(i)**2
  CALL sub_tauchen(wnodes_m(:,i),Probw_m(:,:,i),Probwcum_m(:,:,i),0.d0,m_q_m(i),sigma_q_m(i),nw,cover_w)
  END DO
  wnodes_m = exp(wnodes_m)


  step = ((amax_m-amin)/(DBLE(na)-1.0d0))
  anodes_m = (/ (amin + step*i, i = 0, na-1) /)
  anodes_m(na) = amax_m

  step = ((Dmax_m-Dmin)/(DBLE(nD)-1.0d0))
  Dnodes_m = (/ (Dmin + step*i, i = 0, nD-1) /)
  Dnodes_m(nD) = Dmax_m

  IF (amin - eta*Dmax_m >= 0.d0) THEN
  xmin_m = (amin-eta*Dmax_m)*r_m/(MAXVAL(gnodes_m)*MAXVAL(enodes_m)) + &
	(1.d0-MAXVAL(delta_m) )*Dmin + MIN(MINVAL(unodes_m),u_ret)
  ELSE
  xmin_m = (amin*(r_m+MAXVAL(rknodes_m)) + (1.d0-MAXVAL(delta_m)-(r_m+MAXVAL(rknodes_m))*eta)*Dmin) &
	 /(MAXVAL(gnodes_m)*MAXVAL(enodes_m)) + MIN(MINVAL(unodes_m),u_ret)
  END IF
  xmin_m = MAX(xmin_m,z_lb)
  xmax_m = r_m*(amax_m - eta*Dmax_m)*MAXVAL(wnodes_m) + &
	(1.d0-MINVAL(delta_m))*Dmax_m + MAXVAL(unodes_m)

  step = ((xmax_m-xmin_m)/(DBLE(nx)-1.0d0))
  xnodes_m = (/ (xmin_m + step*i, i = 0, nx-1) /)
  xnodes_m(nx) = xmax_m

  zmin_m = MAX(xmin_m-F*Dmax_m,z_lb)
  zmax_m = xmax_m-F*Dmin
  step = ((zmax_m-zmin_m)/(DBLE(nz)-1.0d0))
  znodes_m = (/ (zmin_m + step*i, i = 0, nz-1) /)
  znodes_m(nz) = zmax_m

  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(555,*) ' MONTHLY MODEL WITH CASH FOR CLUNKERS '
  CLOSE(555)

  CALL sub_valueiterate( Vnoadjust, Vadjust, a_adj,  &
	a_nadj,  D_adj, cchoice )

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished finding policy fn. TIME: ', tcalc
  CLOSE(555)

  t2 = omp_get_wtime()
  CALL sub_valueiterate_mnth(Vnoadjust_m, Vadjust_m, a_adj_m,  &
	a_nadj_m,  D_adj_m )
  t3 = omp_get_wtime()
  tcalc = t3-t2
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished finding monthly policy fn. TIME: ', tcalc
  CLOSE(555)

 t2 = omp_get_wtime()
  ALLOCATE( init_x_shock_m(agents,rep), init_d_shock_m(agents,rep), &
    init_p_shock_m(agents,rep), init_u_shock_m(agents,rep), STAT=AllocateStatus )

  ALLOCATE( init_d_nadj_shock_m(agents,rep), init_delta_shock_m(agents,rep), &
    init_clunk_shock_m(clunk_dur_m,agents,rep) )

  CALL sub_shocks_mnth_a(init_x_shock_m, init_d_shock_m, init_p_shock_m, init_u_shock_m, &
    init_d_nadj_shock_m,init_delta_shock_m,init_clunk_shock_m)

  t3 = omp_get_wtime()

  tcalc = t3-t2
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished generating monthly shocks I. TIME: ', tcalc
  CLOSE(555)

  t0 = omp_get_wtime()
  ALLOCATE( age_t(numsim,agents) )
  ALLOCATE( init_y_shock(shocklives,agents,rep), init_x_shock(shocklives,agents,rep), &
  	init_d_shock(shocklives,agents,rep), n_shck_shock(numshock,agents,rep), &
  	u_shck_shock(numshock,agents,rep), dp_shck_shock(numshock,agents,rep), &
  	p_t_shock(numshock,agents,rep,shck_c), q_t_shock(numshock,ng,rep,shck_c), &
  	w_shck_shock(numshock,ng,rep,shck_c), rk_t_shock(numshock,rep,shck_c), &
  	v_shck_shock(numshock,twork,rep,shck_c), m_shck_shock(numshock,twork,rep,shck_c), &
  	g_shck_shock(numshock,shck_c), rk_shck_shock(numshock,rep,shck_c), STAT=AllocateStatus  )

  ALLOCATE( init_d_nadj_shock(shocklives,agents,rep), init_delta_shock(shocklives,agents,rep), &
	init_clunk_shock(agents,rep), alive_t_shock(numshock,agents,rep) )

  CALL sub_shocks_b(age_t,init_y_shock, init_x_shock, init_d_shock, init_d_nadj_shock,&
  	init_delta_shock,init_clunk_shock, &
  	alive_t_shock,n_shck_shock,u_shck_shock,p_t_shock,q_t_shock,rk_t_shock,&
  	v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock,dp_shck_shock,rk_shck_shock)

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished generating simulation shocks. TIME: ', tcalc
  CLOSE(555)

  t0 = omp_get_wtime()
  CALL sub_shocksim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
  	init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock,&
  	init_delta_shock,init_clunk_shock,age_t,alive_t_shock, &
  	n_shck_shock,u_shck_shock,p_t_shock,dp_shck_shock,q_t_shock,&
  	rk_t_shock,v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock,&
  	idcross_m, ixcross_m,ideltacross_m)

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished shock sim. TIME: ', tcalc
  CLOSE(555)


  t2 = omp_get_wtime()
  ALLOCATE( n_shck_shock_m(numshock_m,agents,rep), u_shck_shock_m(numshock_m,agents,rep), &
	dp_shck_shock_m(numshock_m,agents,rep),  p_t_shock_m(numshock_m,agents,rep,shck_c_m), &
	v_shck_shock_m(numshock_m,twork*mnth,shck_c_m), &
	m_shck_shock_m(numshock_m,twork*mnth,shck_c_m), &
	q_t_shock_m(numshock_m,ng_m,rep,shck_c_m), &
	w_shck_shock_m(numshock_m,ng_m,rep,shck_c_m), rk_t_shock_m(numshock_m,rep,shck_c_m) , STAT=AllocateStatus  )

  ALLOCATE( age_t_m(numshock_m,agents),  &
	alive_t_shock_m(numshock_m,agents,rep), g_shck_shock_m(numshock_m,agents,shck_c_m)  )

  CALL sub_shocks_mnth_b(age_t,alive_t_shock,n_shck_shock,u_shck_shock, &
	p_t_shock,q_t_shock,rk_t_shock,v_shck_shock,m_shck_shock, &
	w_shck_shock,g_shck_shock,rk_shck_shock, &
	init_p_shock_m, init_u_shock_m,age_t_m, &
	alive_t_shock_m,n_shck_shock_m,u_shck_shock_m, &
	p_t_shock_m,q_t_shock_m,rk_t_shock_m,v_shck_shock_m, &
	m_shck_shock_m,w_shck_shock_m,g_shck_shock_m,dp_shck_shock_m)
  t3 = omp_get_wtime()
  tcalc = t3-t2
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished generating monthly simulation shocks. TIME: ', tcalc
  CLOSE(555)

  DEALLOCATE( init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock,&
	init_delta_shock,init_clunk_shock,alive_t_shock, &
	n_shck_shock,u_shck_shock,p_t_shock,dp_shck_shock,q_t_shock,&
	rk_t_shock,v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock )

  t2 = omp_get_wtime()
  CALL sub_shocksim_mnth(Vnoadjust_m,Vadjust_m,a_adj_m,a_nadj_m,D_adj_m, &
	ixcross_m,idcross_m,ideltacross_m,init_x_shock_m,init_d_shock_m, &
	init_d_nadj_shock_m,init_delta_shock_m,init_clunk_shock_m, &
	age_t_m,alive_t_shock_m, n_shck_shock_m,u_shck_shock_m,&
	p_t_shock_m,dp_shck_shock_m,q_t_shock_m,rk_t_shock_m, &
	v_shck_shock_m,m_shck_shock_m,w_shck_shock_m,g_shck_shock_m)

  DEALLOCATE( init_x_shock_m, init_d_shock_m, init_p_shock_m, init_u_shock_m, &
	init_d_nadj_shock_m,init_delta_shock_m, age_t_m,init_clunk_shock_m, &
	alive_t_shock_m,n_shck_shock_m,u_shck_shock_m, &
	p_t_shock_m,q_t_shock_m,rk_t_shock_m,v_shck_shock_m,&
	m_shck_shock_m,w_shck_shock_m,g_shck_shock_m,dp_shck_shock_m )

  t3 = omp_get_wtime()
  tcalc = t3-t2
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished monthly shock sim. TIME: ', tcalc
  CLOSE(555)


end program durables

REAL(8) FUNCTION fel(C,Dprime,equiv)

USE share
IMPLICIT NONE
REAL(8), INTENT(IN) :: C, Dprime, equiv

fel = ( ( (theta * ((C+1d-7)/equiv)**tau  + &
	(1.d0-theta)*(xi*(Dprime+1d-7)/equiv)**tau)**(1.d0/tau) )**(1.0d0-psi) - 1.d0 )/(1.0d0-psi)

END FUNCTION fel


REAL(8) FUNCTION fel_m(C,Dprime,equiv)

USE share
IMPLICIT NONE
REAL(8), INTENT(IN) :: C, Dprime, equiv

fel_m = ( ( (theta_m * ((C+1d-7)/equiv)**tau  + &
	(1.d0-theta_m)*(xi_m*(Dprime+1d-7)/equiv)**tau)**(1.d0/tau) )**(1.0d0-psi) - 1.d0 )/(1.0d0-psi)

END FUNCTION fel_m

SUBROUTINE sub_tauchen(y,pi,picum,rho,mu0,sigma,n,cover_tauchen)
	! Calculates Tauchen points for AR(1) x=(1-rho)mu0 + rho*x_(-1) + u
	! Adapted from sub_tauchen by Jesus Fernandez-Villaverde (undated)
	! cover_tauchen is the number of SD (each side) that one wants
	! to cover.

	IMPLICIT NONE

	INTEGER, INTENT(in) :: n

	REAL(8), INTENT(in) :: rho, mu0, sigma, cover_tauchen
	REAL(8), DIMENSION (n,n), INTENT(out) :: pi , picum
	REAL(8), DIMENSION (n), INTENT(out) :: y

	INTEGER :: yc, tc, tcc,i1

	REAL(8) :: sigy, mu, upp, low
	REAL(8), EXTERNAL  :: cum_normal

	! Define the discrete states of the Markov chain

	sigy = sigma/SQRT(1.0-rho**2)

	y(n) = mu0 + cover_tauchen*sigy
	y(1) = mu0 - cover_tauchen*sigy

	DO yc = 2, n-1

		y(yc) = y(1)+(y(n)-y(1))*(yc-1.0)/(n-1.0)

	END DO

	! Compute the transition matrix

	DO tc = 1,n
		mu = (1-rho)*mu0 + rho*y(tc)
		upp = (y(2)+y(1))/2.0
		upp = (upp-mu)/sigma
		pi(tc,1) = cum_normal(upp)
		low = (y(n)+y(n-1))/2.0
		low = (low-mu)/sigma
		pi(tc,n) = 1.d0-cum_normal(low)

		DO tcc = 2, n-1

			low = (y(tcc-1)+y(tcc))/2.0
			upp = (y(tcc+1)+y(tcc))/2.0
			low = (low-mu)/sigma
			upp = (upp-mu)/sigma
			pi(tc,tcc) = cum_normal(upp)-cum_normal(low)

		END DO
	END DO

	! Compute the CDF of the transition matrix.
	picum(:,1)=pi(:,1)
	DO tc = 2,n
		picum(:,tc)=picum(:,tc-1)+pi(:,tc)
	ENDDO


END SUBROUTINE sub_tauchen

FUNCTION cum_normal(X)
  ! Returns the value of the cumulative density of the Standard Normal
  ! Distribution at point X

  IMPLICIT NONE
  REAL(8), INTENT(in)  :: X
  REAL(8) 		:: cum_normal

  cum_normal =  0.5d0*( 1+erf(x/SQRT(2.d0)) )

END FUNCTION cum_normal
