MODULE share

! PARAMETERS
! --------------
    REAL(8), PARAMETER :: psi=1.5d0
    REAL(8), PARAMETER :: r=1.04d0
    REAL(8), PARAMETER :: rk=1.d0 + 0.05783d0 - r
    REAL(8), PARAMETER :: zeta= 0.6d0
    INTEGER, PARAMETER :: pen_yr=5
    REAL(8) :: u_ret
    INTEGER, PARAMETER :: twork = 40
    INTEGER, PARAMETER :: trest = 20

    REAL(8) :: tau, eta
    REAL(8), PARAMETER :: g_scale=0.5664
    INTEGER, PARAMETER :: gnorm = 2
    REAL(8) :: sigma_ar, sigma_ar_m
    REAL(8), PARAMETER :: rho_rk =0.4996d0
    REAL(8), PARAMETER :: sigma_rk =0.2968d0
    REAL(8), PARAMETER :: m_rk = LOG( rk )

    REAL(8), PARAMETER :: ily_stdage1 = .5817765d0
    REAL(8), PARAMETER :: ily_age1 = -0.5d0 * ily_stdage1**2
    REAL(8), PARAMETER :: ik_age1 = 0.08563d0
     REAL(8), PARAMETER :: ik_stdage1 = 1.035768d0
    REAL(8), PARAMETER :: ild_age1 = -1.388311d0
    REAL(8), PARAMETER :: ild_stdage1 = 1.0390140d0


    ! Wealth parameters
    REAL(8), PARAMETER :: sigma_q_h = 0.0308d0
    REAL(8), PARAMETER :: sigma_q_s = 0.1327d0
    REAL(8), PARAMETER :: cov_q_hs = -0.00018d0
    REAL(8) :: m_ma, m_id, m_ag, m_ar, m_ma_m, m_id_m, m_ag_m, m_ar_m

! Calibrated parameters
    REAL(8),PARAMETER :: sigma_ma=0.2460d0
    REAL(8),PARAMETER :: sigma_id=0.14011d0
    REAL(8),PARAMETER :: sigma_pve = 0.007679477678818
    REAL(8), PARAMETER ::  corr_pve_v = 0.440066534088353
    REAL(8) :: sigma_ma_lc, beta_pve, sigma_pve_res

    REAL(8), PARAMETER :: p_adj_0 = .1963799d0
    REAL(8),PARAMETER :: theta=0.827011924106338d0
    REAL(8),PARAMETER :: kappa=1.14540840305835d0
    REAL(8),PARAMETER :: xi = 0.723984681380191d0
    REAL(8),PARAMETER :: F=0.130156404337943d0
    REAL(8),PARAMETER :: gamma=0.183330606370360d0
    REAL(8),PARAMETER :: sigma_ag=0.0198759135023188d0
    REAL(8), PARAMETER :: gnodes_sc=1.d0
    REAL(8), PARAMETER :: beta=0.944115680568841d0
    REAL(8),PARAMETER :: delta_2=0.145860272229820d0
    REAL(8),PARAMETER :: delta_1=1.42186803203426*delta_2

    REAL(8),PARAMETER :: p_delta_1=1.d0
    REAL(8),PARAMETER :: p_delta_2=0.85d0

! Cash for Clunkers
! --------------
    REAL(8), PARAMETER :: clunk_disc = 0.973d0
    REAL(8), PARAMETER :: clunk_thr = 1.054d0
    REAL(8), PARAMETER :: clunk_inc = 1000.d0
    REAL(8), PARAMETER :: clunk_dis = 0.275d0

    REAL(8), PARAMETER :: p_clunk1 = 0.1d0
    REAL(8), PARAMETER :: p_clunk2 = 1.0d0

! Solve Monthly
! --------------
    INTEGER, PARAMETER :: mnth = 6
    REAL(8), PARAMETER :: r_m=r** (1.d0/DBLE(mnth))
    REAL(8), PARAMETER :: beta_m= beta** (1.d0/DBLE(mnth))
    REAL(8), PARAMETER :: rk_m= (r+rk) ** (1.d0/DBLE(mnth)) - r_m
    REAL(8), PARAMETER :: rho_rk_m = 0.8182d0
    REAL(8), PARAMETER :: sigma_rk_m =  0.23362d0
    REAL(8), PARAMETER :: sigma_q_h_m = ((sigma_q_h**2) / DBLE(mnth) )**(0.5d0)
    REAL(8), PARAMETER :: sigma_q_s_m = ((sigma_q_s**2) / DBLE(mnth) )**(0.5d0)
    REAL(8), PARAMETER :: cov_q_hs_m = cov_q_hs / DBLE(mnth)

    REAL(8),PARAMETER :: delta_2_m=1.d0-(1.d0-delta_2)**(1.d0/DBLE(mnth))
    REAL(8),PARAMETER :: delta_1_m=1.d0-(1.d0-delta_1)**(1.d0/DBLE(mnth))
    REAL(8),PARAMETER :: p_delta_1_m=1.d0
    REAL(8),PARAMETER :: p_delta_2_m=p_delta_2**(1.d0/DBLE(mnth))
    REAL(8),PARAMETER :: gamma_m=1.d0 - (1.d0- (1.d0-delta_2*(1.d0-gamma))**(1.d0/DBLE(mnth))) / delta_2_m
    REAL(8),PARAMETER :: sigma_ma_m= sigma_ma
    REAL(8),PARAMETER :: sigma_id_m=((sigma_id**2) / DBLE(mnth) )**(0.5d0)
    REAL(8),PARAMETER :: sigma_ag_m=((sigma_ag**2) / DBLE(mnth) )**(0.5d0)

    REAL(8), PARAMETER :: xi_m = xi
    REAL(8), PARAMETER :: c_d = theta/(1.d0-theta) * (1.d0-beta*(1.d0-delta_2))
    REAL(8), PARAMETER :: theta_m = theta

    ! Initial monthly wage draw
    REAL(8), PARAMETER :: ilp_age1_m = -1.9923d0
    REAL(8), PARAMETER :: ilp_stdage1_m = 0.62946d0
    REAL(8), PARAMETER :: mu_ma_age1_m = -3.427d0
    REAL(8), PARAMETER :: sigma_ma_age1_m = 1.1887d0
    REAL(8), PARAMETER :: cov_pma_age1_m = -1.2532d0

    REAL(8), PARAMETER :: scale_y = 1.d0 /DBLE(mnth)

    REAL(8), PARAMETER :: clunk_disc_m = 0.964d0
    REAL(8), PARAMETER :: clunk_thr_m = 6.293d0
    REAL(8), PARAMETER :: clunk_inc_m = clunk_inc * scale_y
    REAL(8), PARAMETER :: clunk_dis_m = 0.127d0

    REAL(8),PARAMETER :: p_clunk1_m = 0.5d0
    REAL(8),PARAMETER :: p_clunk2_m = p_clunk2


! GRIDS
! --------------
    REAL(8), parameter :: amin=0    !minimum asset value
    REAL(8), parameter :: amax=15.d0   !max asset
    REAL(8), parameter :: Dmin=0    !minimum durable choice
    REAL(8), parameter :: Dmax=2.d0  !maximum durable choice
    REAL(8), parameter :: amax_m=amax/scale_y   !max asset
    REAL(8), parameter :: Dmax_m=Dmax/scale_y   !maximum durable choice
    REAL(8), PARAMETER :: cover_e = 3.d0
    REAL(8), PARAMETER :: cover_u = 3.d0
    REAL(8), PARAMETER :: cover_w = 3.d0
    REAL(8), PARAMETER :: cover_rk = 2.75d0
    REAL(8), parameter :: cmin = 1.d-7
    REAL(8), parameter :: vmin = -1.d7
    REAL(8) :: emin, emax, umin, umax, wmin, wmax, rkmin, rkmax    ! labour income process parameters
    REAL(8) :: rkmin_m, rkmax_m
    REAL(8) :: zmin, zmax, xmin, xmax
    REAL(8) :: zmin_m, zmax_m, xmin_m, xmax_m
    INTEGER, PARAMETER :: ng = trest+twork
    INTEGER, PARAMETER :: ng_m = mnth * ng    ! Monthly periods.
    integer, parameter :: ne = 5 ! size of idiosyncratic labor shock grid (perm)
    integer, parameter :: nu = 4  ! size of idiosyncratic labor shock grid (transitory)
    integer, parameter :: nw = 4  ! size of price shocks grid
    integer, parameter :: nrk = 4 ! size or rate grid
    integer, parameter :: ngp = 2 ! size of growth rate grid
    INTEGER, PARAMETER :: ndp = 2  ! size of depreciation grid
    INTEGER, PARAMETER :: nc = 2  ! size of cash for clunkers grid
    integer, parameter :: na = 200 ! size of asset grid
    integer, parameter :: nD = 150 ! size of durable grid

    integer, parameter :: nz = 250 ! size of resource grid (adjust)
    integer, parameter :: nx = 250 ! size of resource grid (adjust)

    REAL(8), DIMENSION(ne) :: enodes, enodes_m  !Nodes for idiosyncratic productivity (perm)
    REAL(8), DIMENSION(nu) :: unodes, unodes_m  !Nodes for idiosyncratic productivity (transitory)
    REAL(8), DIMENSION(nc) :: clunk, clunk_m
    REAL(8), DIMENSION(ng) :: m_q_h, m_q, sigma_q, h_shr, s_shr
    REAL(8), DIMENSION(ng_m) :: m_q_m, sigma_q_m, h_shr_m, s_shr_m
    REAL(8), DIMENSION(ndp) :: delta, delta_m  !Nodes for depreciation
    REAL(8), DIMENSION(nw,ng) :: wnodes
    REAL(8), DIMENSION(nw,ng_m) ::  wnodes_m  !Nodes for asset price shocks
    REAL(8), DIMENSION(nrk) :: rknodes, rknodes_m  !Nodes for rate spread
    REAL(8), DIMENSION(ng,ngp) :: gnodes
    REAL(8), DIMENSION(ng) :: betanodes, eqvnodes  !Nodes for lifecycle profile

    REAL(8), DIMENSION(ng_m) :: betanodes_m, eqvnodes_m
    REAL(8), DIMENSION(ng_m,ngp) :: gnodes_m
    REAL(8), DIMENSION(na) :: anodes, anodes_m  !Nodes for idiosyncratic assets
    REAL(8), DIMENSION(nD) :: Dnodes, Dnodes_m  !Nodes for idiosyncratic durables
    REAL(8), DIMENSION(nz) :: znodes, znodes_m
    REAL(8), DIMENSION(nx) :: xnodes, xnodes_m
    REAL(8), DIMENSION(ne,ne) :: Probe, Probecum, Probe_m, Probecum_m !Transition probabilities for idiosyncratic productivity (perm)
    REAL(8), DIMENSION(nu,nu) :: Probu, Probucum, Probu_m, Probucum_m !Transition probabilities for idiosyncratic productivity (transitory)
    REAL(8), DIMENSION(nw,nw,ng) :: Probw, Probwcum !Transition probabilities for price shocks
    REAL(8), DIMENSION(nw,nw,ng_m) :: Probw_m, Probwcum_m
    REAL(8), DIMENSION(nrk,nrk) :: Probrk, Probrkcum, Probrk_m, Probrkcum_m
    REAL(8), DIMENSION(ngp,ngp) :: Probg, Probg_m
    REAL(8), DIMENSION(ndp,ndp) :: Probdp, Probdpcum, Probdp_m, Probdpcum_m   !Transition probabilities for depreciation rate
    REAL(8), DIMENSION(nc,nc) :: Probc, Probccum, Probc_m

! SIMULATION
! --------------
    INTEGER, PARAMETER :: numsim=4000  !Length of simulation
    INTEGER, PARAMETER :: simlives = numsim / ng + 2
    INTEGER, PARAMETER :: agent_age = 2000       ! Number of agents of each age
    INTEGER, PARAMETER :: agents= ng*agent_age
    INTEGER, PARAMETER :: burnin=ng+1    !Initial periods dropped in simulation
    REAL(8), PARAMETER :: p_adj_0_tune = 1.5d0

! SHOCKS
! --------------
    ! Which shocks to include
    INTEGER, PARAMETER :: rep = 50
    INTEGER, PARAMETER :: rep_out = 1
    INTEGER, PARAMETER :: shck_c = 6
    INTEGER, PARAMETER :: numshock=2*ng
    INTEGER, PARAMETER :: shocklives = numshock / ng + 2
    INTEGER, PARAMETER :: yr1_shock = 1946
    INTEGER, PARAMETER :: yr_end_shock = 2018
    INTEGER, PARAMETER :: shockseries1_n = 89
    REAL(8), DIMENSION(shockseries1_n) :: shockseries1
    INTEGER, PARAMETER :: shockseries2_h_n = 43
    REAL(8), DIMENSION(shockseries2_h_n) :: shockseries2_h
    INTEGER, PARAMETER :: shockseries2_s_n = 58
    REAL(8), DIMENSION(shockseries2_s_n) :: shockseries2_s
    INTEGER, PARAMETER :: shockseries3_n = 46
    REAL(8), DIMENSION(shockseries3_n) :: shockseries3

    INTEGER, PARAMETER :: shockseries1_start = yr_end_shock+1-yr1_shock
    INTEGER, PARAMETER :: shck_c_period = yr_end_shock+1-2007
    INTEGER, PARAMETER :: g_shck_period = yr_end_shock+1-2009
    INTEGER, PARAMETER :: clunk_period = yr_end_shock+1-2009

    REAL(8), DIMENSION(g_shck_period,twork) :: g_shck_ageprofile

    INTEGER, PARAMETER :: shck_c_m = 2
    INTEGER, PARAMETER :: ex_m = shck_c_m*2
    INTEGER, PARAMETER :: m_years = 7
    INTEGER, PARAMETER :: yr_pr = 4
    INTEGER, PARAMETER :: numshock_m = m_years*mnth
    INTEGER, PARAMETER :: clunk_ex_bg = numshock-clunk_period-yr_pr
    INTEGER, PARAMETER :: clunk_mnth = 4
    INTEGER, PARAMETER :: clunk_period_m = yr_pr*mnth + MIN(clunk_mnth,mnth)
    INTEGER, PARAMETER :: clunk_dur_m = MIN(1,mnth-MIN(clunk_mnth,mnth)+1)
    INTEGER, PARAMETER :: clunk_estwin_m = 5

! Cohort shocks
! ---
    INTEGER, PARAMETER :: coh_size = 10
    INTEGER, PARAMETER :: shockseriescoh_n = 56
    REAL(8), DIMENSION(shockseriescoh_n,twork) :: shockseriescoh, unempseriescoh
    REAL(8), DIMENSION(shockseriescoh_n) :: shockseriescoh_agg, unempseriescoh_agg
    INTEGER, PARAMETER :: coh_fe_n = 56
    REAL(8), DIMENSION(coh_fe_n) :: coh_fe
    INTEGER, PARAMETER :: shockseriesmat_n = yr_end_shock-1980+1



END MODULE share
