  SUBROUTINE sub_shocks_b(age_t,init_y_shock, init_x_shock, init_d_shock, &
	init_d_nadj_shock,init_delta_shock,init_clunk_shock, &
	alive_t_shock,n_shck_shock,u_shck_shock,p_t_shock,q_t_shock,rk_t_shock,&
	v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock,dp_shck_shock,rk_shck_shock)

  ! Generates sequence of idiosyncratic and aggregate shocks

  USE share
  USE OMP_LIB
  USE par_zig_mod

  IMPLICIT NONE

! SHOCKS
! -------------
  INTEGER, DIMENSION(numsim,agents), INTENT(OUT) :: age_t

  REAL(8), DIMENSION(shocklives,agents,rep), INTENT(OUT) :: &
	 init_y_shock, init_x_shock, init_d_shock
  INTEGER, DIMENSION(shocklives,agents,rep) :: init_d_nadj_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(OUT) :: init_delta_shock
  INTEGER, DIMENSION(agents,rep), INTENT(OUT) :: init_clunk_shock
  INTEGER, DIMENSION(numshock,agents,rep), INTENT(OUT) :: alive_t_shock
  REAL(8), DIMENSION(numshock,agents,rep), INTENT(OUT) :: n_shck_shock, &
	  u_shck_shock,dp_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(OUT) :: p_t_shock
  REAL(8), DIMENSION(numshock,twork,rep,shck_c), INTENT(OUT) :: v_shck_shock, m_shck_shock
  REAL(8), DIMENSION(numshock,ng,rep,shck_c), INTENT(OUT) :: q_t_shock, w_shck_shock
  REAL(8), DIMENSION(numshock,rep,shck_c), INTENT(OUT) :: rk_t_shock
  INTEGER, DIMENSION(numshock,shck_c), INTENT(OUT) :: g_shck_shock
  REAL(8), DIMENSION(numshock,rep,shck_c), INTENT(OUT) :: rk_shck_shock

  REAL(8), DIMENSION(numshock) :: v_shck_shock_store

  REAL(8) :: rand_shock, wts_temp, uts_temp, wage_adj, init_y_shock_temp
  REAL(8), DIMENSION(agents) :: rand_shock_vec, rand_shock_vec2
  INTEGER :: j, time, i, k, wts_count, age_temp, age_counter
  INTEGER :: v_shck_counter, v_shck_coh_counter, w_h_shck_counter, w_s_shck_counter, &
	g_shck_counter, rk_shck_counter, coh_fe_counter

  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8), DIMENSION(numshock,rep,shck_c) :: agg_wts

  INTEGER  :: reset, npar, numthreads
  INTEGER, DIMENSION(agents)  :: kpar
  INTEGER, DIMENSION(:), ALLOCATABLE :: seed
  INTEGER :: grainsize = 32

  !$OMP PARALLEL
  !$OMP DO
  DO i=1, agents
  age_t(:,i) = 0
  init_y_shock(:,i,:) = 0.d0
  init_x_shock(:,i,:) = 0.d0
  init_d_shock(:,i,:) = 0.d0
  init_d_nadj_shock(:,i,:) = 0
  init_delta_shock(:,i,:) = 0
  init_clunk_shock(i,:) = 0
  alive_t_shock(:,i,:) = 0
  n_shck_shock(:,i,:) = 0.d0
  u_shck_shock(:,i,:) = 0.d0
  p_t_shock(:,i,:,:) = 0.d0
  dp_shck_shock(:,i,:) = 0.d0
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  rk_t_shock = 0.d0
  v_shck_shock = 0.d0
  m_shck_shock = 0.d0
  v_shck_shock_store = 0.d0
  w_shck_shock = 0.d0
  q_t_shock = 0.d0
  rk_shck_shock = 0.d0

  !$OMP PARALLEL
  numthreads = OMP_get_num_threads()
  !$OMP END PARALLEL
  npar=numthreads+1

  ALLOCATE( seed(npar) )
  DO i = 1,npar
        seed(i) = 12345678 * i
  END DO

  reset=1
  CALL par_zigset(npar, seed, grainsize,reset)
  reset=0
  CALL par_zigset(npar, seed, grainsize,reset)

  age_temp = 1
  age_counter = 1
  DO i=1, agents
    IF (age_counter>agent_age) THEN
    age_temp = age_temp +1
    age_counter = 1
    END IF
  age_t(1,i) = age_temp
  age_counter = age_counter+1
  END DO

  !$OMP PARALLEL
  !$OMP DO
  DO i=1, agents
    DO time =1,numsim
      IF (time<numsim) THEN
        IF (age_t(time,i)<ng) THEN
        age_t(time+1,i) = age_t(time,i) + 1
        ELSE
        age_t(time+1,i) = 1
        END IF
      END IF
    END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL


  DO time =1,shocklives
  !$OMP PARALLEL
  !$OMP DO
       DO i=1, agents
       kpar(i) = omp_get_thread_num()+1
        DO j = 1, rep

	  rand_shock_vec(i)=par_rnor(kpar(i))
	  init_y_shock(time,i,j) = EXP( ily_age1 + ily_stdage1 * rand_shock_vec(i) )

	  rand_shock_vec(i)=par_rnor(kpar(i))
	  init_d_shock(time,i,j) = EXP( ild_age1 + ild_stdage1 * rand_shock_vec(i) )
	  rand_shock_vec(i)=par_uni(kpar(i))
          IF ( rand_shock_vec(i)> p_adj_0*p_adj_0_tune ) THEN
	  init_d_nadj_shock(time,i,j) = 1
          END IF

          rand_shock_vec(i)=par_rnor(kpar(i))
	  init_x_shock(time,i,j) = MAX( ik_age1 + ik_stdage1 * rand_shock_vec(i), -eta*init_d_shock(time,i,j) )
          IF (init_x_shock(time,i,j) >0.d0) THEN
          init_x_shock(time,i,j) = init_x_shock(time,i,j)*r
          ELSE
          init_x_shock(time,i,j) = init_x_shock(time,i,j)*(r + rk)
          END IF
          IF (time==1) THEN

            rand_shock_vec(i)=par_uni(kpar(i))
            IF (rand_shock_vec(i) <= clunk_dis) THEN
            init_clunk_shock(i,j) = 1
            ELSE
            init_clunk_shock(i,j) = 2
            END IF
          END IF

          rand_shock_vec(i)=par_uni(kpar(i))
          IF (rand_shock_vec(i) <= Probdpcum(1,1) ) THEN
          init_delta_shock(time,i,j) = 1
          ELSE
          init_delta_shock(time,i,j) = 2
          END IF
        END DO
       END DO
  !$OMP END DO
  !$OMP END PARALLEL
  END DO

  !$OMP PARALLEL
  !$OMP DO
  DO i=1,agents
  kpar(i) = omp_get_thread_num()+1
  DO j=1,rep
  rand_shock_vec(i)=par_rnor(kpar(i))
  u_shck_shock(1,i,j) = EXP( m_ma + sigma_ma * rand_shock_vec(i) )
  p_t_shock(1,i,j,:) = init_y_shock(1,i,j)/u_shck_shock(1,i,j)

  END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  q_t_shock = 1.d0
  alive_t_shock(1,:,:) = 1
  rk_t_shock = LOG(rk)
  m_shck_shock = 1.d0

  !$OMP PARALLEL DO PRIVATE(v_shck_counter,v_shck_coh_counter, &
  !$OMP w_s_shck_counter,w_h_shck_counter,g_shck_counter,rk_shck_counter)
  DO j=1,rep
  kpar(j) = omp_get_thread_num()+1
  v_shck_counter = max(shockseries1_n - shockseries1_start,0)
  v_shck_coh_counter = max(shockseriescoh_n - shockseries1_start,1)
  w_s_shck_counter = 0
  w_h_shck_counter = 0
  g_shck_counter = 0
  rk_shck_counter = 0
   DO time =1,numshock

    IF (time<numshock-shockseries1_start .OR. time==numshock) THEN
    rand_shock_vec(j)=par_rnor(kpar(j))
    rand_shock_vec2(j)=par_rnor(kpar(j))
    DO k=1,shck_c
     DO i=1,twork
     v_shck_shock(time,i,j,k) = EXP( m_ag + sigma_ag * rand_shock_vec(j) )
     m_shck_shock(time,i,j,k) = v_shck_shock(time,i,j,k)**(beta_pve) * &
	EXP( rand_shock_vec2(j)*sigma_pve_res )
     END DO
    END DO
    ELSEIF (time<numshock-shockseriescoh_n+1) THEN
    v_shck_counter = v_shck_counter+1
      DO i = 1,twork
      v_shck_shock(time,i,j,:) = EXP( shockseries1(v_shck_counter) )
      m_shck_shock(time,i,j,:) = 1.d0
      END DO
    IF (j==1) v_shck_shock_store(time) = EXP( shockseries1(v_shck_counter) )

    ELSE
    v_shck_counter = v_shck_counter+1
    v_shck_coh_counter = v_shck_coh_counter+1
      IF (time<numshock-shck_c_period) THEN
      DO k=1,shck_c
       DO i=1,twork
         v_shck_shock(time,i,j,k) = EXP( shockseriescoh(v_shck_coh_counter,i) )
         m_shck_shock(time,i,j,k) = EXP( unempseriescoh(v_shck_coh_counter,i) )
       END DO
      END DO
      ELSE
      IF (time<numshock-g_shck_period) THEN
        DO i=1,twork
         v_shck_shock(time,i,j,1:2) = EXP( shockseriescoh(v_shck_coh_counter,i) )
         m_shck_shock(time,i,j,1:2) = EXP( unempseriescoh(v_shck_coh_counter,i) )
         v_shck_shock(time,i,j,3:5) = 1.d0
	       m_shck_shock(time,i,j,3:5) = 1.d0
        END DO
      ELSE
      g_shck_counter = g_shck_counter + 1
      DO i=1,twork
         v_shck_shock(time,i,j,1) = g_shck_ageprofile( g_shck_counter, i )
         v_shck_shock(time,i,j,2) = EXP( shockseriescoh(v_shck_coh_counter,i) )
         m_shck_shock(time,i,j,1:2) = EXP( unempseriescoh(v_shck_coh_counter,i) )
         v_shck_shock(time,i,j,3:5) = 1.d0
         m_shck_shock(time,i,j,3:5) = 1.d0
      END DO
      END IF
         DO i=1,twork
         v_shck_shock(time,i,j,6) = v_shck_shock(time,i,j,1)
         m_shck_shock(time,i,j,6) = m_shck_shock(time,i,j,1)
         END DO
      END IF
    END IF

    IF (time<numshock-shockseries2_s_n .OR. time==numshock) THEN
    rand_shock_vec(j)=par_rnor(kpar(j))
       DO i=1,ng
       w_shck_shock(time,i,j,:) = EXP( m_q(i) + sigma_q(i) * rand_shock_vec(j) )
       END DO
    ELSE
      IF (time<numshock-shockseries2_h_n) THEN
      w_s_shck_counter = w_s_shck_counter+1
      rand_shock_vec(j)=par_rnor(kpar(j))
          DO i=1,ng
          w_shck_shock(time,i,j,:) = EXP( m_q_h(i) + &
        		sigma_q_h * h_shr(i) * rand_shock_vec(j) + &
        		s_shr(i) * shockseries2_s(w_s_shck_counter)   )
          END DO
      ELSE
      w_s_shck_counter = w_s_shck_counter+1
      w_h_shck_counter = w_h_shck_counter+1
        IF (time<numshock-shck_c_period) THEN
          DO i=1,ng
          w_shck_shock(time,i,j,:) = EXP( h_shr(i) * shockseries2_h(w_h_shck_counter) + &
		          s_shr(i) * shockseries2_s(w_s_shck_counter) )
          END DO
        ELSE

          DO i=1,ng
          w_shck_shock(time,i,j,1) = EXP( h_shr(i) * shockseries2_h(w_h_shck_counter) + &
		           s_shr(i) * shockseries2_s(w_s_shck_counter) )
          w_shck_shock(time,i,j,3) = w_shck_shock(time,i,j,1)
	             w_shck_shock(time,i,j,6) = w_shck_shock(time,i,j,1)
          END DO
          DO i=1,ng
          w_shck_shock(time,i,j,2) = 1.d0
          w_shck_shock(time,i,j,4) = 1.d0
          w_shck_shock(time,i,j,5) = 1.d0
          END DO
        END IF
      END IF
    END IF

    IF(time>1) THEN
      DO k = 1, shck_c
        DO i = 2,ng
	q_t_shock(time,i,j,k) = q_t_shock(time-1,i-1,j,k)*w_shck_shock(time,i,j,k)
        END DO
        q_t_shock(time,1,j,k) =  SUM( q_t_shock(time,2:,j,k) )/DBLE(ng-1)
      END DO
    END IF

    IF (time>1) THEN
      IF (time<numshock-shockseries3_n .OR. time==numshock) THEN
      rand_shock_vec(j)=par_rnor(kpar(j))
      rk_shck_shock(time,j,:) = sigma_rk * rand_shock_vec(j)
      rk_t_shock(time,j,:) = LOG(rk)*(1.d0-rho_rk) + &
		rho_rk * rk_t_shock(time-1,j,:) + rk_shck_shock(time,j,:)
      ELSE
      rk_shck_counter = rk_shck_counter + 1
      rk_shck_shock(time,j,1) = shockseries3(rk_shck_counter)
      rk_shck_shock(time,j,5) = shockseries3(rk_shck_counter)
      rk_shck_shock(time,j,6) = shockseries3(rk_shck_counter)
      rk_t_shock(time,j,1) = LOG(rk)*(1.d0-rho_rk) + &
		rho_rk * rk_t_shock(time-1,j,1) + rk_shck_shock(time,j,1)
      rk_t_shock(time,j,5) = LOG(rk)*(1.d0-rho_rk) + &
		rho_rk * rk_t_shock(time-1,j,5) + rk_shck_shock(time,j,5)
      rk_t_shock(time,j,6) = LOG(rk)*(1.d0-rho_rk) + &
		rho_rk * rk_t_shock(time-1,j,6) + rk_shck_shock(time,j,6)
        IF (time<numshock-shck_c_period) THEN
        rk_shck_shock(time,j,2:4) = shockseries3(rk_shck_counter)
        rk_t_shock(time,j,2:4) = LOG(rk)*(1.d0-rho_rk) + &
		rho_rk * rk_t_shock(time-1,j,2:4) + rk_shck_shock(time,j,2:4)
        ELSE
        rk_shck_shock(time,j,2:4) = 0.d0
        rk_t_shock(time,j,2:4) = LOG(rk)*(1.d0-rho_rk) + &
		rho_rk * rk_t_shock(time-1,j,2:4) + rk_shck_shock(time,j,2:4)
        END IF
      END IF
    END IF

   END DO
  END DO
  !OMP END PARALLEL DO

  rk_t_shock = EXP(rk_t_shock)

  g_shck_shock = gnorm
  g_shck_shock(numshock-g_shck_period:,1) = 1
  g_shck_shock(numshock-g_shck_period:,4) = 1
  g_shck_shock(numshock-g_shck_period:,6) = 1

    DO j=1, rep
      coh_fe_counter = 0
      DO time=1,numshock

        IF (time>=numshock-shockseries1_start) THEN
          DO k = 1, shck_c

          wts_temp = 0.d0
		  !$OMP PARALLEL REDUCTION(+:wts_temp)
		  !$OMP DO
		  DO i=1, agents
		    IF ( (age_t(time-1,i)<=twork) .AND. (alive_t_shock(time-1,i,j)==1) ) THEN
		    wts_temp = wts_temp + p_t_shock(time-1,i,j,k) * u_shck_shock(time-1,i,j)
		    END IF
		  END DO
		  !$OMP END DO
		  !$OMP END PARALLEL
          agg_wts(time-1,j,k) = wts_temp
          END DO

           IF (time>numshock-shck_c_period) THEN
	      wage_adj = agg_wts(time-2,j,3)
	      wts_temp = wage_adj / agg_wts(time-1,j,3)
             DO k = 3, shck_c-1
	       !$OMP PARALLEL DO
	       DO i=1, agents
	        IF ( (age_t(time-1,i)<=twork) .AND. (alive_t_shock(time-1,i,j)==1) ) THEN
                 p_t_shock(time-1,i,j,k) = p_t_shock(time-1,i,j,k) * wts_temp
	        END IF
         END DO
	       !$OMP END PARALLEL DO

                 DO i=1,twork
                 v_shck_shock(time-1,i,j,k) = v_shck_shock(time-1,i,j,k) * wts_temp
                 END DO
              agg_wts(time-1,j,k) = agg_wts(time-1,j,k) * wts_temp
             END DO
           END IF

        END IF

        IF (time .GE. numshock-coh_fe_n) THEN
        coh_fe_counter = coh_fe_counter+1
        END IF
  !$OMP PARALLEL PRIVATE(init_y_shock_temp)
  !$OMP DO
  DO i=1, agents
  kpar(i) = omp_get_thread_num()+1
	IF (time==1) THEN
        init_loc(i) = 2
        END IF
	rand_shock_vec(i)=par_rnor(kpar(i))
	n_shck_shock(time,i,j) = EXP( m_id + sigma_id * rand_shock_vec(i) )
	IF (time>1) THEN
	rand_shock_vec(i)=par_rnor(kpar(i))
	u_shck_shock(time,i,j) = EXP( m_ma + sigma_ma * rand_shock_vec(i) )
          IF (age_t(time,i)==1) THEN
		  DO k=1,shck_c
 		     IF ( (time .GE. numshock-coh_fe_n) .AND. (time .LT. numshock) ) THEN
                         IF ( (time<numshock-shck_c_period) .OR. (k==1 .OR. k==2 .OR. k==6) ) THEN
                         init_y_shock_temp = init_y_shock(init_loc(i),i,j)* EXP( coh_fe(coh_fe_counter) )
                         ELSE
             	         init_y_shock_temp = init_y_shock(init_loc(i),i,j)*v_shck_shock(time,age_t(time,i),j,k)
                         END IF
                     ELSE
             	     init_y_shock_temp =  init_y_shock(init_loc(i),i,j)*v_shck_shock(time,age_t(time,i),j,k)
                     END IF
		  p_t_shock(time,i,j,k) = init_y_shock_temp/u_shck_shock(time,i,j)
                  END DO
                  init_loc(i) = init_loc(i) + 1
	  ELSE
		  DO k=1,shck_c
		    IF (age_t(time,i)<=twork) THEN
		    p_t_shock(time,i,j,k) = gnodes(age_t(time,i),g_shck_shock(time,k))*p_t_shock(time-1,i,j,k) &
				*n_shck_shock(time,i,j)*v_shck_shock(time,age_t(time,i),j,k)
                    ELSE
   		    p_t_shock(time,i,j,k) = gnodes(age_t(time,i),g_shck_shock(time,k))*p_t_shock(time-1,i,j,k)
		  END IF
                END DO
	  END IF
	END IF
	IF (time<numshock) THEN
	  IF (age_t(time,i)<ng) THEN
	    IF (alive_t_shock(time,i,j)== 1) THEN
            rand_shock_vec(i)=par_uni(kpar(i))
	    	IF( rand_shock_vec(i)<betanodes(age_t(time,i)) ) THEN
	 	alive_t_shock(time+1,i,j) = 1
		ELSE
		alive_t_shock(time+1,i,j) = 0
		END IF
	    END IF
	  ELSE
	 	alive_t_shock(time+1,i,j) = 1
	  END IF
	END IF
        dp_shck_shock(time,i,j)=par_uni(kpar(i))
  END DO
  !$OMP END DO
  !$OMP END PARALLEL
       END DO
    END DO

  END SUBROUTINE sub_shocks_b
