  SUBROUTINE sub_shocks_mnth_b(age_t,alive_t_shock,n_shck_shock,u_shck_shock, &
	p_t_shock,q_t_shock,rk_t_shock,v_shck_shock,m_shck_shock,&
	w_shck_shock,g_shck_shock,rk_shck_shock, &
	init_p_shock_m, init_u_shock_m, age_t_m, &
	alive_t_shock_m,n_shck_shock_m,u_shck_shock_m, &
	p_t_shock_m,q_t_shock_m,rk_t_shock_m,v_shck_shock_m,m_shck_shock_m, &
	w_shck_shock_m,g_shck_shock_m,dp_shck_shock_m)

  ! Generates sequence of idiosyncratic and aggregate shocks for monthly model

  USE share
  USE OMP_LIB
  USE par_zig_mod

  IMPLICIT NONE

! ANNUAL SHOCKS IN
! --------------
  INTEGER, DIMENSION(numsim,agents), INTENT(IN) :: age_t
  INTEGER, DIMENSION(numshock,agents,rep), INTENT(IN) :: alive_t_shock
  REAL(8), DIMENSION(numshock,agents,rep), INTENT(IN) :: n_shck_shock, &
	  u_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(IN) :: p_t_shock
  REAL(8), DIMENSION(numshock,twork,rep,shck_c), INTENT(IN) :: v_shck_shock, m_shck_shock
  REAL(8), DIMENSION(numshock,ng,rep,shck_c), INTENT(IN) :: q_t_shock, w_shck_shock
  REAL(8), DIMENSION(numshock,rep,shck_c), INTENT(IN) :: rk_t_shock
  INTEGER, DIMENSION(numshock,shck_c), INTENT(IN) :: g_shck_shock
  REAL(8), DIMENSION(numshock,rep,shck_c), INTENT(IN) :: rk_shck_shock
  REAL(8), DIMENSION(agents,rep), INTENT(IN) ::  init_p_shock_m, init_u_shock_m

  INTEGER, DIMENSION(numshock_m,agents), INTENT(OUT) :: age_t_m

  INTEGER, DIMENSION(numshock_m,agents,rep), INTENT(OUT) :: alive_t_shock_m
  REAL(8), DIMENSION(numshock_m,agents,rep), INTENT(OUT) :: n_shck_shock_m, &
	  u_shck_shock_m, dp_shck_shock_m
  REAL(8), DIMENSION(numshock_m,agents,rep,shck_c_m), INTENT(OUT) :: p_t_shock_m
  REAL(8), DIMENSION(numshock_m,twork*mnth,shck_c_m), INTENT(OUT) :: v_shck_shock_m, &
	m_shck_shock_m
  REAL(8), DIMENSION(numshock_m,ng_m,rep,shck_c_m), INTENT(OUT) :: q_t_shock_m, w_shck_shock_m
  REAL(8), DIMENSION(numshock_m,rep,shck_c_m), INTENT(OUT) :: rk_t_shock_m
  INTEGER, DIMENSION(numshock_m,agents,shck_c_m), INTENT(OUT) :: g_shck_shock_m

  REAL(8), DIMENSION(ng_m,agents) :: rk_shck_lc_m

  REAL(8) :: init_y_shock_temp
  REAL(8), DIMENSION(agents) :: rand_shock_vec
  INTEGER, DIMENSION(agents) :: rand_int_vec
  INTEGER :: time, month, time_m, i, j, k, l, m, o

  INTEGER  :: reset, npar, numthreads, coh_fe_counter
  INTEGER, DIMENSION(agents)  :: kpar
  INTEGER, DIMENSION(:), ALLOCATABLE :: seed
  INTEGER :: grainsize = 32

  !$OMP PARALLEL
  !$OMP DO
  DO i=1, agents
  age_t_m(:,i) = 0
  alive_t_shock_m(:,i,:) = 0
  n_shck_shock_m(:,i,:) = 0.d0
  u_shck_shock_m(:,i,:) = 0.d0
  dp_shck_shock_m(:,i,:) = 0.d0
  p_t_shock_m(:,i,:,:) = 0.d0
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  rk_t_shock_m = 0.d0
  v_shck_shock_m = 0.d0
  m_shck_shock_m = 0.d0
  w_shck_shock_m = 0.d0
  q_t_shock_m = 0.d0

  !$OMP PARALLEL
  numthreads = OMP_get_num_threads()
  !$OMP END PARALLEL
  npar=numthreads+1

  ALLOCATE( seed(npar) )
  DO i = 1,npar
        seed(i) = 12345678 * i
  END DO
  reset=1
  CALL par_zigset(npar, seed, grainsize,reset)
  reset=0
  CALL par_zigset(npar, seed, grainsize,reset)

  !$OMP PARALLEL
  !$OMP DO
  DO i=1,agents
  kpar(i) = omp_get_thread_num()+1
  rand_shock_vec(i)=par_uni(kpar(i))
  age_t_m(1,i) = (age_t(clunk_ex_bg,i)-1)*mnth + CEILING( rand_shock_vec(i)*mnth )
    DO j=1,rep
    alive_t_shock_m(1,i,j) =   alive_t_shock(clunk_ex_bg,i,j)
    p_t_shock_m(1,i,j,:) = p_t_shock(clunk_ex_bg,i,j,1) * scale_y
    END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  DO j=1,rep
   DO k=1,ng
    DO l=1,mnth
    m =(k-1)*mnth + l
    q_t_shock_m(1,m,j,:) = q_t_shock(clunk_ex_bg,k,j,1)
    END DO
   END DO
  rk_t_shock_m(1,j,:) = LOG( (1.d0+rk_t_shock(clunk_ex_bg,j,1) )**(1.d0/DBLE(mnth)) - 1.d0 )
  g_shck_shock_m(1,:,:) = g_shck_shock(clunk_ex_bg,1)
  END DO

  DO j=1,rep
   DO i=1,ng_m
   q_t_shock_m(:,i,j,1) = q_t_shock_m(1,i,j,1)
   w_shck_shock_m(:,i,j,1) = 1.d0
   END DO
   DO time=2,numshock_m
   rk_t_shock_m(time,j,1) = rk_t_shock_m(time-1,j,1)
   END DO
  END DO
  g_shck_shock_m(:,:,1) = g_shck_shock_m(1,1,1)
  DO j=1,twork*mnth
  v_shck_shock_m(:,j,1) = 1.d0
  m_shck_shock_m(:,j,1) = 1.d0
  END DO

  DO time=1,m_years
    o = (time-1)*mnth + 1
    DO j=1,rep
      DO k=1,ng
        DO l=1,mnth
        m =(k-1)*mnth + l
        q_t_shock_m(o,m,j,2) = q_t_shock(clunk_ex_bg+time-1,k,j,1)
        END DO
      END DO
    rk_t_shock_m(o,j,2) = LOG( (1.d0+rk_t_shock(clunk_ex_bg+time-1,j,1))**(1.d0/DBLE(mnth))-1.d0 )
      DO k=1,ng
        DO l=1,mnth
        m =(k-1)*mnth + l
        w_shck_shock_m(o+1:MIN(o+mnth,numshock_m),m,j,2) = &
		w_shck_shock(clunk_ex_bg+time,k,j,1)**(1.d0/DBLE(mnth))
        END DO
      END DO
      IF (mnth .GT. 1) THEN
        DO k=1,mnth-1
         DO i=2,ng_m
         q_t_shock_m(o+k,i,j,2) = q_t_shock_m(o+k-1,i-1,j,2)*w_shck_shock_m(o+k,i,j,2)
         END DO
         q_t_shock_m(o+k,1,j,2) = SUM( q_t_shock_m(o+k,2:,j,2) )/DBLE(ng_m-1)
         rk_t_shock_m(o+k,j,2) = rk_t_shock_m(o,j,2) + &
		DBLE(k)*( LOG( (1.d0+rk_t_shock(clunk_ex_bg+time,j,1))**(1.d0/DBLE(mnth))-1.d0 )-rk_t_shock_m(o,j,2) )/DBLE(mnth)
        END DO
      END IF
      DO k=1,twork
        DO l=1,mnth
        m =(k-1)*mnth + l
        v_shck_shock_m(o+1:MIN(o+mnth,numshock_m),m,2) = v_shck_shock(clunk_ex_bg+time,k,1,1)**(1.d0/DBLE(mnth))
        m_shck_shock_m(o+1:MIN(o+mnth,numshock_m),m,2) = m_shck_shock(clunk_ex_bg+time,k,1,1)
        END DO
      END DO
    END DO
     !$OMP PARALLEL
     !$OMP DO
     DO i=1,agents
     kpar(i) = omp_get_thread_num()+1
       IF ( g_shck_shock(clunk_ex_bg+time,1) .NE. g_shck_shock(clunk_ex_bg+time-1,1) ) THEN
       rand_shock_vec(i)=par_uni(kpar(i))
       rand_int_vec(i) = NINT( rand_shock_vec(i)*DBLE((mnth-1)) )
       g_shck_shock_m(o:o+rand_int_vec(i),i,2) = g_shck_shock(clunk_ex_bg+time-1,1)
       g_shck_shock_m(o+rand_int_vec(i)+1:MIN(o+mnth,numshock_m),i,2) = g_shck_shock(clunk_ex_bg+time,1)
       ELSE
       g_shck_shock_m(o+1:MIN(o+mnth,numshock_m),i,2) = g_shck_shock(clunk_ex_bg+time,1)
       END IF
     END DO
    !$OMP END DO
    !$OMP END PARALLEL

  END DO

  rk_t_shock_m = EXP( rk_t_shock_m )

    DO j=1, rep
    coh_fe_counter = coh_fe_n-clunk_period-yr_pr
      DO time=1, m_years
      coh_fe_counter = coh_fe_counter+1
       DO month =1,mnth
       time_m = (time-1)*mnth + month
  !$OMP PARALLEL PRIVATE(init_y_shock_temp)
  !$OMP DO
  DO i=1, agents
  kpar(i) = omp_get_thread_num()+1
	rand_shock_vec(i)=par_rnor(kpar(i))
	n_shck_shock_m(time_m,i,j) = EXP( m_id_m + sigma_id_m * rand_shock_vec(i) )
	rand_shock_vec(i)=par_rnor(kpar(i))
	u_shck_shock_m(time_m,i,j) = EXP( m_ma_m + sigma_ma_m * rand_shock_vec(i) )
	IF (time_m>1) THEN
          IF (age_t_m(time_m,i)==1) THEN
		  DO k=1,shck_c_m
                  if (k==1) THEN
                   p_t_shock_m(time_m,i,j,k)  = init_p_shock_m(i,j)
		  ELSE
                    p_t_shock_m(time_m,i,j,k) = init_p_shock_m(i,j)* EXP( coh_fe(coh_fe_counter) )
                  END IF
                  END DO
          u_shck_shock_m(time_m,i,j) = init_u_shock_m(i,j)
	  ELSE
		  DO k=1,shck_c_m
		    IF (age_t_m(time_m,i)<=twork*mnth) THEN
		    p_t_shock_m(time_m,i,j,k) = gnodes_m(age_t_m(time_m,i),g_shck_shock_m(time_m,i,k))*p_t_shock_m(time_m-1,i,j,k) &
				*n_shck_shock_m(time_m,i,j)*v_shck_shock_m(time_m,age_t_m(time_m,i),k)
                    ELSE
   		    p_t_shock_m(time_m,i,j,k) = gnodes_m(age_t_m(time_m,i),g_shck_shock_m(time_m,i,k))*p_t_shock_m(time_m-1,i,j,k)
		    END IF
                  END DO
	  END IF
	END IF
	IF (time_m<numshock_m) THEN
	  IF (age_t_m(time_m,i)<ng_m) THEN
            IF (j==1) age_t_m(time_m+1,i) = age_t_m(time_m,i) + 1
	    IF (alive_t_shock_m(time_m,i,j)== 1) THEN
            rand_shock_vec(i)=par_uni(kpar(i))
	    	IF( rand_shock_vec(i)<betanodes_m(age_t_m(time_m,i)) ) THEN
	 	alive_t_shock_m(time_m+1,i,j) = 1
		ELSE
		alive_t_shock_m(time_m+1,i,j) = 0
		END IF
	    END IF
	  ELSE
	     IF (j==1) age_t_m(time_m+1,i) = 1
	     alive_t_shock_m(time_m+1,i,j) = 1
	  END IF
	END IF
        dp_shck_shock_m(time_m,i,j)=par_uni(kpar(i))
  END DO
  !$OMP END DO
  !$OMP END PARALLEL
        END DO
       END DO
    END DO


  END SUBROUTINE sub_shocks_mnth_b
