subroutine sub_valueiterate_mnth(Vnoadjust_m, Vadjust_m, a_adj_m,  &
	a_nadj_m,  D_adj_m )
  USE OMP_LIB
  USE SHARE
  IMPLICIT NONE

  REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk), INTENT(OUT) :: Vnoadjust_m, Vadjust_m
  REAL(8), DIMENSION(nx,nD,ng_m,ndp,nc,ngp,nrk), INTENT(OUT) :: a_adj_m,  &
	a_nadj_m,  D_adj_m

  INTEGER :: i,iter,j,k,l,m,n,o,p,i2,j2,k2,k3,l2,m2,o2,n2,n3, month, a_m
  REAL(8), DIMENSION(nD*na) :: adj_hold
  REAL(8), DIMENSION(na) :: nadj_hold
  REAL(8), DIMENSION(nz,nc,ngp,nrk) :: Vadjust_z, a_adj_z,  D_adj_z
  REAL(8), DIMENSION(na,nD,nc,ngp,nrk) :: EV
  REAL(8), DIMENSION(na,nD,ndp,nc,ngp,nrk) :: EVn
  REAL(8), DIMENSION(nD,ne,ngp) :: Dp, Dp_w
  REAL(8), DIMENSION(nD,ndp,ne,ngp) :: Dp_nadj, Dp_nadj_w
  INTEGER, DIMENSION(nD,ne,ngp) :: Dp_nodes
  INTEGER, DIMENSION(nD,ndp,ne,ngp) :: Dp_nadj_nodes
  REAL(8), DIMENSION(na,nD,ne,nu,nw,ngp,nrk) :: xp, xp_w
  REAL(8), DIMENSION(na,nD,ne,nu,nw,ndp*ndp*ngp,nrk) :: xp_nadj, xp_nadj_w
  INTEGER, DIMENSION(na,nD,ne,nu,nw,ngp,nrk) :: xpnodes
  INTEGER, DIMENSION(na,nD,ne,nu,nw,ndp*ndp*ngp,nrk) :: xp_nadj_nodes
  REAL(8), DIMENSION(nx,nD) :: adjust_resource, zweight
  INTEGER, DIMENSION(nx,nD) :: z_intnodes
  INTEGER, DIMENSION(nD*na) :: dummy_choice_a, dummy_choice_D
  REAL(8), DIMENSION(2) :: V_hold
  INTEGER :: choice, index1
  REAL(8) :: C, D_hold
  INTEGER :: age

REAL(8), EXTERNAL :: fel_m

IF (nz<nx) THEN
  OPEN (UNIT=555, FILE="out/Output.txt", STATUS="OLD", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' WARNING! nz<nx '
  CLOSE(555)
END IF

  !$OMP PARALLEL DO
   DO j=1,nD
   Vnoadjust_m(:,j,:,:,:,:,:) = 0.d0
   Vadjust_m(:,j,:,:,:,:,:) = 0.d0
   a_adj_m(:,j,:,:,:,:,:) = 0.d0
   a_nadj_m(:,j,:,:,:,:,:) = 0.d0
   D_adj_m(:,j,:,:,:,:,:) = 0.d0
   EV(:,j,:,:,:) = 0.d0
   EVn(:,j,:,:,:,:) = 0.d0
   Dp(j,:,:) = 0.d0
   Dp_w(j,:,:) = 0.d0
   Dp_nadj(j,:,:,:) = 0.d0
   Dp_nadj_w(j,:,:,:) = 0.d0
   Dp_nodes(j,:,:) = 0
   Dp_nadj_nodes(j,:,:,:) = 0
   xp(:,j,:,:,:,:,:) = 0.d0
   xp_w(:,j,:,:,:,:,:) = 0.d0
   xp_nadj(:,j,:,:,:,:,:) = 0.d0
   xp_nadj_w(:,j,:,:,:,:,:) = 0.d0
   xpnodes(:,j,:,:,:,:,:) = 0
   xp_nadj_nodes(:,j,:,:,:,:,:) = 0
   END DO
  !$OMP END PARALLEL DO

DO i=1,na
 DO j=1,nD
  index1 = (i-1)*nD + j
  dummy_choice_a( index1 ) = i
  dummy_choice_D( index1 ) = j
 END DO
END DO

DO i=1,nx
 DO j=1,nD
   adjust_resource(i,j) = xnodes_m(i) - F*Dnodes_m(j)
   CALL sub_intpnode(nz,znodes_m,adjust_resource(i,j),z_intnodes(i,j),zweight(i,j))
 END DO
END DO

! Age=trest+twork (a'=eta*D', no assets remaining, no debt)
! ---------------

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,adj_hold)
   DO j=1,nz
     DO k=1,nc
      ! Set up choice
       DO j2=1,nD
         IF (Dnodes_m(j2) .LE. clunk_thr_m) THEN
         C = znodes_m(j)-Dnodes_m(j2)*clunk_m(k)
         ELSE
         C = znodes_m(j)-Dnodes_m(j2)
         END IF
         IF (C>0.d0) THEN
         adj_hold(j2) = fel_m( C,Dnodes_m(j2), eqvnodes_m(ng_m) )
         ELSE
         C = cmin
         adj_hold(j2) = vmin
         END IF
       END DO
      choice = MAXLOC( adj_hold(:nD), 1)
      Vadjust_z(j,k,:,:) = adj_hold(choice)
      a_adj_z(j,k,:,:) = eta*Dnodes_m( dummy_choice_D(choice) )
      D_adj_z(j,k,:,:) = Dnodes_m( dummy_choice_D(choice) )
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold)
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
       D_hold = (1.d0-delta_m(k)*(1.d0-gamma_m))*Dnodes_m(j)
       C = xnodes_m(i) - D_hold
       IF (C>0.d0) THEN
       Vnoadjust_m(i,j,ng_m,k,:,:,:) = fel_m( C, D_hold, eqvnodes_m(ng_m) )
       ELSE
       Vnoadjust_m(i,j,ng_m,k,:,:,:) = vmin
       END IF
       a_nadj_m(i,j,ng_m,k,:,:,:) = eta*D_hold
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO k=1,nc
     DO m=1,ndp
      DO i=1,nx
       Vadjust_m(i,j,ng_m,m,k,:,:) = zweight(i,j)*Vadjust_z( z_intnodes(i,j),k,gnorm,nrk) + &
		            (1.d0-zweight(i,j))*Vadjust_z( z_intnodes(i,j)+1,k,gnorm,nrk)
       D_adj_m(i,j,ng_m,m,k,:,:) = zweight(i,j)*D_adj_z( z_intnodes(i,j),k,gnorm,nrk) + &
		            (1.d0-zweight(i,j))*D_adj_z( z_intnodes(i,j)+1,k,gnorm,nrk)
       a_adj_m(i,j,ng_m,m,k,:,:) = eta*D_adj_m(i,j,ng_m,m,k,gnorm,nrk)
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

! Age<trest+twork
! ---------------
DO age = ng,1,-1
  DO month = mnth,1,-1
  IF (age .LT. ng .OR. month .LT. mnth ) THEN
  a_m = (age-1)*mnth + month

  IF (a_m>=twork*mnth) THEN
 ! When retired
 ! ------------
  !$OMP PARALLEL DO PRIVATE(l2)
	  DO j=1,nD
           DO l=1,ngp

	   Dp(j,1,l) = Dnodes_m(j) / gnodes_m(a_m+1,l)
	   CALL sub_intpnode(nD,Dnodes_m,Dp(j,1,l),Dp_nodes(j,1,l),Dp_w(j,1,l))
           DO k=1,ndp
	   Dp_nadj(j,k,1,l) = (1.d0-delta_m(k)*(1-gamma_m))*Dnodes_m(j) / gnodes_m(a_m+1,l)
	   CALL sub_intpnode(nD,Dnodes_m,Dp_nadj(j,k,1,l),Dp_nadj_nodes(j,k,1,l),Dp_nadj_w(j,k,1,l))
           END DO
	 DO i=1,na
          DO k=1,nw
           DO m=1,nrk
	    IF (anodes_m(i) >= eta*Dnodes_m(j)) THEN
	    xp(i,j,1,1,k,l,m) = wnodes_m(k,a_m+1) * r_m*(anodes_m(i)-eta*Dnodes_m(j)) / gnodes_m(a_m+1,l) + &
				(1.d0-delta_m(ndp)) * Dnodes_m(j) / gnodes_m(a_m+1,l) + u_ret
	    ELSE
	    xp(i,j,1,1,k,l,m) = (r_m+rknodes_m(m))*(anodes_m(i)-eta*Dnodes_m(j))  &
				/ gnodes_m(a_m+1,l) + &
				(1.d0-delta_m(ndp)) * Dnodes_m(j) / gnodes_m(a_m+1,l) + u_ret
	    END IF
	    CALL sub_intpnode(nx,xnodes_m,xp(i,j,1,1,k,l,m),xpnodes(i,j,1,1,k,l,m),xp_w(i,j,1,1,k,l,m))

              DO k2=1,ndp
               DO k3=1,ndp
               l2= (k2-1)*ndp*ngp + (k3-1)*ngp + l
   	      IF ( anodes_m(i) >= eta*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j) ) THEN
	      xp_nadj(i,j,1,1,k,l2,m) = wnodes_m(k,a_m+1) * r_m * (anodes_m(i)-eta*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j)) &
				/ gnodes_m(a_m+1,l) + &
				(1.d0-delta_m(k3))*(1.d0-delta_m(k2)*(1-gamma_m))*Dnodes_m(j) / gnodes_m(a_m+1,l) + u_ret
	      ELSE
	      xp_nadj(i,j,1,1,k,l2,m) = (r_m+rknodes_m(m))*(anodes_m(i)-eta*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j)) &
				/ gnodes_m(a_m+1,l) + &
				(1.d0-delta_m(k3))*(1.d0-delta_m(k2)*(1-gamma_m))*Dnodes_m(j) / gnodes_m(a_m+1,l) + u_ret
	      END IF
	      CALL sub_intpnode(nx,xnodes_m,xp_nadj(i,j,1,1,k,l2,m),xp_nadj_nodes(i,j,1,1,k,l2,m),xp_nadj_w(i,j,1,1,k,l2,m))
               END DO
              END DO

             END DO
            END DO
	   END DO
	  END DO
	 END DO
  !$OMP END PARALLEL DO

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold,l2)
  DO j=1,nD
     DO k2=1,nc
      DO i2=1,ngp
       DO j2=1,nrk
    DO i=1,na

      EV(i,j,k2,i2,j2) = 0.d0

      DO k=1,nw
       DO k3=1,nc
        DO l=1,ngp
         DO m=1,nrk
        V_hold(1) =     xp_w(i,j,1,1,k,l,m)*Dp_w(j,1,l)*Vnoadjust_m(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l),a_m+1,ndp,k3,l,m) + &
	 		xp_w(i,j,1,1,k,l,m)*(1.d0-Dp_w(j,1,l))*Vnoadjust_m(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l)+1,a_m+1,ndp,k3,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*Dp_w(j,1,l)*Vnoadjust_m(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l),a_m+1,ndp,k3,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*(1.d0-Dp_w(j,1,l))*Vnoadjust_m(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l)+1,a_m+1,ndp,k3,l,m)
        V_hold(2) =     xp_w(i,j,1,1,k,l,m)*Dp_w(j,1,l)*Vadjust_m(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l),a_m+1,ndp,k3,l,m) + &
	 		xp_w(i,j,1,1,k,l,m)*(1.d0-Dp_w(j,1,l))*Vadjust_m(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l)+1,a_m+1,ndp,k3,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*Dp_w(j,1,l)*Vadjust_m(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l),a_m+1,ndp,k3,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*(1.d0-Dp_w(j,1,l))*Vadjust_m(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l)+1,a_m+1,ndp,k3,l,m)
        EV(i,j,k2,i2,j2) = EV(i,j,k2,i2,j2) + beta_m * betanodes_m(a_m) *  Probc_m(k2,k3)* &
			Probw_m(1,k,a_m+1) * Probg_m(i2,l) * Probrk_m(j2,m) * &
			(gnodes_m(a_m+1,l)**(1.d0-psi)) * MAXVAL( V_hold ,1 )

        END DO
       END DO
      END DO
     END DO

    DO n2=1,ndp

      EVn(i,j,n2,k2,i2,j2) = 0.d0

      DO k=1,nw
       DO n3=1,ndp
        DO k3=1,nc
         DO l=1,ngp
         l2 = (n2-1)*ndp*ngp + (n3-1)*ngp + l
          DO m=1,nrk
        V_hold(1) =     xp_nadj_w(i,j,1,1,k,l2,m)*Dp_nadj_w(j,n2,1,l)* &
			  Vnoadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,n2,1,l),a_m+1,n3,k3,l,m) + &
	 		xp_nadj_w(i,j,1,1,k,l2,m)*(1.d0-Dp_nadj_w(j,n2,1,l))* &
			  Vnoadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,n2,1,l)+1,a_m+1,n3,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*Dp_nadj_w(j,n2,1,l)* &
			  Vnoadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,n2,1,l),a_m+1,n3,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*(1.d0-Dp_nadj_w(j,n2,1,l))* &
			  Vnoadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,n2,1,l)+1,a_m+1,n3,k3,l,m)
        V_hold(2) =     xp_nadj_w(i,j,1,1,k,l2,m)*Dp_nadj_w(j,n2,1,l)* &
			  Vadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,n2,1,l),a_m+1,n3,k3,l,m) + &
	 		xp_nadj_w(i,j,1,1,k,l2,m)*(1.d0-Dp_nadj_w(j,n2,1,l))* &
			  Vadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,n2,1,l)+1,a_m+1,n3,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*Dp_nadj_w(j,n2,1,l)* &
		 	  Vadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,n2,1,l),a_m+1,n3,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*(1.d0-Dp_nadj_w(j,n2,1,l))* &
			  Vadjust_m(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,n2,1,l)+1,a_m+1,n3,k3,l,m)
        EVn(i,j,n2,k2,i2,j2)  =  EVn(i,j,n2,k2,i2,j2) + beta_m * betanodes_m(a_m) * Probdp_m(n2,n3)* Probc_m(k2,k3)* &
			Probw_m(1,k,a_m+1)* Probg_m(i2,l) * Probrk_m(j2,m) *&
			(gnodes_m(a_m+1,l)**(1.d0-psi)) * MAXVAL( V_hold ,1 )
         END DO
        END DO
       END DO
      END DO
     END DO

     END DO

      END DO
     END DO
    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL




  ELSE
 ! When working
 ! ------------

 !$OMP PARALLEL DO PRIVATE(o2)
 DO j=1,nD
   DO k=1,ne
    DO o=1,ngp
   ! Adjust
   Dp(j,k,o) = Dnodes_m(j) / ( gnodes_m(a_m+1,o)*enodes_m(k) )
   CALL sub_intpnode(nD,Dnodes_m,Dp(j,k,o),Dp_nodes(j,k,o),Dp_w(j,k,o))

     DO l=1,ndp
     Dp_nadj(j,l,k,o) = (1.d0-delta_m(l)*(1.d0-gamma_m))*Dnodes_m(j) / ( gnodes_m(a_m+1,o)*enodes_m(k) )
      CALL sub_intpnode(nD,Dnodes_m,Dp_nadj(j,l,k,o),Dp_nadj_nodes(j,l,k,o),Dp_nadj_w(j,l,k,o))
     END DO
  DO i=1,na
    DO l=1,nu
     DO m=1,nw
      DO p=1,nrk
    IF (anodes_m(i) >= eta*Dnodes_m(j)) THEN
    xp(i,j,k,l,m,o,p) = wnodes_m(m,a_m+1)*r_m*(anodes_m(i)-eta*Dnodes_m(j)) / (gnodes_m(a_m+1,o)*enodes_m(k)) + &
		(1.d0-delta_m(ndp))*Dnodes_m(j) / ( gnodes_m(a_m+1,o)*enodes_m(k) ) + unodes_m(l)
    ELSE
    xp(i,j,k,l,m,o,p) = (r_m+rknodes_m(p))*(anodes_m(i)-eta*Dnodes_m(j) ) &
		/ (gnodes_m(a_m+1,o)*enodes_m(k)) + &
		(1.d0-delta_m(ndp))*Dnodes_m(j) / ( gnodes_m(a_m+1,o)*enodes_m(k) ) + unodes_m(l)
    END IF
    CALL sub_intpnode(nx,xnodes_m,xp(i,j,k,l,m,o,p),xpnodes(i,j,k,l,m,o,p),xp_w(i,j,k,l,m,o,p))
    ! No Adjust
    DO k2=1,ndp
      DO k3=1,ndp
        o2= (k2-1)*ndp*ngp + (k3-1)*ngp + o
    IF (anodes_m(i) >= eta*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j)) THEN
    xp_nadj(i,j,k,l,m,o2,p) = wnodes_m(m,a_m+1)*r_m*(anodes_m(i)-eta*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j)) &
		 / (gnodes_m(a_m+1,o)*enodes_m(k)) + &
		(1.d0-delta_m(k3))*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j) / ( gnodes_m(a_m+1,o)*enodes_m(k) ) + unodes_m(l)
    ELSE
    xp_nadj(i,j,k,l,m,o2,p) = (r_m+rknodes_m(p))*( anodes_m(i)-eta*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j) ) &
		/ (gnodes_m(a_m+1,o)*enodes_m(k)) + &
		(1.d0-delta_m(k3))*(1.d0-delta_m(k2)*(1.d0-gamma_m))*Dnodes_m(j) / ( gnodes_m(a_m+1,o)*enodes_m(k) ) + unodes_m(l)
    END IF
    CALL sub_intpnode(nx,xnodes_m,xp_nadj(i,j,k,l,m,o2,p),xp_nadj_nodes(i,j,k,l,m,o2,p),xp_nadj_w(i,j,k,l,m,o2,p))
        END DO
       END DO

       END DO
      END DO
     END DO
    END DO
   END DO
  END DO
 END DO
 !$OMP END PARALLEL DO


  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold,o2)
  DO j=1,nD

     DO k2=1,nc
      DO i2=1,ngp
       DO j2=1,nrk
    DO i=1,na
      EV(i,j,k2,i2,j2) = 0.d0

      DO k = 1,ne
       DO l = 1,nu
        DO m = 1,nw
         DO k3 = 1,nc
          DO o = 1,ngp
           DO p = 1,nrk
        V_hold(1) =   xp_w(i,j,k,l,m,o,p)*Dp_w(j,k,o)*Vnoadjust_m(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o),a_m+1,ndp,k3,o,p) + &
	 		xp_w(i,j,k,l,m,o,p)*(1.d0-Dp_w(j,k,o))*Vnoadjust_m(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o)+1,a_m+1,ndp,k3,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*Dp_w(j,k,o)*Vnoadjust_m(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o),a_m+1,ndp,k3,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*(1.d0-Dp_w(j,k,o))*Vnoadjust_m(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o)+1,a_m+1,ndp,k3,o,p)
        V_hold(2) =     xp_w(i,j,k,l,m,o,p)*Dp_w(j,k,o)*Vadjust_m(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o),a_m+1,ndp,k3,o,p) + &
	 		xp_w(i,j,k,l,m,o,p)*(1.d0-Dp_w(j,k,o))*Vadjust_m(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o)+1,a_m+1,ndp,k3,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*Dp_w(j,k,o)*Vadjust_m(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o),a_m+1,ndp,k3,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*(1.d0-Dp_w(j,k,o))*Vadjust_m(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o)+1,a_m+1,ndp,k3,o,p)
        EV(i,j,k2,i2,j2) = EV(i,j,k2,i2,j2) + beta_m * betanodes_m(a_m)*Probc_m(k2,k3)* &
	                  Probe_m(1,k)*Probu_m(1,l)*Probw_m(1,m,a_m+1)*Probg_m(i2,o)*Probrk_m(j2,p)* &
			  (gnodes_m(a_m+1,o)*enodes_m(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
           END DO
          END DO
         END DO
	END DO
       END DO
      END DO

  DO n2=1,ndp
      EVn(i,j,n2,k2,i2,j2) = 0.d0

      DO k = 1,ne
       DO l = 1,nu
        DO m = 1,nw
         DO n3 = 1,ndp
          DO k3 = 1,nc
          DO o = 1,ngp
          o2 = (n2-1)*ndp*ngp + (n3-1)*ngp + o
           DO p = 1,nrk
        V_hold(1) =     xp_nadj_w(i,j,k,l,m,o2,p)*Dp_nadj_w(j,n2,k,o)* &
			Vnoadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,n2,k,o),a_m+1,n3,k3,o,p) + &
	 		xp_nadj_w(i,j,k,l,m,o2,p)*(1.d0-Dp_nadj_w(j,n2,k,o))* &
			Vnoadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,n2,k,o)+1,a_m+1,n3,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*Dp_nadj_w(j,n2,k,o)* &
			Vnoadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,n2,k,o),a_m+1,n3,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*(1.d0-Dp_nadj_w(j,n2,k,o))* &
			Vnoadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,n2,k,o)+1,a_m+1,n3,k3,o,p)
        V_hold(2) =     xp_nadj_w(i,j,k,l,m,o2,p)*Dp_nadj_w(j,n2,k,o)* &
			Vadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,n2,k,o),a_m+1,n3,k3,o,p) + &
	 		xp_nadj_w(i,j,k,l,m,o2,p)*(1.d0-Dp_nadj_w(j,n2,k,o))* &
			Vadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,n2,k,o)+1,a_m+1,n3,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*Dp_nadj_w(j,n2,k,o)* &
			Vadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,n2,k,o),a_m+1,n3,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*(1.d0-Dp_nadj_w(j,n2,k,o))* &
			Vadjust_m(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,n2,k,o)+1,a_m+1,n3,k3,o,p)
        EVn(i,j,n2,k2,i2,j2) = EVn(i,j,n2,k2,i2,j2) + beta_m * betanodes_m(a_m)*Probdp_m(n2,n3)*Probc_m(k2,k3)* &
			Probe_m(1,k)*Probu_m(1,l)*Probw_m(1,m,a_m+1)*Probg_m(i2,o)*Probrk_m(j2,p)*  &
			 (gnodes_m(a_m+1,o)*enodes_m(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
            END DO
           END DO
          END DO
         END DO
	END DO
       END DO
      END DO

       END DO

      END DO
     END DO
    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,index1,adj_hold)
   DO j=1,nz
    DO k=1,nc
     DO l=1,ngp
      DO m=1,nrk

      DO i2=1,na
       DO j2=1,nD
       index1 = (i2-1)*nD + j2
       IF (Dnodes_m(j2) .LE. clunk_thr_m) THEN
       C = znodes_m(j)-(clunk_m(k)-eta)*Dnodes_m(j2)-anodes_m(i2)
       ELSE
       C = znodes_m(j)-(1.d0-eta)*Dnodes_m(j2)-anodes_m(i2)
       END IF
       IF (C>0.d0) THEN
       adj_hold(index1) = fel_m( C,Dnodes_m(j2), eqvnodes_m(a_m) ) + EV(i2,j2,k,l,m)
       ELSE
       adj_hold(index1) = vmin
       END IF
       END DO
      END DO
      choice = MAXLOC( adj_hold, 1)
      Vadjust_z(j,k,l,m) = adj_hold(choice)
      a_adj_z(j,k,l,m) = anodes_m( dummy_choice_a(choice) )
      D_adj_z(j,k,l,m) = Dnodes_m( dummy_choice_D(choice) )
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold,choice,nadj_hold)
   DO j=1,nD
     DO n=1,ndp
      DO k=1,nc
      DO l=1,ngp
       DO m=1,nrk
        DO i=1,nx
      DO i2=1,na
       D_hold = (1-delta_m(n)*(1.d0-gamma_m))*Dnodes_m(j)
       C = xnodes_m(i) - anodes_m(i2) - (1.d0-eta)*D_hold

         IF (C>0.d0) THEN
         nadj_hold(i2) = fel_m( C, D_hold, eqvnodes_m(a_m) )+ EVn(i2,j,n,k,l,m)
         ELSE
         nadj_hold(i2) = vmin
         END IF
      END DO
       choice = MAXLOC( nadj_hold, 1)
       Vnoadjust_m(i,j,a_m,n,k,l,m) = nadj_hold(choice)
       a_nadj_m(i,j,a_m,n,k,l,m) = anodes_m( choice )
        END DO
       END DO
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
     DO k=1,nc
      DO l=1,ngp
       DO m=1,nrk
        DO n=1,ndp
         DO i=1,nx
       Vadjust_m(i,j,a_m,n,k,l,m) = zweight(i,j)*Vadjust_z( z_intnodes(i,j),k,l,m) + &
		            (1.d0-zweight(i,j))*Vadjust_z( z_intnodes(i,j)+1,k,l,m)
       a_adj_m(i,j,a_m,n,k,l,m) = zweight(i,j)*a_adj_z( z_intnodes(i,j),k,l,m ) + &
		            (1.d0-zweight(i,j))*a_adj_z( z_intnodes(i,j)+1,k,l,m )
       D_adj_m(i,j,a_m,n,k,l,m) = zweight(i,j)*D_adj_z( z_intnodes(i,j),k,l,m ) + &
		            (1.d0-zweight(i,j))*D_adj_z( z_intnodes(i,j)+1,k,l,m)

        END DO
       END DO
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

 END IF
 END DO
END DO

END SUBROUTINE sub_valueiterate_mnth
