program durables
 use share
 USE OMP_LIB
 use par_zig_mod

IMPLICIT NONE

  INTEGER :: i,j,k,l,m,iter,mx_thread, thread, chk_thread
  REAL(8) :: y_ss, c_h_ss, step, r_beta_cons
  REAL(8), DIMENSION(pen_yr-1) :: u_coef1
  REAL(8) :: u_coef2
  REAL(8) :: t0,t1,tcalc
  INTEGER :: AllocateStatus, status

! VALUE FUNCTIONS AND POLICIES
! --------------
    REAL(8), DIMENSION(nx,nD,ng,ndp,ns) :: &
	 Vnoadjust, Vadjust, V
    REAL(8), DIMENSION(nx,nD,ng,ndp,ns) :: a_adj,  &
	a_nadj,  D_adj, f_adj, f_nadj, cchoice

! SHOCKS
! -------------
    INTEGER, DIMENSION(:,:), ALLOCATABLE  :: age_t
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE  :: init_y_shock, init_x_shock, init_d_shock
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE  :: init_d_nadj_shock
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE  :: init_delta_shock
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE  :: alive_t_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE  :: n_shck_shock, u_shck_shock, dp_shck_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE  :: p_t_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE  :: v_shck_shock, m_shck_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE  :: s_t_shock

! IRFS
! -------------
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: init_y_irf, init_x_irf, init_d_irf
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: init_d_nadj_irf, init_delta_irf
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: alive_t_irf
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: n_shck_irf,  dp_shck_irf
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: u_shck_irf
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: p_t_irf
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: s_t_irf
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: v_shck_irf, m_shck_irf


  OPEN(UNIT=1,FILE='omp_thread',STATUS='OLD',ACTION='READ',IOSTAT=status)
  READ(1,*,IOSTAT=status) thread
  CLOSE(1)

  !$OMP PARALLEL
  mx_thread = OMP_GET_MAX_THREADS()
  thread = MIN(thread,mx_thread)
  !$OMP END PARALLEL
  CALL OMP_SET_NUM_THREADS(thread)
  !$OMP PARALLEL
  chk_thread = OMP_get_num_threads()
  !$OMP END PARALLEL

  t0 = omp_get_wtime()

  tau = (kappa-1.d0)/kappa
  tau2 = (kappa2-1.d0)/kappa2
  delta = (/ delta_1, delta_2 /)

  eta=(1.d0-delta_2-F)/(r+rk)
  sigma_ar = SQRT( sigma_id**2 + sigma_ag**2 )
  sigma_ma_lc = SQRT( sigma_ma**2 + sigma_pve**2 )
  beta_pve = corr_pve_v*sigma_pve/sigma_ag
  sigma_pve_res = SQRT( sigma_pve**2 - beta_pve**2 * sigma_ag**2 )

  gnodes = 1.d0
  CALL sub_seriesin

  DO i=0,pen_yr-2
  u_coef1(i+1) = 1.d0/EXP( SUM( LOG(gnodes(twork-i:twork) ) ) )
  END DO
  u_coef2 = (1.d0 + SUM(u_coef1) )/pen_yr
  u_ret = zeta * u_coef2

  CALL sub_tauchen(enodes,Probe,Probecum,0.d0,0.d0,sigma_ar,ne,cover_e)
  CALL sub_tauchen(unodes,Probu,Probucum,0.d0,0.d0,sigma_ma_lc,nu,cover_u)
  CALL sub_tauchen(snodes,Probs,Probscum,rho_s,0.d0,sigma_s,ns,cover_s)
  enodes = exp(enodes)
  unodes = exp(unodes)
  snodes = exp(snodes)
  emax = enodes(ne)
  emin = enodes(1)
  umax = unodes(nu)
  umin = unodes(1)
  smax = snodes(ns)
  smin = snodes(1)

  Probdp = reshape( (/ p_delta_1, 1.d0-p_delta_2, &
			1.d0-p_delta_1, p_delta_2 /), (/ndp,ndp/) )
  Probdpcum = MATMUL(Probdp,Probdp)

  Probdpcum = reshape( (/ 1.d0-p_delta_2, 1.d0-p_delta_2, &
			p_delta_2, p_delta_2 /), (/ndp,ndp/) )

  step = ((amax-amin)/(DBLE(na)-1.0d0))
  anodes = (/ (amin + step*i, i = 0, na-1) /)
  anodes(na) = amax

  step = ((Dmax-Dmin)/(DBLE(nD)-1.0d0))
  Dnodes = (/ (Dmin + step*i, i = 0, nD-1) /)
  Dnodes(nD) = Dmax

  step = ((fmax-fmin)/(DBLE(nf)-1.0d0))
  fnodes = (/ (fmin + step*i, i = 0, nf-1) /)
  fnodes(nf) = fmax

  IF (amin - eta*Dmax >= 0.d0) THEN
  xmin = amin*r/(MAXVAL(gnodes)*MAXVAL(enodes)) + MINVAL(unodes)
  ELSE
  xmin = ( amin*r + rk*(amin-eta*Dmax) )/(MINVAL(gnodes)*MINVAL(enodes)) + MINVAL(unodes)
  END IF
  xmax = amax * r + MAXVAL(unodes)
  step = ((xmax-xmin)/(DBLE(nx)-1.0d0))
  xnodes = (/ (xmin + step*i, i = 0, nx-1) /)
  xnodes(nx) = xmax

  zmin = xmin + (1.d0-MAXVAL(delta)-F)*Dmin
  zmax = xmax + (1.d0-MINVAL(delta)-F)*Dmax
  step = ((zmax-zmin)/(DBLE(nz)-1.0d0))
  znodes = (/ (zmin + step*i, i = 0, nz-1) /)
  znodes(nz) = zmax

  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(555,*) ' MODEL WITH FUEL PRICE '
  CLOSE(555)

  CALL sub_valueiterate(Vnoadjust, Vadjust, V, a_adj,  &
	a_nadj,  D_adj, f_adj, f_nadj, cchoice )

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished finding policy fn. TIME: ', tcalc
  CLOSE(555)

  t0 = omp_get_wtime()
  ALLOCATE( age_t(numsim,agents) )
  ALLOCATE( init_y_shock(shocklives,agents,rep), init_x_shock(shocklives,agents,rep), init_d_shock(shocklives,agents,rep), &
    n_shck_shock(numshock,agents,rep), u_shck_shock(numshock,agents,rep), dp_shck_shock(numshock,agents,rep), &
    p_t_shock(numshock,agents,rep,shck_c), v_shck_shock(numshock,twork,rep,shck_c), &
    m_shck_shock(numshock,twork,rep,shck_c), s_t_shock(numshock,rep,shck_c), STAT=AllocateStatus  )

  ALLOCATE( init_d_nadj_shock(shocklives,agents,rep), init_delta_shock(shocklives,agents,rep), &
	alive_t_shock(numshock,agents,rep) )

  CALL sub_shocks_b(age_t,init_y_shock,init_x_shock, init_d_shock,init_d_nadj_shock,init_delta_shock, &
	alive_t_shock,n_shck_shock,u_shck_shock,p_t_shock,v_shck_shock,m_shck_shock,dp_shck_shock,s_t_shock)

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished generating simulation shocks. TIME: ', tcalc
  CLOSE(555)

  CALL sub_shocksim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,f_adj,f_nadj, &
	init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock,init_delta_shock,age_t,alive_t_shock, &
	n_shck_shock,u_shck_shock,p_t_shock,dp_shck_shock,s_t_shock,v_shck_shock,m_shck_shock)

  DEALLOCATE( init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock, init_delta_shock, &
	alive_t_shock,n_shck_shock,u_shck_shock,p_t_shock,s_t_shock,v_shck_shock,m_shck_shock, &
	dp_shck_shock )

  t0 = omp_get_wtime()
  tcalc = t0-t1
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished shock sim. TIME: ', tcalc
  CLOSE(555)

end program durables

REAL(8) FUNCTION fel(C,Dprime,fuel,equiv)

USE share
IMPLICIT NONE
REAL(8), INTENT(IN) :: C, Dprime, fuel, equiv
REAL(8) :: dur_service

dur_service = (omega*Dprime**tau2 + (1.d0-omega)*fuel**tau2 )**(1.d0/tau2)

fel =  ( ( (theta * (C/equiv)**tau  + &
	(1.d0-theta)*(xi*(dur_service)/equiv)**tau)**(1.d0/tau) )**(1.0d0-psi) - 1.d0)/(1.0d0-psi)

END FUNCTION fel


SUBROUTINE sub_tauchen(y,pi,picum,rho,mu0,sigma,n,cover_tauchen)
	! Calculates Tauchen points for AR(1) x=(1-rho)mu0 + rho*x_(-1) + u
	! Adapted from sub_tauchen by Jesus Fernandez-Villaverde (undated)
	! cover_tauchen is the number of SD (each side) that one wants
	! to cover.

	IMPLICIT NONE

	INTEGER, INTENT(in) :: n

	REAL(8), INTENT(in) :: rho, mu0, sigma, cover_tauchen
	REAL(8), DIMENSION (n,n), INTENT(out) :: pi , picum
	REAL(8), DIMENSION (n), INTENT(out) :: y

	INTEGER :: yc, tc, tcc,i1

	REAL(8) :: sigy, mu, upp, low
	REAL(8), EXTERNAL  :: cum_normal

	! Define the discrete states of the Markov chain

	sigy = sigma/SQRT(1.0-rho**2)

	y(n) = mu0 + cover_tauchen*sigy
	y(1) = mu0 - cover_tauchen*sigy

	DO yc = 2, n-1

		y(yc) = y(1)+(y(n)-y(1))*(yc-1.0)/(n-1.0)

	END DO

	! Compute the transition matrix

	DO tc = 1,n
		mu = (1-rho)*mu0 + rho*y(tc)
		upp = (y(2)+y(1))/2.0
		upp = (upp-mu)/sigma
		pi(tc,1) = cum_normal(upp)
		low = (y(n)+y(n-1))/2.0
		low = (low-mu)/sigma
		pi(tc,n) = 1.d0-cum_normal(low)

		DO tcc = 2, n-1

			low = (y(tcc-1)+y(tcc))/2.0
			upp = (y(tcc+1)+y(tcc))/2.0
			low = (low-mu)/sigma
			upp = (upp-mu)/sigma
			pi(tc,tcc) = cum_normal(upp)-cum_normal(low)

		END DO
	END DO

	! Compute the CDF of the transition matrix.
	picum(:,1)=pi(:,1)
	DO tc = 2,n
		picum(:,tc)=picum(:,tc-1)+pi(:,tc)
	ENDDO


END SUBROUTINE sub_tauchen

FUNCTION cum_normal(X)
  ! Returns the value of the cumulative density of the Standard Normal
  ! Distribution at point X

  IMPLICIT NONE
  REAL(8), INTENT(in)  :: X
  REAL(8) 		:: cum_normal

  cum_normal =  0.5d0*( 1+erf(x/SQRT(2.d0)) )

END FUNCTION cum_normal
