subroutine sub_valueiterate(Vnoadjust, Vadjust, V, a_adj,  &
	a_nadj,  D_adj, f_adj, f_nadj, &
	cchoice)

  USE OMP_LIB
  USE SHARE
  IMPLICIT NONE

  REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(OUT) :: Vnoadjust, Vadjust, V
  REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(OUT) :: a_adj,  &
	a_nadj,  D_adj,  f_adj, f_nadj, cchoice

  REAL(8), DIMENSION(:,:,:,:,:), ALLOCATABLE :: c_adj, c_nadj

  INTEGER :: i,iter,j,k,l,m,i2,j2,k2,l2,m2
  REAL(8) :: adj_hold, nadj_hold
  REAL(8), DIMENSION(nz,ns) :: Vadjust_z, a_adj_z,  D_adj_z, f_adj_z
  REAL(8), DIMENSION(na,nD,ns) :: EV
  REAL(8), DIMENSION(na,nD,ndp,ns) :: EVn
  REAL(8), DIMENSION(nD,ne) :: Dp, Dp_w
  REAL(8), DIMENSION(nD,ndp,ne) :: Dp_nadj, Dp_nadj_w
  INTEGER, DIMENSION(nD,ne) :: Dp_nodes
  INTEGER, DIMENSION(nD,ndp,ne) :: Dp_nadj_nodes
  REAL(8), DIMENSION(na,nD,ne,nu) :: xp, xp_w
  REAL(8), DIMENSION(na,nD,ndp,ne,nu) :: xp_nadj, xp_nadj_w
  INTEGER, DIMENSION(na,nD,ne,nu) :: xpnodes
  INTEGER, DIMENSION(na,nD,ndp,ne,nu) :: xp_nadj_nodes
  REAL(8), DIMENSION(nx,nD,ndp) :: adjust_resource, zweight
  INTEGER, DIMENSION(nx,nD,ndp) :: z_intnodes
  INTEGER, DIMENSION(nD*na*nf) :: dummy_choice_a, dummy_choice_D, dummy_choice_f
  INTEGER, DIMENSION(na*nf) :: dummy_choice_a_na, dummy_choice_f_na
  INTEGER, DIMENSION(nD*nf) :: dummy_choice_Dend, dummy_choice_fend
  REAL(8), DIMENSION(2) :: V_hold
  INTEGER :: choice, index1
  REAL(8) :: C, D_hold
  INTEGER :: age

REAL(8), EXTERNAL :: fel


  ALLOCATE( c_adj(nx,nD,ng,ndp,ns), c_nadj(nx,nD,ng,ndp,ns) )

  !$OMP PARALLEL DO
   DO j=1,nD
   Vnoadjust(:,j,:,:,:) = 0.d0
   Vadjust(:,j,:,:,:) = 0.d0
   V(:,j,:,:,:) = 0.d0
   a_adj(:,j,:,:,:) = 0.d0
   a_nadj(:,j,:,:,:) = 0.d0
   D_adj(:,j,:,:,:) = 0.d0
   f_adj(:,j,:,:,:) = 0.d0
   f_nadj(:,j,:,:,:) = 0.d0
   c_adj(:,j,:,:,:) = 0.d0
   c_nadj(:,j,:,:,:) = 0.d0
   cchoice(:,j,:,:,:) = 0.d0
   EV(:,j,:) = 0.d0
   EVn(:,j,:,:) = 0.d0
   Dp(j,:) = 0.d0
   Dp_w(j,:) = 0.d0
   Dp_nadj(j,:,:) = 0.d0
   Dp_nadj_w(j,:,:) = 0.d0
   Dp_nodes(j,:) = 0
   Dp_nadj_nodes(j,:,:) = 0
   xp(:,j,:,:) = 0.d0
   xp_w(:,j,:,:) = 0.d0
   xp_nadj(:,j,:,:,:) = 0.d0
   xp_nadj_w(:,j,:,:,:) = 0.d0
   xpnodes(:,j,:,:) = 0
   xp_nadj_nodes(:,j,:,:,:) = 0
   END DO
  !$OMP END PARALLEL DO

DO i=1,na
 DO j=1,nD
  DO k=1,nf
  index1 = (i-1)*nD*nf + (j-1)*nf + k
  dummy_choice_a( index1 ) = i
  dummy_choice_D( index1 ) = j
  dummy_choice_f( index1 ) = k
  END DO
 END DO
END DO

 DO j=1,nD
  DO k=1,nf
  index1 = (j-1)*nf + k
  dummy_choice_Dend( index1 ) = j
  dummy_choice_fend( index1 ) = k
  END DO
 END DO

 DO i=1,na
  DO k=1,nf
  index1 = (i-1)*nf + k
  dummy_choice_a_na( index1 ) = i
  dummy_choice_f_na( index1 ) = k
  END DO
 END DO

DO i=1,nx
 DO j=1,nD
  DO k=1,ndp
   adjust_resource(i,j,k) = (1.d0-delta(k)-F-r*eta)*Dnodes(j) + xnodes(i)
   CALL sub_intpnode(nz,znodes,adjust_resource(i,j,k),z_intnodes(i,j,k),zweight(i,j,k))
  END DO
 END DO
END DO

! Age=trest+twork (a'=eta*D', no assets remaining, no debt)
! ---------------

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,adj_hold,index1)
   DO j=1,nz
    DO k=1,ns
       Vadjust_z(j,k) = vmin
       choice = 1
       DO j2=1,nD
        DO k2=1,nf
         index1 = (j2-1)*nf + k2
         C = znodes(j)-Dnodes(j2)-snodes(k)*fnodes(k2)
         IF (C>0.d0) THEN
         adj_hold= fel( C,Dnodes(j2), fnodes(k2), eqvnodes(ng) )
         ELSE
         C = cmin
         adj_hold = vmin
         END IF
         IF (adj_hold>Vadjust_z(j,k)) THEN
         Vadjust_z(j,k) = adj_hold
         choice = index1
         END IF
       END DO
      END DO
      a_adj_z(j,k) = eta*Dnodes( dummy_choice_Dend(choice) )
      D_adj_z(j,k) = Dnodes( dummy_choice_Dend(choice) )
      f_adj_z(j,k) = fnodes( dummy_choice_fend(choice) )
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold,choice,nadj_hold)
   DO j=1,nD
    DO i=1,nx
     DO m=1,ndp
      DO k=1,ns
     Vnoadjust(i,j,ng,m,k) = vmin
     choice = 1
      DO k2 = 1,nf
       C = xnodes(i) - (delta(m)*gamma+r*eta)*Dnodes(j)-snodes(k)*fnodes(k2)
       D_hold = (1.d0-delta(m)*(1.d0-gamma))*Dnodes(j)
       IF (C>0.d0) THEN
       nadj_hold = fel( C, D_hold, fnodes(k2), eqvnodes(ng) )
       ELSE
       nadj_hold = vmin
       END IF
       IF (nadj_hold>Vnoadjust(i,j,ng,m,k)) THEN
       Vnoadjust(i,j,ng,m,k) = nadj_hold
       choice = k2
       END IF
      END DO
       a_nadj(i,j,ng,m,k) = eta*D_hold
       f_nadj(i,j,ng,m,k) = fnodes( choice )
       c_nadj(i,j,ng,m,k) = xnodes(i) - (delta(m)*gamma+r*eta)*Dnodes(j)-snodes(k)*f_nadj(i,j,ng,m,k)
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
     DO m=1,ndp
      DO k=1,ns
       Vadjust(i,j,ng,m,k) = zweight(i,j,m)*Vadjust_z( z_intnodes(i,j,m),k) + &
		            (1.d0-zweight(i,j,m))*Vadjust_z( z_intnodes(i,j,m)+1,k)
       D_adj(i,j,ng,m,k) = zweight(i,j,m)*D_adj_z( z_intnodes(i,j,m),k ) + &
		            (1.d0-zweight(i,j,m))*D_adj_z( z_intnodes(i,j,m)+1,k)
       f_adj(i,j,ng,m,k) = zweight(i,j,m)*f_adj_z( z_intnodes(i,j,m),k ) + &
		            (1.d0-zweight(i,j,m))*f_adj_z( z_intnodes(i,j,m)+1,k)
       a_adj(i,j,ng,m,k) = eta*D_adj(i,j,ng,m,k)
       c_adj(i,j,ng,m,k) = adjust_resource(i,j,m) - D_adj(i,j,ng,m,k) - &
		f_adj(i,j,ng,m,k) * snodes(k)

	   IF (Vadjust(i,j,ng,m,k) >= Vnoadjust(i,j,ng,m,k)) THEN
	   V(i,j,ng,m,k) = Vadjust(i,j,ng,m,k)
	   cchoice(i,j,ng,m,k) = c_adj(i,j,ng,m,k)
	   ELSE
	   V(i,j,ng,m,k) = Vnoadjust(i,j,ng,m,k)
	   cchoice(i,j,ng,m,k) = c_nadj(i,j,ng,m,k)
	   END IF
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

! Age<trest+twork
! ---------------
DO age = ng-1,1,-1

  IF (age>=twork) THEN
 ! When retired
 ! ------------
 IF (age==ng-1) THEN
  !$OMP PARALLEL DO
	  DO j=1,nD
	   Dp(j,1) = Dnodes(j) / gnodes(age+1)
	   CALL sub_intpnode(nD,Dnodes,Dp(j,1),Dp_nodes(j,1),Dp_w(j,1))
           DO k=1,ndp
			     Dp_nadj(j,k,1) = (1.d0-delta(k)*(1-gamma))*Dnodes(j) / gnodes(age+1)
			     CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,k,1),Dp_nadj_nodes(j,k,1),Dp_nadj_w(j,k,1))
           END DO

	 DO i=1,na

	    IF (anodes(i) >= eta*Dnodes(j)) THEN
	    xp(i,j,1,1) = r*anodes(i) / gnodes(age+1) + u_ret
	    ELSE
	    xp(i,j,1,1) = (r*anodes(i) + rk*(anodes(i)-eta*Dnodes(j)) ) &
				/ gnodes(age+1) + u_ret
	    END IF
	    CALL sub_intpnode(nx,xnodes,xp(i,j,1,1),xpnodes(i,j,1,1),xp_w(i,j,1,1))
          DO k=1,ndp
  	      IF ( anodes(i) >= eta*(1.d0-delta(k)*(1.d0-gamma))*Dnodes(j) ) THEN
	      xp_nadj(i,j,k,1,1) = r*anodes(i) / gnodes(age+1) + u_ret
	      ELSE
	      xp_nadj(i,j,k,1,1) = (r*anodes(i) + &
				rk*(anodes(i)-eta*(1.d0-delta(k)*(1.d0-gamma))*Dnodes(j)) ) &
				/ gnodes(age+1) + u_ret
	      END IF
	      CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,k,1,1),xp_nadj_nodes(i,j,k,1,1),xp_nadj_w(i,j,k,1,1))
           END DO
	  END DO
	 END DO
  !$OMP END PARALLEL DO
 END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold)
  DO j=1,nD
    DO i=1,na
     DO i2=1,ns
	EV(i,j,i2)=0.d0

        DO k=1,ns
        V_hold(1) =     xp_w(i,j,1,1)*Dp_w(j,1)*Vnoadjust(xpnodes(i,j,1,1),Dp_nodes(j,1),age+1,ndp,k) + &
	 		xp_w(i,j,1,1)*(1.d0-Dp_w(j,1))*Vnoadjust(xpnodes(i,j,1,1),Dp_nodes(j,1)+1,age+1,ndp,k) + &
			(1.d0-xp_w(i,j,1,1))*Dp_w(j,1)*Vnoadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1),age+1,ndp,k) + &
			(1.d0-xp_w(i,j,1,1))*(1.d0-Dp_w(j,1))*Vnoadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1)+1,age+1,ndp,k)
        V_hold(2) =     xp_w(i,j,1,1)*Dp_w(j,1)*Vadjust(xpnodes(i,j,1,1),Dp_nodes(j,1),age+1,ndp,k) + &
	 		xp_w(i,j,1,1)*(1.d0-Dp_w(j,1))*Vadjust(xpnodes(i,j,1,1),Dp_nodes(j,1)+1,age+1,ndp,k) + &
			(1.d0-xp_w(i,j,1,1))*Dp_w(j,1)*Vadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1),age+1,ndp,k) + &
			(1.d0-xp_w(i,j,1,1))*(1.d0-Dp_w(j,1))*Vadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1)+1,age+1,ndp,k)
        EV(i,j,i2)   =  EV(i,j,i2) + beta * betanodes(age)* Probs(i2,k) * (gnodes(age+1)**(1.d0-psi)) * MAXVAL( V_hold ,1 )
        END DO


        DO j2=1,ndp
      	EVn(i,j,j2,i2)=0.d0
        DO m=1,ndp
          DO k=1,ns

        V_hold(1) =     xp_nadj_w(i,j,j2,1,1)*Dp_nadj_w(j,j2,1)* &
			  Vnoadjust(xp_nadj_nodes(i,j,j2,1,1),Dp_nadj_nodes(j,j2,1),age+1,m,k) + &
	 		xp_nadj_w(i,j,j2,1,1)*(1.d0-Dp_nadj_w(j,j2,1))* &
			  Vnoadjust(xp_nadj_nodes(i,j,j2,1,1),Dp_nadj_nodes(j,j2,1)+1,age+1,m,k) + &
			(1.d0-xp_nadj_w(i,j,j2,1,1))*Dp_nadj_w(j,j2,1)* &
			  Vnoadjust(xp_nadj_nodes(i,j,j2,1,1)+1,Dp_nadj_nodes(j,j2,1),age+1,m,k) + &
			(1.d0-xp_nadj_w(i,j,j2,1,1))*(1.d0-Dp_nadj_w(j,j2,1))* &
			  Vnoadjust(xp_nadj_nodes(i,j,j2,1,1)+1,Dp_nadj_nodes(j,j2,1)+1,age+1,m,k)
        V_hold(2) =     xp_nadj_w(i,j,j2,1,1)*Dp_nadj_w(j,j2,1)* &
			  Vadjust(xp_nadj_nodes(i,j,j2,1,1),Dp_nadj_nodes(j,j2,1),age+1,m,k) + &
	 		xp_nadj_w(i,j,j2,1,1)*(1.d0-Dp_nadj_w(j,j2,1))* &
			  Vadjust(xp_nadj_nodes(i,j,j2,1,1),Dp_nadj_nodes(j,j2,1)+1,age+1,m,k) + &
			(1.d0-xp_nadj_w(i,j,j2,1,1))*Dp_nadj_w(j,j2,1)* &
		 	  Vadjust(xp_nadj_nodes(i,j,j2,1,1)+1,Dp_nadj_nodes(j,j2,1),age+1,m,k) + &
			(1.d0-xp_nadj_w(i,j,j2,1,1))*(1.d0-Dp_nadj_w(j,j2,1))* &
			  Vadjust(xp_nadj_nodes(i,j,j2,1,1)+1,Dp_nadj_nodes(j,j2,1)+1,age+1,m,k)
        EVn(i,j,j2,i2)  = 	EVn(i,j,j2,i2) + beta * betanodes(age)* Probdp(j2,m)* Probs(i2,k)* &
			(gnodes(age+1)**(1.d0-psi)) * MAXVAL( V_hold ,1 )
        END DO
       END DO
      END DO

    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  ELSE
 ! When working
 ! ------------
 !$OMP PARALLEL DO
 DO j=1,nD
   DO k=1,ne
   ! Adjust
   Dp(j,k) = Dnodes(j) / ( gnodes(age+1)*enodes(k) )
   CALL sub_intpnode(nD,Dnodes,Dp(j,k),Dp_nodes(j,k),Dp_w(j,k))
    DO l=1,ndp
     Dp_nadj(j,l,k) = (1.d0-delta(l)*(1.d0-gamma))*Dnodes(j) / ( gnodes(age+1)*enodes(k) )
     CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,l,k),Dp_nadj_nodes(j,l,k),Dp_nadj_w(j,l,k))
    END DO
  END DO

  DO i=1,na
   DO k=1,ne
    DO l=1,nu
    IF (anodes(i) >= eta*Dnodes(j)) THEN
    xp(i,j,k,l) = r*anodes(i) / (gnodes(age+1)*enodes(k)) + unodes(l)
    ELSE
    xp(i,j,k,l) = ( r*anodes(i) + rk*(anodes(i)-eta*Dnodes(j) ) ) &
					/ (gnodes(age+1)*enodes(k)) + unodes(l)
    END IF
    CALL sub_intpnode(nx,xnodes,xp(i,j,k,l),xpnodes(i,j,k,l),xp_w(i,j,k,l))
      DO m=1,ndp
      IF (anodes(i) >= eta*(1.d0-delta(m)*(1.d0-gamma))*Dnodes(j)) THEN
      xp_nadj(i,j,m,k,l) = r*anodes(i) / (gnodes(age+1)*enodes(k)) + unodes(l)
      ELSE
      xp_nadj(i,j,m,k,l) = ( r*anodes(i) + rk*( anodes(i)-eta*(1.d0-delta(m)*(1.d0-gamma))*Dnodes(j) ) ) &
					/ (gnodes(age+1)*enodes(k)) + unodes(l)
      END IF
      CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,m,k,l),xp_nadj_nodes(i,j,m,k,l),xp_nadj_w(i,j,m,k,l))
      END DO
    END DO
   END DO
  END DO
 END DO
 !$OMP END PARALLEL DO

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold)
  DO j=1,nD
    DO i=1,na
     DO i2=1,ns
      EV(i,j,i2) = 0.d0

      DO k = 1,ne
       DO l = 1,nu
        DO m = 1,ns
        V_hold(1) =   xp_w(i,j,k,l)*Dp_w(j,k)*Vnoadjust(xpnodes(i,j,k,l),Dp_nodes(j,k),age+1,ndp,m) + &
	 		xp_w(i,j,k,l)*(1.d0-Dp_w(j,k))*Vnoadjust(xpnodes(i,j,k,l),Dp_nodes(j,k)+1,age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l))*Dp_w(j,k)*Vnoadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k),age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l))*(1.d0-Dp_w(j,k))*Vnoadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k)+1,age+1,ndp,m)
        V_hold(2) =     xp_w(i,j,k,l)*Dp_w(j,k)*Vadjust(xpnodes(i,j,k,l),Dp_nodes(j,k),age+1,ndp,m) + &
	 		xp_w(i,j,k,l)*(1.d0-Dp_w(j,k))*Vadjust(xpnodes(i,j,k,l),Dp_nodes(j,k)+1,age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l))*Dp_w(j,k)*Vadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k),age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l))*(1.d0-Dp_w(j,k))*Vadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k)+1,age+1,ndp,m)
        EV(i,j,i2) = EV(i,j,i2) + beta * betanodes(age)*Probe(1,k)*Probu(1,l)* Probs(i2,m) *&
			 (gnodes(age+1)*enodes(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
        END DO
       END DO
      END DO

    DO j2=1,ndp
      EVn(i,j,j2,i2) = 0.d0

      DO k = 1,ne
       DO l = 1,nu
        DO m2=1,ndp
         DO m = 1,ns

        V_hold(1) =     xp_nadj_w(i,j,j2,k,l)*Dp_nadj_w(j,j2,k)* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l),Dp_nadj_nodes(j,j2,k),age+1,m2,m) + &
	 		xp_nadj_w(i,j,j2,k,l)*(1.d0-Dp_nadj_w(j,j2,k))* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l),Dp_nadj_nodes(j,j2,k)+1,age+1,m2,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l))*Dp_nadj_w(j,j2,k)* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l)+1,Dp_nadj_nodes(j,j2,k),age+1,m2,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l))*(1.d0-Dp_nadj_w(j,j2,k))* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l)+1,Dp_nadj_nodes(j,j2,k)+1,age+1,m2,m)
        V_hold(2) =     xp_nadj_w(i,j,j2,k,l)*Dp_nadj_w(j,j2,k)* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l),Dp_nadj_nodes(j,j2,k),age+1,m2,m) + &
	 		xp_nadj_w(i,j,j2,k,l)*(1.d0-Dp_nadj_w(j,j2,k))* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l),Dp_nadj_nodes(j,j2,k)+1,age+1,m2,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l))*Dp_nadj_w(j,j2,k)* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l)+1,Dp_nadj_nodes(j,j2,k),age+1,m2,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l))*(1.d0-Dp_nadj_w(j,j2,k))* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l)+1,Dp_nadj_nodes(j,j2,k)+1,age+1,m2,m)
        EVn(i,j,j2,i2) = EVn(i,j,j2,i2) + beta * betanodes(age)*Probe(1,k)*Probu(1,l)* Probdp(j2,m2) * Probs(i2,m) * &
			 (gnodes(age+1)*enodes(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
         END DO
        END DO
       END DO
      END DO

     END DO
    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,index1,adj_hold)
   DO j=1,nz
    DO k=1,ns
      Vadjust_z(j,k)  = vmin
      choice = 1
      DO i2=1,na
       DO j2=1,nD
        DO k2=1,nf
        index1 = (i2-1)*nD*nf + (j2-1)*nf + k2
        C = znodes(j)-(1.d0-eta)*Dnodes(j2)-anodes(i2)-snodes(k)*fnodes(k2)
        IF (C>0.d0) THEN
        adj_hold = fel( C,Dnodes(j2), fnodes(k2), eqvnodes(age) ) + EV(i2,j2,k)
        ELSE
        adj_hold = vmin
        END IF
        IF (adj_hold>Vadjust_z(j,k)) THEN
        Vadjust_z(j,k) = adj_hold
        choice = index1
        END IF
        END DO
       END DO
      END DO
      a_adj_z(j,k) = anodes( dummy_choice_a(choice) )
      D_adj_z(j,k) = Dnodes( dummy_choice_D(choice) )
      f_adj_z(j,k) = fnodes( dummy_choice_f(choice) )
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO PRIVATE(index1,C,D_hold,choice,nadj_hold)
   DO j=1,nD
    DO i=1,nx
     DO m=1,ndp
      DO k=1,ns
      Vnoadjust(i,j,age,m,k) = vmin
      choice = 1
      DO i2=1,na
       DO k2=1,nf
       index1 = (i2-1)*nf + k2
       C = xnodes(i) - anodes(i2) + &
	     ( eta * (1-delta(m)*(1.d0-gamma) - r ) - delta(m)*gamma )*Dnodes(j) - &
	     snodes(k)*fnodes(k2)
       D_hold = (1-delta(m)*(1.d0-gamma))*Dnodes(j)
         IF (C>0.d0) THEN
         nadj_hold = fel( C, D_hold, fnodes(k2), eqvnodes(age) )+ EVn(i2,j,m,k)
         ELSE
         nadj_hold = vmin
         END IF
        IF (nadj_hold>Vnoadjust(i,j,age,m,k)) THEN
        Vnoadjust(i,j,age,m,k) = nadj_hold
        choice = index1
        END IF
       END DO
      END DO
       a_nadj(i,j,age,m,k) = anodes( dummy_choice_a_na(choice) )
       f_nadj(i,j,age,m,k) = fnodes( dummy_choice_f_na(choice) )
       c_nadj(i,j,age,m,k) = xnodes(i) - a_nadj(i,j,age,m,k) + &
	     ( eta * (1-delta(m)*(1.d0-gamma) - r) - delta(m)*gamma )*Dnodes(j) - &
	     snodes(k)*f_nadj(i,j,age,m,k)
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
     DO m=1,ndp
      DO k=1,ns
       Vadjust(i,j,age,m,k) = zweight(i,j,m)*Vadjust_z( z_intnodes(i,j,m),k) + &
		            (1.d0-zweight(i,j,m))*Vadjust_z( z_intnodes(i,j,m)+1,k)
       a_adj(i,j,age,m,k) = zweight(i,j,m)*a_adj_z( z_intnodes(i,j,m),k ) + &
		            (1.d0-zweight(i,j,m))*a_adj_z( z_intnodes(i,j,m)+1,k)
       D_adj(i,j,age,m,k) = zweight(i,j,m)*D_adj_z( z_intnodes(i,j,m),k ) + &
		            (1.d0-zweight(i,j,m))*D_adj_z( z_intnodes(i,j,m)+1,k)
       f_adj(i,j,age,m,k) = zweight(i,j,m)*f_adj_z( z_intnodes(i,j,m),k ) + &
		            (1.d0-zweight(i,j,m))*f_adj_z( z_intnodes(i,j,m)+1,k)
       c_adj(i,j,age,m,k) = adjust_resource(i,j,m) - a_adj(i,j,age,m,k) - &
		(1.d0-eta)*D_adj(i,j,age,m,k) - snodes(k)*f_adj(i,j,age,m,k)

	   IF (Vadjust(i,j,age,m,k) >= Vnoadjust(i,j,age,m,k)) THEN
	   V(i,j,age,m,k) = Vadjust(i,j,age,m,k)
	   cchoice(i,j,age,m,k) = c_adj(i,j,age,m,k)
	   ELSE
	   V(i,j,age,m,k) = Vnoadjust(i,j,age,m,k)
	   cchoice(i,j,age,m,k) = c_nadj(i,j,age,m,k)
	   END IF
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


END DO


  DEALLOCATE( c_adj, c_nadj )

END SUBROUTINE sub_valueiterate
