program durables
 use share
 USE OMP_LIB
 use par_zig_mod

IMPLICIT NONE

  INTEGER :: i,j,k,l,m,i2,iter,mx_thread, thread, chk_thread
  REAL(8) :: y_ss, c_h_ss, step, r_beta_cons
  REAL(8), DIMENSION(pen_yr-1) :: u_coef1
  REAL(8) :: u_coef2
  REAL(8) :: t0,t1,tcalc
  INTEGER :: AllocateStatus, status

! VALUE FUNCTIONS AND POLICIES
! --------------
    REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk) :: &
	 Vnoadjust, Vadjust, V
    REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk) :: a_adj,  &
	a_nadj,  D_adj, cchoice

! SIMULATION
! --------------
    REAL(8), DIMENSION(:,:), ALLOCATABLE :: init_y, init_x, init_d
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: init_d_nadj, init_delta
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: age_t, alive_t
    REAL(8), DIMENSION(:,:), ALLOCATABLE :: n_shck, u_shck, p_t, dp_shck
    REAL(8), DIMENSION(:,:), ALLOCATABLE :: q_t, w_shck
    REAL(8), DIMENSION(:), ALLOCATABLE :: rk_t, v_shck
    INTEGER, DIMENSION(:), ALLOCATABLE :: coh0

! LIFECYCLE
! -------------
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: alive_t_lc
    REAL(8), DIMENSION(:,:), ALLOCATABLE :: e_shck_lc, u_shck_lc, w_shck_lc, &
	 p_t_lc, q_t_lc, rk_t_lc, dp_shck_lc

! SHOCKS
! -------------
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: init_y_shock, init_x_shock, init_d_shock
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: init_d_nadj_shock, init_delta_shock
    INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: alive_t_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: n_shck_shock,  dp_shck_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: u_shck_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: p_t_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: q_t_shock, w_shck_shock
    REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: rk_t_shock
    REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: v_shck_shock, m_shck_shock
    INTEGER, DIMENSION(:,:), ALLOCATABLE :: g_shck_shock

  ! IRFS
  ! -------------
      REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: init_y_irf, init_x_irf, init_d_irf
      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: init_d_nadj_irf, init_delta_irf
      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: alive_t_irf
      REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: n_shck_irf,  dp_shck_irf
      REAL(8), DIMENSION(:,:,:), ALLOCATABLE :: u_shck_irf
      REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: p_t_irf
      REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: q_t_irf, w_shck_irf
      REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: rk_t_irf
      REAL(8), DIMENSION(:,:,:,:), ALLOCATABLE :: v_shck_irf, m_shck_irf
      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: g_shck_irf

  OPEN(UNIT=1,FILE='omp_thread',STATUS='OLD',ACTION='READ',IOSTAT=status)
  READ(1,*,IOSTAT=status) thread
  CLOSE(1)

  !$OMP PARALLEL
  mx_thread = OMP_GET_MAX_THREADS()
  thread = MIN(thread,mx_thread)
  !$OMP END PARALLEL
  CALL OMP_SET_NUM_THREADS(thread)
  !$OMP PARALLEL
  chk_thread = OMP_get_num_threads()
  !$OMP END PARALLEL

  t0 = omp_get_wtime()

  tau = (kappa-1.d0)/kappa
  delta = (/ delta_1, delta_2 /)
  sigma_ar = SQRT( sigma_id**2 + sigma_ag**2 )
  sigma_ma_lc = SQRT( sigma_ma**2 + sigma_pve**2 )
  beta_pve = corr_pve_v*sigma_pve/sigma_ag
  sigma_pve_res = SQRT( sigma_pve**2 - beta_pve**2 * sigma_ag**2 )

  gnodes = 1.d0
  CALL sub_seriesin

  DO i=0,pen_yr-2
  u_coef1(i+1) = 1.d0/EXP( SUM( LOG(gnodes(twork-i:twork,2) ) ) )
  END DO
  u_coef2 = (1.d0 + SUM(u_coef1) )/pen_yr
  u_ret = zeta * u_coef2

  CALL sub_tauchen(enodes,Probe,Probecum,0.d0,0.d0,sigma_ar,ne,cover_e)
  CALL sub_tauchen(unodes,Probu,Probucum,0.d0,0.d0,sigma_ma_lc,nu,cover_u)
  DO i =1,ng
  sigma_q(i) = SQRT( h_shr(i)**2 * sigma_q_h**2 + s_shr(i)**2 * sigma_q_s**2 + &
	2.d0 * cov_q_hs * h_shr(i) * s_shr(i) )
  m_q(i) = -0.5 * sigma_q(i)**2
  m_q_h(i) = -0.5d0 * sigma_q_h**2 * h_shr(i)**2
  m_q_s(i) = -0.5d0 * sigma_q_s**2 * s_shr(i)**2
  CALL sub_tauchen(wnodes(:,i),Probw(:,:,i),Probwcum(:,:,i),0.d0,m_q(i),sigma_q(i),nw,cover_w)
  END DO
  CALL sub_tauchen(rknodes,Probrk,Probrkcum,rho_rk,LOG(rk),sigma_rk,nrk,cover_rk)
  enodes = exp(enodes)
  unodes = exp(unodes)
  wnodes = exp(wnodes)
  rknodes = exp(rknodes)
  emax = enodes(ne)
  emin = enodes(1)
  umax = unodes(nu)
  umin = unodes(1)
  wmax = MAXVAL( wnodes )
  wmin = MINVAL( wnodes )
  rkmax = rknodes(nrk)
  rkmin = rknodes(1)

  Probdp = reshape( (/ p_delta_1, 1.d0-p_delta_2, &
			1.d0-p_delta_1, p_delta_2 /), (/ndp,ndp/) )
  Probdpcum = reshape( (/ 1.d0-p_delta_2, 1.d0-p_delta_2, &
			p_delta_2, p_delta_2 /), (/ndp,ndp/) )

  m_delta = delta_2
  eta=(1.d0-m_delta-F)/(r+rk)

  Probg = reshape( (/ 1.d0-1.d0/g_dur, 0.d0, 1.d0/g_dur, 1.d0 /), (/ngp,ngp/) )

  step = ((amax-amin)/(DBLE(na)-1.0d0))
  anodes = (/ (amin + step*i, i = 0, na-1) /)
  anodes(na) = amax

  step = ((Dmax-Dmin)/(DBLE(nD)-1.0d0))
  Dnodes = (/ (Dmin + step*i, i = 0, nD-1) /)
  Dnodes(nD) = Dmax

  IF (amin - eta*Dmax >= 0.d0) THEN
  xmin = (amin-eta*Dmax)*r/(MAXVAL(gnodes)*MAXVAL(enodes)) + &
	(1.d0-MAXVAL(delta) )*Dmin + MIN(MINVAL(unodes),u_ret)
  ELSE
  xmin = (amin*(r+rkmax) + (1.d0-MAXVAL(delta)-(r+rkmax)*eta)*Dmin) &
	 /(MAXVAL(gnodes)*MAXVAL(enodes)) + MIN(MINVAL(unodes), u_ret)
  END IF
  xmax = r*(amax - eta*Dmax)*MAXVAL(wnodes) + (1.d0-MINVAL(delta))*Dmax + MAXVAL(unodes)

  step = ((xmax-xmin)/(DBLE(nx)-1.0d0))
  xnodes = (/ (xmin + step*i, i = 0, nx-1) /)
  xnodes(nx) = xmax

  zmin = xmin-F*Dmax
  zmax = xmax-F*Dmin
  step = ((zmax-zmin)/(DBLE(nz)-1.0d0))
  znodes = (/ (zmin + step*i, i = 0, nz-1) /)
  znodes(nz) = zmax

  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="REWIND")
  WRITE(555,*) ' BASELINE/FULL MODEL '
  WRITE(555,*) '    LOAN SPREAD SHOCKS= ', base_rate
  WRITE(555,*) '    GROWTH RATE SHOCK= ', base_growth
  CLOSE(555)


  CALL sub_valueiterate( Vnoadjust, Vadjust, V, a_adj,  &
	a_nadj,  D_adj, cchoice )

  IF ( (base_rate .EQV. .TRUE. ) .AND.  (base_growth .EQV. .TRUE. ) ) THEN
  OPEN (UNIT=1111, FILE="out/policy.txt", ACTION="WRITE", POSITION="REWIND")
    DO i=1,nx
      DO j=1,nD
       DO k=1,ng
        DO l=1,ndp
         DO m=1,ngp
          DO i2=1,nrk
                WRITE(1111,*) Vnoadjust(i,j,k,l,m,i2), Vadjust(i,j,k,l,m,i2), &
                  D_adj(i,j,k,l,m,i2)
           END DO
          END DO
         END DO
        END DO
      END DO
    END DO
  CLOSE(1111)

END IF


  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished finding policy fn. TIME: ', tcalc
  CLOSE(555)

  ALLOCATE( init_y(simlives,agents), init_x(simlives,agents), init_d(simlives,agents),  &
	n_shck(numsim,agents), u_shck(numsim,agents), p_t(numsim,agents), v_shck(numsim), dp_shck(numsim,agents), &
        q_t(numsim,ng), w_shck(numsim,ng), rk_t(numsim), &
        e_shck_lc(ng,agents), u_shck_lc(ng,agents), w_shck_lc(ng,agents), p_t_lc(ng,agents), &
	q_t_lc(ng,agents), rk_t_lc(ng,agents), dp_shck_lc(ng,agents), STAT=AllocateStatus  )

  ALLOCATE( age_t(numsim,agents), alive_t(numsim,agents), init_d_nadj(simlives,agents), init_delta(simlives,agents), &
	alive_t_lc(ng,agents), coh0(agents)  )

  CALL sub_shocks_a(init_y,init_x,init_d,init_d_nadj,init_delta,age_t,alive_t,&
	n_shck,u_shck,p_t,q_t,rk_t,v_shck,w_shck,dp_shck, &
	alive_t_lc,e_shck_lc,u_shck_lc,w_shck_lc,p_t_lc,q_t_lc,rk_t_lc,dp_shck_lc)

  t0 = omp_get_wtime()
  tcalc = t0-t1
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished generating shocks. TIME: ', tcalc
  CLOSE(555)

  IF ( (base_rate .EQV. .TRUE.) .AND. (base_growth .EQV. .TRUE.) ) THEN
  CALL sub_simulate(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y,init_x,init_d,init_d_nadj,init_delta,age_t,alive_t,&
	n_shck,u_shck,p_t,dp_shck,q_t,rk_t,v_shck,w_shck)

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished simulation. TIME: ', tcalc
  CLOSE(555)

  CALL sub_lifecycle(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y,init_x,init_d,init_d_nadj,init_delta,alive_t_lc,&
	e_shck_lc,u_shck_lc,p_t_lc,dp_shck_lc,q_t_lc,rk_t_lc,w_shck_lc)

  t0 = omp_get_wtime()
  tcalc = t0-t1
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished lifecycle. TIME: ', tcalc
  CLOSE(555)

  END IF

  DEALLOCATE( alive_t,n_shck,u_shck,p_t,dp_shck,q_t,rk_t,v_shck,w_shck )
  DEALLOCATE( init_y,init_x,init_d,init_d_nadj,init_delta, &
	alive_t_lc,e_shck_lc,u_shck_lc,p_t_lc,dp_shck_lc,q_t_lc,rk_t_lc,w_shck_lc )

  ALLOCATE( init_y_shock(shocklives,agents,rep), init_x_shock(shocklives,agents,rep), init_d_shock(shocklives,agents,rep), &
    n_shck_shock(numshock,agents,rep), u_shck_shock(numshock,agents,rep), dp_shck_shock(numshock,agents,rep), &
    p_t_shock(numshock,agents,rep,shck_c), v_shck_shock(numshock,twork,rep,shck_c), m_shck_shock(numshock,twork,rep,shck_c), &
    q_t_shock(numshock,ng,rep,shck_c), w_shck_shock(numshock,ng,rep,shck_c), &
    rk_t_shock(numshock,rep,shck_c), g_shck_shock(numshock,shck_c)  , STAT=AllocateStatus  )

  ALLOCATE( init_d_nadj_shock(shocklives,agents,rep), init_delta_shock(shocklives,agents,rep), &
	alive_t_shock(numshock,agents,rep) )

  CALL sub_shocks_b(age_t,init_y_shock, init_x_shock, init_d_shock,&
	init_d_nadj_shock,init_delta_shock, &
	alive_t_shock,n_shck_shock,u_shck_shock,p_t_shock,q_t_shock,rk_t_shock, &
	v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock,dp_shck_shock)

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished generating simulation shocks. TIME: ', tcalc
  CLOSE(555)

  CALL sub_shocksim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock,init_delta_shock,age_t,alive_t_shock, &
	n_shck_shock,u_shck_shock,p_t_shock,dp_shck_shock,q_t_shock,&
	rk_t_shock,v_shck_shock,m_shck_shock,w_shck_shock,g_shck_shock)

  DEALLOCATE( init_y_shock,init_x_shock,init_d_shock,init_d_nadj_shock, init_delta_shock, &
	alive_t_shock,n_shck_shock,u_shck_shock,p_t_shock,v_shck_shock,m_shck_shock, &
	dp_shck_shock, q_t_shock,rk_t_shock,w_shck_shock,g_shck_shock )

  t0 = omp_get_wtime()
  tcalc = t0-t1
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished shock sim. TIME: ', tcalc
  CLOSE(555)

  IF ( (base_rate .EQV. .TRUE.) .AND. (base_growth .EQV. .TRUE.) ) THEN

  ALLOCATE( init_y_irf(irflives,agents,rep_irf), init_x_irf(irflives,agents,rep_irf), init_d_irf(irflives,agents,rep_irf), &
    n_shck_irf(numirf,agents,rep_irf), u_shck_irf(numirf,agents,rep_irf), dp_shck_irf(numirf,agents,rep_irf), &
    p_t_irf(numirf,agents,rep_irf,irf_c), v_shck_irf(numirf,twork,rep_irf,irf_c), m_shck_irf(numirf,twork,rep_irf,irf_c), &
    q_t_irf(numirf,ng,rep_irf,irf_c), w_shck_irf(numirf,ng,rep_irf,irf_c), &
    rk_t_irf(numirf,ng,rep_irf,irf_c), g_shck_irf(numirf,ng,irf_c)  , STAT=AllocateStatus  )

  ALLOCATE( init_d_nadj_irf(irflives,agents,rep_irf), init_delta_irf(irflives,agents,rep_irf), &
	alive_t_irf(numirf,agents,rep_irf) )

  CALL sub_shocks_c(age_t,coh0,init_y_irf, init_x_irf, init_d_irf, &
    init_d_nadj_irf,init_delta_irf, &
  	alive_t_irf,n_shck_irf,u_shck_irf,p_t_irf,q_t_irf,rk_t_irf, &
  	v_shck_irf,m_shck_irf,w_shck_irf,g_shck_irf,dp_shck_irf)

  t1 = omp_get_wtime()
  tcalc = t1-t0
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished generating IRF shocks. TIME: ', tcalc
  CLOSE(555)

  CALL sub_irfsim(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
  	init_y_irf,init_x_irf,init_d_irf,init_d_nadj_irf,init_delta_irf,&
  	age_t,coh0,alive_t_irf, &
  	n_shck_irf,u_shck_irf,p_t_irf,dp_shck_irf,q_t_irf,rk_t_irf, &
  	v_shck_irf,m_shck_irf,w_shck_irf,g_shck_irf)

  DEALLOCATE( init_y_irf,init_x_irf,init_d_irf,init_d_nadj_irf, init_delta_irf, &
	alive_t_irf,n_shck_irf,u_shck_irf,p_t_irf,v_shck_irf,m_shck_irf, &
	dp_shck_irf, q_t_irf,rk_t_irf,w_shck_irf,g_shck_irf )

  t0 = omp_get_wtime()
  tcalc = t0-t1
  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' Finished IRF. TIME: ', tcalc
  CLOSE(555)


END IF

end program durables

REAL(8) FUNCTION fel(C,Dprime,equiv)

USE share
IMPLICIT NONE
REAL(8), INTENT(IN) :: C, Dprime, equiv

fel = ( ( (theta * ((C+1d-7)/equiv)**tau  + &
	(1.d0-theta)*(xi*(Dprime+1d-7)/equiv)**tau)**(1.d0/tau) )**(1.0d0-psi) - 1.d0 )/(1.0d0-psi)

END FUNCTION fel

SUBROUTINE sub_tauchen(y,pi,picum,rho,mu0,sigma,n,cover_tauchen)

	IMPLICIT NONE

	INTEGER, INTENT(in) :: n

	REAL(8), INTENT(in) :: rho, mu0, sigma, cover_tauchen
	REAL(8), DIMENSION (n,n), INTENT(out) :: pi , picum
	REAL(8), DIMENSION (n), INTENT(out) :: y

	INTEGER :: yc, tc, tcc,i1

	REAL(8) :: sigy, mu, upp, low
	REAL(8), EXTERNAL  :: cum_normal

	! Define the discrete states of the Markov chain

	sigy = sigma/SQRT(1.0-rho**2)

	y(n) = mu0 + cover_tauchen*sigy
	y(1) = mu0 - cover_tauchen*sigy

	DO yc = 2, n-1

		y(yc) = y(1)+(y(n)-y(1))*(yc-1.0)/(n-1.0)

	END DO

	! Compute the transition matrix

	DO tc = 1,n
		mu = (1-rho)*mu0 + rho*y(tc)
		upp = (y(2)+y(1))/2.0
		upp = (upp-mu)/sigma
		pi(tc,1) = cum_normal(upp)
		low = (y(n)+y(n-1))/2.0
		low = (low-mu)/sigma
		pi(tc,n) = 1.d0-cum_normal(low)

		DO tcc = 2, n-1

			low = (y(tcc-1)+y(tcc))/2.0
			upp = (y(tcc+1)+y(tcc))/2.0
			low = (low-mu)/sigma
			upp = (upp-mu)/sigma
			pi(tc,tcc) = cum_normal(upp)-cum_normal(low)

		END DO
	END DO

	! Compute the CDF of the transition matrix.
	picum(:,1)=pi(:,1)
	DO tc = 2,n
		picum(:,tc)=picum(:,tc-1)+pi(:,tc)
	ENDDO


END SUBROUTINE sub_tauchen

FUNCTION cum_normal(X)
  ! Returns the value of the cumulative density of the Standard Normal
  ! Distribution at point X

  IMPLICIT NONE
  REAL(8), INTENT(in)  :: X
  REAL(8) 		:: cum_normal

  cum_normal =  0.5d0*( 1+erf(x/SQRT(2.d0)) )

END FUNCTION cum_normal
