SUBROUTINE sub_lifecycle(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj, &
	init_y,init_x,init_d,init_d_nadj,init_delta,alive_t_lc,e_shck_lc,u_shck_lc, &
	p_t_lc,dp_shck_lc,q_t_lc,rk_t_lc,w_shck_lc)

USE OMP_LIB
USE share

IMPLICIT NONE
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: Vnoadjust, Vadjust
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(IN) :: a_adj, a_nadj,  D_adj
  REAL(8), DIMENSION(simlives,agents), INTENT(IN) :: init_y, init_x, init_d
  INTEGER, DIMENSION(simlives,agents), INTENT(IN) :: init_d_nadj
  INTEGER, DIMENSION(simlives,agents), INTENT(IN) :: init_delta
  INTEGER, DIMENSION(ng,agents), INTENT(IN) :: alive_t_lc
  REAL(8), DIMENSION(ng,agents), INTENT(IN) :: e_shck_lc,u_shck_lc,p_t_lc, &
	q_t_lc, rk_t_lc, w_shck_lc,dp_shck_lc

  INTEGER :: i, j
  REAL(8), DIMENSION(agents) :: idcross, ixcross, &
	 	idpcross, iapcross, iccross
  REAL(8), DIMENSION(agents) :: iicross, iadjcross, ikcross, ikpcross, ibcross, &
		ibpcross,  imcross, impcross
  REAL(8), DIMENSION(agents) :: ic_realcross, id_realcross, ilc_realcross, &
		ild_realcross, ivalnewcar
  INTEGER, DIMENSION(agents) :: adjcross, inewcar, ideltacross
  REAL(8), DIMENSION(ng+1) :: cts, lcts, alive
  REAL(8), DIMENSION(ng+1) :: dts, ldts
  INTEGER :: age
  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8) :: c_ldiffp1max, d_ldiffp1max
	INTEGER :: c_maxage, d_maxage

  cts=0.d0
  dts=0.d0

  !$OMP PARALLEL DO
  DO i=1,agents
    IF ( init_x(1,i) >= 0.d0) THEN
    ikcross(i) = ( init_x(1,i) )/r
    imcross(i) = init_x(1,i) / (r*q_t_lc(1,i))
    ibcross(i) = 0.d0
    ELSE
    ibcross(i) = ABS( init_x(1,i) )/(r+rk_t_lc(1,i))
    ikcross(i) = 0.d0
    imcross(i) = 0.d0
    END IF
  ideltacross(i) = init_delta(1,i)
  idcross(i) = init_d(1,i)/p_t_lc(1,i)
  idcross(i) = MIN( MAX( idcross(i), Dmin), Dmax)
  ixcross(i) = init_x(1,i)/p_t_lc(1,i) + &
	 (1.d0-delta(ideltacross(i)))*idcross(i) + u_shck_lc(1,i)
  ixcross(i) = MIN( MAX( ixcross(i), xmin), xmax)

  init_loc(i) = 2

   IF (init_d_nadj(1,i)==1) THEN
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), 1, ideltacross(i), gnorm, rk_t_lc(1,i),&
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   idcross(i) = idpcross(i)
   ideltacross(i) = 2
     IF ( (ixcross(i)-(1.d0-delta(ideltacross(i)))*idcross(i)-u_shck_lc(1,i))/(r+rk)<-eta*idcross(i) ) THEN
     ixcross(i) = (1.d0-delta(ideltacross(i))-eta*(r+rk))*idcross(i) + u_shck_lc(1,i)
     END IF
   END IF
  END DO
  !$OMP END PARALLEL DO

  age1: DO age = 1, ng
  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   CALL sub_pollin( Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	 ixcross(i), idcross(i), age, ideltacross(i), gnorm, rk_t_lc(age,i), &
	 iapcross(i), idpcross(i), iccross(i), adjcross(i) )
   IF (alive_t_lc(age,i)==1) THEN
     ic_realcross(i) = iccross(i) * p_t_lc(age,i)
     id_realcross(i) = idcross(i) * p_t_lc(age,i)
     ilc_realcross(i) = LOG( MAX(ic_realcross(i),1d-6) )
     ild_realcross(i) = LOG( MAX(id_realcross(i),1d-6) )
     iicross(i) = (idpcross(i) - (1.d0-delta(ideltacross(i)))*idcross(i)) * p_t_lc(age,i)
       IF (adjcross(i)==2 .AND. &
		idpcross(i) > (1.d0-delta(ideltacross(i)))*idcross(i)) THEN
       inewcar(i) = 1
       ivalnewcar(i) = (idpcross(i) - idcross(i)) * p_t_lc(age,i)
       ELSE
       inewcar(i) = 0
       ivalnewcar(i) = 0.d0
       END IF

      IF (adjcross(i)==2) THEN
         ideltacross(i) = 2
       ELSE

         IF ( dp_shck_lc(age,i) <= Probdp(ideltacross(i),1) ) THEN
         ideltacross(i) = 1
         ELSE
         ideltacross(i) = 2
         END IF
       END IF

       IF (iapcross(i)>=eta*idpcross(i)) THEN
       ikpcross(i) = (iapcross(i)- eta*idpcross(i))*p_t_lc(age,i)
         IF (age<ng) THEN
         impcross(i) = ikpcross(i) / q_t_lc(age,i)
         ELSE
         impcross(i) = 0.d0
         END IF
       ibpcross(i) = 0.d0
       ELSE
       ibpcross(i) = ABS(iapcross(i)- eta*idpcross(i))*p_t_lc(age,i)
       ikpcross(i) = 0.d0
       impcross(i) = 0.d0
       END IF

   ELSE
   ic_realcross(i)=0.d0
   ilc_realcross(i)=0.d0
   id_realcross(i)=0.d0
   ild_realcross(i)=0.d0
   ikcross(i)=0.d0
   ibcross(i)=0.d0
   imcross(i)=0.d0
   END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

	alive(age) =  SUM(DBLE(alive_t_lc(age,:)))
  cts(age)   = SUM( ic_realcross ) / SUM(DBLE(alive_t_lc(age,:)))
  lcts(age)   = SUM( ilc_realcross ) / SUM(DBLE(alive_t_lc(age,:)))
  dts(age) = SUM( id_realcross ) / SUM(DBLE(alive_t_lc(age,:)))
  ldts(age) = SUM( ild_realcross ) / SUM(DBLE(alive_t_lc(age,:)))

  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
   IF (age<ng) THEN
     IF(age<twork) THEN
     idcross(i) = idpcross(i)/ &
		(gnodes(age+1,gnorm)*e_shck_lc(age+1,i))
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_lc(age+1,i) * r * (iapcross(i)-eta*idpcross(i)) / &
		(gnodes(age+1,gnorm)*e_shck_lc(age+1,i)) + &
		(1.d0-delta(ideltacross(i)))*idcross(i) + u_shck_lc(age+1,i)
     ELSE
     ixcross(i) = (r+rk_t_lc(age+1,i))*( iapcross(i)-eta*idpcross(i) ) / &
		(gnodes(age+1,gnorm)*e_shck_lc(age+1,i)) + &
		(1.d0-delta(ideltacross(i)))*idcross(i) + u_shck_lc(age+1,i)
     END IF

     ELSE
     idcross(i) = idpcross(i)/ gnodes(age+1,gnorm)
     IF (iapcross(i) > eta*idpcross(i)) THEN
     ixcross(i) = w_shck_lc(age+1,i) * r * (iapcross(i)-eta*idpcross(i)) / &
		gnodes(age+1,gnorm) + &
		(1.d0-delta(ideltacross(i)))*idcross(i) + u_ret
     ELSE
     ixcross(i) = (r+rk_t_lc(age+1,i))*( iapcross(i)-eta*idpcross(i) ) / &
		   gnodes(age+1,gnorm) + &
		   (1.d0-delta(ideltacross(i)))*idcross(i) + u_ret
     END IF

     END IF
     ikcross(i) = ikpcross(i)
     ibcross(i) = ibpcross(i)
     imcross(i) = impcross(i)
   ELSE
   id_realcross(i) = idpcross(i) * p_t_lc(age,i)
   ild_realcross(i) = LOG( MAX(id_realcross(i),1d-6) )
   END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END DO age1

  !$OMP PARALLEL
  !$OMP DO
   DO i = 1, agents
     IF (alive_t_lc(ng,i)==0) THEN
     id_realcross(i) = 0.d0
     ild_realcross(i) = 0.d0
     END IF
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  dts(ng+1) = SUM( id_realcross ) / SUM(DBLE(alive_t_lc(ng,:)))
  ldts(ng+1) = SUM( ild_realcross ) / SUM(DBLE(alive_t_lc(ng,:)))

  c_maxage = 24 + MAXLOC(lcts(1:ng-2), 1)
  d_maxage = 24 + MAXLOC(ldts(1:ng-2), 1)
  c_ldiffp1max = 100.d0 * ( MAXVAL(lcts(:ng-2)) - lcts(1) )
  d_ldiffp1max = 100.d0 * ( MAXVAL(ldts(:ng-2)) - ldts(1) )

  OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) '  '
  WRITE(555,*) ' LIFECYCLE MOMENTS '
  WRITE(555,*) ' ------------------ '
	WRITE(555,*) '                                      model               (data) '
	WRITE(555,*) ' Lifecycle growth in non-durables:  ', c_ldiffp1max, ' (41.9) '
	WRITE(555,*) ' Lifecycle growth in car stock:     ', d_ldiffp1max, ' (60.5) '
  WRITE(555,*) ' Age of max C:                      ', c_maxage, ' (45) '
  WRITE(555,*) ' Age of max D:                      ', d_maxage, ' (53) '

  CLOSE(555)

END SUBROUTINE sub_lifecycle
