  SUBROUTINE sub_shocks_a(init_y,init_x,init_d,init_d_nadj,init_delta, &
	age_t,alive_t,n_shck,u_shck,p_t,q_t,rk_t,v_shck,w_shck,dp_shck, &
	alive_t_lc,e_shck_lc,u_shck_lc,w_shck_lc,p_t_lc,q_t_lc,rk_t_lc,dp_shck_lc)

  USE share
  USE OMP_LIB
  USE par_zig_mod

  IMPLICIT NONE

! SIMULATION
! --------------
  REAL(8), DIMENSION(simlives,agents), INTENT(OUT) :: init_y, init_x, init_d
  REAL(8), DIMENSION(simlives,agents) :: init_k
  INTEGER, DIMENSION(simlives,agents), INTENT(OUT) :: init_d_nadj
  INTEGER, DIMENSION(simlives,agents), INTENT(OUT) :: init_delta
  INTEGER, DIMENSION(numsim,agents), INTENT(OUT) :: age_t, alive_t
  REAL(8), DIMENSION(numsim,agents), INTENT(OUT) :: n_shck, u_shck, p_t, dp_shck
  REAL(8), DIMENSION(numsim,ng), INTENT(OUT) :: q_t, w_shck
  REAL(8), DIMENSION(numsim), INTENT(OUT) :: rk_t, v_shck
  REAL(8), DIMENSION(numsim) :: rk_shck

  REAL(8), DIMENSION(numsim) :: m_shck

! LIFECYCLE
! -------------
  INTEGER, DIMENSION(ng,agents), INTENT(OUT) :: alive_t_lc
  REAL(8), DIMENSION(ng,agents), INTENT(OUT) :: e_shck_lc, u_shck_lc, w_shck_lc, &
	p_t_lc, q_t_lc, rk_t_lc, dp_shck_lc
  REAL(8), DIMENSION(ng,agents) :: rk_shck_lc

  REAL(8) :: rand_shock
  REAL(8), DIMENSION(agents) :: rand_shock_vec
  INTEGER :: j, time, i, k, age_temp, age_counter, wts_count

  INTEGER, DIMENSION(agents) :: init_loc

  INTEGER  :: reset, npar, numthreads
  INTEGER, DIMENSION(agents)  :: kpar
  INTEGER, DIMENSION(:), ALLOCATABLE :: seed
  INTEGER :: grainsize = 32

  !$OMP PARALLEL
  !$OMP DO
  DO i=1, agents
  init_y(:,i) = 0.d0
  init_d(:,i) = 0.d0
  init_d_nadj(:,i) = 0
  init_k(:,i) = 0.d0
  init_x(:,i) = 0.d0
  init_delta(:,i) = 0
  n_shck(:,i) = 0.d0
  u_shck(:,i) = 0.d0
  p_t(:,i) = 0.d0
  dp_shck(:,i) = 0.d0
  age_t(:,i) = 0
  alive_t(:,i) = 0
  alive_t_lc(:,i) = 0
  e_shck_lc(:,i) = 0.d0
  u_shck_lc(:,i) = 0.d0
  w_shck_lc(:,i) = 0.d0
  p_t_lc(:,i) = 0.d0
  dp_shck_lc(:,i) = 0.d0
  q_t_lc(:,i) = 0.d0
  rk_t_lc(:,i) = 0.d0
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  rk_t = 0.d0
  v_shck = 0.d0
  m_shck = 0.d0
  w_shck = 0.d0
  q_t = 0.d0

  !$OMP PARALLEL
  numthreads = OMP_get_num_threads()
  !$OMP END PARALLEL
  reset=0
  npar=numthreads+1

  ALLOCATE( seed(npar) )
  DO i = 1,npar
        seed(i) = 12345678 * i
  END DO

  CALL par_zigset(npar, seed, grainsize,reset)

  DO time =1,simlives
  !$OMP PARALLEL
  !$OMP DO
       DO i=1, agents
          kpar(i) = omp_get_thread_num()+1

	  rand_shock_vec(i)=par_rnor(kpar(i))
	  init_y(time,i) = EXP( ily_age1 + ily_stdage1 * rand_shock_vec(i) )

	  rand_shock_vec(i)=par_rnor(kpar(i))
	  init_d(time,i) = EXP( ild_age1 + ild_stdage1 * rand_shock_vec(i) )
	  rand_shock_vec(i)=par_uni(kpar(i))
          IF ( rand_shock_vec(i)> p_adj_0 * p_adj_0_tune ) THEN
	  init_d_nadj(time,i) = 1
          END IF

    rand_shock_vec(i)=par_rnor(kpar(i))
	  init_x(time,i) = MAX( ik_age1 + ik_stdage1 * rand_shock_vec(i), -eta*init_d(time,i) )
          IF (init_x(time,i) >0.d0) THEN
          init_x(time,i) = init_x(time,i) * r
          ELSE
          init_x(time,i) = init_x(time,i) * (r + rk)
          END IF
          rand_shock_vec(i)=par_uni(kpar(i))
          IF (rand_shock_vec(i) <= Probdpcum(1,1) ) THEN
          init_delta(time,i) = 1
          ELSE
          init_delta(time,i) = 2
          END IF
       END DO
  !$OMP END DO
  !$OMP END PARALLEL
  END DO


  !$OMP PARALLEL
  !$OMP DO
  DO i=1,agents
  kpar(i) = omp_get_thread_num()+1
  rand_shock_vec(i)=par_rnor(kpar(i))
  u_shck(1,i) = EXP( sigma_ma * rand_shock_vec(i) )
  p_t(1,i) = init_y(1,i)/u_shck(1,i)
  init_loc(i) = 2
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  alive_t(1,:) =1
  age_temp = 1
  age_counter = 1
  DO i=1, agents
    IF (age_counter>agent_age) THEN
    age_temp = age_temp +1
    age_counter = 1
    END IF
  age_t(1,i) = age_temp
  age_counter = age_counter+1
  END DO
  w_shck = 1.d0
  q_t(1,:) = 1.d0
  rk_t(1) = LOG(rk)

  !$OMP PARALLEL
  !$OMP DO
  DO i=1,agents
  kpar(i) = omp_get_thread_num()+1
  rand_shock_vec(i)=par_rnor(kpar(i))
  u_shck_lc(1,i) = EXP( sigma_ma * rand_shock_vec(i) )
  p_t_lc(1,i) = init_y(1,i)/u_shck_lc(1,i)
  q_t_lc(1,i) = 1.d0
  rand_shock_vec(i)=par_rnor(kpar(i))
  rk_t_lc(1,i) = sigma_rk / SQRT(1.d0-rho_rk**2) * rand_shock_vec(i)
  END DO
  !$OMP END DO
  !$OMP END PARALLEL
  alive_t_lc(1,:) =1

  DO time =1,numsim
    rand_shock_vec(1)=par_rnor(kpar(1))
    v_shck(time) = EXP( sigma_ag * rand_shock_vec(1) )
    rand_shock_vec(1)=par_rnor(kpar(1))
    m_shck(time) = v_shck(time)**(beta_pve) * EXP( rand_shock_vec(1) *sigma_pve_res )
    rand_shock_vec(1)=par_rnor(kpar(1))
    DO i=1,ng
    w_shck(time,i) = EXP( m_q(i) + sigma_q(i) * rand_shock_vec(1) )
    END DO
    rand_shock_vec(1)=par_rnor(kpar(1))
    rk_shck(time) = sigma_rk * rand_shock_vec(1)
    IF(time>1) THEN
      	!$OMP PARALLEL
      	!$OMP DO
        DO i=2,ng
	          q_t(time,i) = q_t(time-1,i-1)*w_shck(time,i)
        END DO
        !$OMP END DO
        !$OMP END PARALLEL
        q_t(time,1) = SUM( q_t(time,2:) )/DBLE(ng-1)
        rk_t(time) = m_rk*(1.d0-rho_rk) + rho_rk * rk_t(time-1) + &
		rk_shck(time)
    END IF
  END DO
  rk_t = EXP(rk_t)

  !$OMP PARALLEL
  !$OMP DO
       DO i=1, agents
       kpar(i) = omp_get_thread_num()+1
        DO time =1,numsim
	rand_shock_vec(i)=par_rnor(kpar(i))
	n_shck(time,i) = EXP( sigma_id * rand_shock_vec(i) )
	IF (time>1) THEN
	rand_shock_vec(i)=par_rnor(kpar(i))
	u_shck(time,i) = EXP( sigma_ma * rand_shock_vec(i) )
          IF (age_t(time,i)==1) THEN
          init_y(init_loc(i),i) =  init_y(init_loc(i),i)*v_shck(time)
   	  p_t(time,i) = init_y(init_loc(i),i)/u_shck(time,i)
          init_loc(i) = init_loc(i) + 1
	  ELSE
                IF (age_t(time,i)<=twork) THEN
		p_t(time,i) = gnodes(age_t(time,i),gnorm)*p_t(time-1,i) &
				*n_shck(time,i)*v_shck(time)
                ELSE
 		p_t(time,i) = gnodes(age_t(time,i),gnorm)*p_t(time-1,i)
                END IF
	  END IF
          u_shck(time,i) = u_shck(time,i)*m_shck(time)
	END IF

	IF (time<numsim) THEN
	  IF (age_t(time,i)<ng) THEN
	  age_t(time+1,i) = age_t(time,i) + 1
	  IF (alive_t(time,i)== 1) THEN
            rand_shock_vec(i)=par_uni(kpar(i))
	    	IF( rand_shock_vec(i)<betanodes(age_t(time,i)) ) THEN
	 	alive_t(time+1,i) = 1
		ELSE
		alive_t(time+1,i) = 0
		END IF
	  END IF

	  ELSE
	  age_t(time+1,i) = 1
	  alive_t(time+1,i) = 1
 	  END IF
	END IF
        dp_shck(time,i)=par_uni(kpar(i))
        END DO
       END DO
  !$OMP END DO
  !$OMP END PARALLEL


  !$OMP PARALLEL
  !$OMP DO
     DO i=1, agents
     kpar(i) = omp_get_thread_num()+1
        DO time =1,ng
	rand_shock_vec(i)=par_rnor(kpar(i))
	e_shck_lc(time,i) = EXP( sigma_ar * rand_shock_vec(i) )
	rand_shock_vec(i)=par_rnor(kpar(i))
	w_shck_lc(time,i) = EXP( m_q(time) + sigma_q(time) * rand_shock_vec(i) )
    	rand_shock_vec(i)=par_rnor(kpar(i))
    	rk_shck_lc(time,i) = sigma_rk * rand_shock_vec(i)
        IF (time>1) THEN
	rand_shock_vec(i)=par_rnor(kpar(i))
	u_shck_lc(time,i) = EXP( sigma_ma_lc * rand_shock_vec(i) )
          IF (time<=twork) THEN
          p_t_lc(time,i) = gnodes(time,gnorm)*p_t_lc(time-1,i)*e_shck_lc(time,i)
          ELSE
 	  p_t_lc(time,i) = gnodes(time,gnorm)*p_t_lc(time-1,i)
          END IF
 	q_t_lc(time,i) = q_t_lc(time-1,i)*w_shck_lc(time,i)
    	rk_t_lc(time,i) = LOG(rk)*(1.d0-rho_rk) + rho_rk * rk_t_lc(time-1,i) + &
		rk_shck_lc(time,i)
        END IF
	IF (time<ng) THEN
	  IF (alive_t_lc(time,i)== 1) THEN
            rand_shock_vec(i)=par_uni(kpar(i))
	    IF( rand_shock_vec(i)<betanodes(time) ) THEN
	    alive_t_lc(time+1,i) = 1
	    ELSE
	    alive_t_lc(time+1,i) = 0
            END IF
	  END IF
	END IF
        dp_shck_lc(time,i)=par_uni(kpar(i))
       END DO
     END DO
  !$OMP END DO
  !$OMP END PARALLEL

  rk_t_lc = EXP(rk_t_lc)

  END SUBROUTINE sub_shocks_a
