subroutine sub_valueiterate(Vnoadjust, Vadjust, V, a_adj,  &
	a_nadj,  D_adj, cchoice )
  USE OMP_LIB
  USE SHARE
  IMPLICIT NONE

  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(OUT) :: Vnoadjust, Vadjust, V
  REAL(8), DIMENSION(nx,nD,ng,ndp,ngp,nrk), INTENT(OUT) :: a_adj,  &
	a_nadj,  D_adj, cchoice

  REAL(8), DIMENSION(:,:,:,:,:,:), ALLOCATABLE :: c_adj, c_nadj

  INTEGER :: i,iter,j,k,l,m,o,p,i2,j2,k2,k3,l2,m2,o2
  REAL(8), DIMENSION(nD*na) :: adj_hold
  REAL(8), DIMENSION(na) :: nadj_hold
  REAL(8), DIMENSION(nz,ngp,nrk) :: Vadjust_z, a_adj_z,  D_adj_z
  REAL(8), DIMENSION(na,nD,ngp,nrk) :: EV
  REAL(8), DIMENSION(na,nD,ndp,ngp,nrk) ::  EVn
  REAL(8), DIMENSION(nD,ne,ngp) :: Dp, Dp_w
  REAL(8), DIMENSION(nD,ndp,ne,ngp) :: Dp_nadj, Dp_nadj_w
  INTEGER, DIMENSION(nD,ne,ngp) :: Dp_nodes
  INTEGER, DIMENSION(nD,ndp,ne,ngp) :: Dp_nadj_nodes
  REAL(8), DIMENSION(na,nD,ne,nu,nw,ngp,nrk) :: xp, xp_w
  REAL(8), DIMENSION(na,nD,ne,nu,nw,ndp*ndp*ngp,nrk) :: xp_nadj, xp_nadj_w
  INTEGER, DIMENSION(na,nD,ne,nu,nw,ngp,nrk) :: xpnodes
  INTEGER, DIMENSION(na,nD,ne,nu,nw,ndp*ndp*ngp,nrk) :: xp_nadj_nodes
  REAL(8), DIMENSION(nx,nD) :: adjust_resource, zweight
  INTEGER, DIMENSION(nx,nD) :: z_intnodes
  INTEGER, DIMENSION(nD*na) :: dummy_choice_a, dummy_choice_D
  REAL(8), DIMENSION(2) :: V_hold
  INTEGER :: choice, index1
  REAL(8) :: C, D_hold
  INTEGER :: age

  REAL(8), EXTERNAL :: fel

  ALLOCATE(  c_adj(nx,nD,ng,ndp,ngp,nrk), c_nadj(nx,nD,ng,ndp,ngp,nrk)  )

IF (nz<nx) THEN
  OPEN (UNIT=555, FILE="out/out/Output.txt", STATUS="OLD", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' WARNING! nz<nx '
  CLOSE(555)
END IF

  !$OMP PARALLEL DO
   DO j=1,nD
   Vnoadjust(:,j,:,:,:,:) = 0.d0
   Vadjust(:,j,:,:,:,:) = 0.d0
   V(:,j,:,:,:,:) = 0.d0
   a_adj(:,j,:,:,:,:) = 0.d0
   a_nadj(:,j,:,:,:,:) = 0.d0
   D_adj(:,j,:,:,:,:) = 0.d0
   c_adj(:,j,:,:,:,:) = 0.d0
   c_nadj(:,j,:,:,:,:) = 0.d0
   cchoice(:,j,:,:,:,:) = 0.d0
   EV(:,j,:,:) = 0.d0
   EVn(:,j,:,:,:) = 0.d0
   Dp(j,:,:) = 0.d0
   Dp_w(j,:,:) = 0.d0
   Dp_nadj(j,:,:,:) = 0.d0
   Dp_nadj_w(j,:,:,:) = 0.d0
   Dp_nodes(j,:,:) = 0
   Dp_nadj_nodes(j,:,:,:) = 0
   xp(:,j,:,:,:,:,:) = 0.d0
   xp_w(:,j,:,:,:,:,:) = 0.d0
   xp_nadj(:,j,:,:,:,:,:) = 0.d0
   xp_nadj_w(:,j,:,:,:,:,:) = 0.d0
   xpnodes(:,j,:,:,:,:,:) = 0
   xp_nadj_nodes(:,j,:,:,:,:,:) = 0
   END DO
  !$OMP END PARALLEL DO

DO i=1,na
 DO j=1,nD
  index1 = (i-1)*nD + j
  dummy_choice_a( index1 ) = i
  dummy_choice_D( index1 ) = j
 END DO
END DO

DO i=1,nx
 DO j=1,nD
   adjust_resource(i,j) = xnodes(i) - F*Dnodes(j)
   CALL sub_intpnode(nz,znodes,adjust_resource(i,j),z_intnodes(i,j),zweight(i,j))
 END DO
END DO

! Age=trest+twork (a'=eta*D', no assets remaining, no debt)
! ---------------

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,adj_hold)
   DO j=1,nz
       DO j2=1,nD
         C = znodes(j)-Dnodes(j2)
         IF (C>0.d0) THEN
         adj_hold(j2) = fel( C,Dnodes(j2), eqvnodes(ng) )
         ELSE
         C = cmin
         adj_hold(j2) = vmin
         END IF
       END DO
      choice = MAXLOC( adj_hold(:nD), 1)
      Vadjust_z(j,:,:) = adj_hold(choice)
      a_adj_z(j,:,:) = eta*Dnodes( dummy_choice_D(choice) )
      D_adj_z(j,:,:) = Dnodes( dummy_choice_D(choice) )
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold)
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
       D_hold = (1.d0-delta(k)*(1.d0-gamma))*Dnodes(j)
       C = xnodes(i) - D_hold
       IF (C>0.d0) THEN
       c_nadj(i,j,ng,k,:,:) = C
       Vnoadjust(i,j,ng,k,:,:) = fel( c_nadj(i,j,ng,k,gnorm,nrk), D_hold, eqvnodes(ng) )
       ELSE
       c_nadj(i,j,ng,k,:,:) = cmin
       Vnoadjust(i,j,ng,k,:,:) = vmin
       END IF
       a_nadj(i,j,ng,k,:,:) = eta*D_hold
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
       Vadjust(i,j,ng,:,:,:) = zweight(i,j)*Vadjust_z( z_intnodes(i,j),gnorm,nrk) + &
		            (1.d0-zweight(i,j))*Vadjust_z( z_intnodes(i,j)+1,gnorm,nrk)
       D_adj(i,j,ng,:,:,:) = zweight(i,j)*D_adj_z( z_intnodes(i,j),gnorm,nrk) + &
		            (1.d0-zweight(i,j))*D_adj_z( z_intnodes(i,j)+1,gnorm,nrk)
       a_adj(i,j,ng,:,:,:) = eta*D_adj(i,j,ng,ndp,gnorm,nrk)
       c_adj(i,j,ng,:,:,:) = adjust_resource(i,j) - D_adj(i,j,ng,ndp,gnorm,nrk)


    DO k=1,ndp
	   IF (Vadjust(i,j,ng,k,gnorm,nrk) >= Vnoadjust(i,j,ng,k,gnorm,nrk)) THEN
	   V(i,j,ng,k,:,:) = Vadjust(i,j,ng,k,gnorm,nrk)
	   cchoice(i,j,ng,k,:,:) = c_adj(i,j,ng,k,gnorm,nrk)
	   ELSE
	   V(i,j,ng,k,:,:) = Vnoadjust(i,j,ng,k,gnorm,nrk)
	   cchoice(i,j,ng,k,:,:) = c_nadj(i,j,ng,k,gnorm,nrk)
	   END IF
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

! Age<trest+twork
! ---------------
DO age = ng-1,1,-1

  IF (age>=twork) THEN
 ! When retired
 ! ------------
  !$OMP PARALLEL DO PRIVATE(l2)
	  DO j=1,nD
           DO l=1,ngp

	   Dp(j,1,l) = Dnodes(j) / gnodes(age+1,l)
	   CALL sub_intpnode(nD,Dnodes,Dp(j,1,l),Dp_nodes(j,1,l),Dp_w(j,1,l))
           DO k=1,ndp
	   Dp_nadj(j,k,1,l) = (1.d0-delta(k)*(1-gamma))*Dnodes(j) / gnodes(age+1,l)
	   CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,k,1,l),Dp_nadj_nodes(j,k,1,l),Dp_nadj_w(j,k,1,l))
           END DO
	 DO i=1,na
          DO k=1,nw
           DO m=1,nrk
	    IF (anodes(i) >= eta*Dnodes(j)) THEN
	    xp(i,j,1,1,k,l,m) = wnodes(k,age+1) * r*(anodes(i)-eta*Dnodes(j)) / gnodes(age+1,l) + &
				(1.d0-delta(ndp)) * Dnodes(j) / gnodes(age+1,l) + u_ret
	    ELSE
	    xp(i,j,1,1,k,l,m) = (r+rknodes(m))*(anodes(i)-eta*Dnodes(j))  &
				/ gnodes(age+1,l) + &
				(1.d0-delta(ndp)) * Dnodes(j) / gnodes(age+1,l) + u_ret
	    END IF
	    CALL sub_intpnode(nx,xnodes,xp(i,j,1,1,k,l,m),xpnodes(i,j,1,1,k,l,m),xp_w(i,j,1,1,k,l,m))

              DO k2=1,ndp
               DO k3=1,ndp
               l2= (k2-1)*ndp*ngp + (k3-1)*ngp + l
   	      IF ( anodes(i) >= eta*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j) ) THEN
	      xp_nadj(i,j,1,1,k,l2,m) = wnodes(k,age+1) * r * (anodes(i)-eta*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j)) &
				/ gnodes(age+1,l) + &
				(1.d0-delta(k3))*(1.d0-delta(k2)*(1-gamma))*Dnodes(j) / gnodes(age+1,l) + u_ret
	      ELSE
	      xp_nadj(i,j,1,1,k,l2,m) = (r+rknodes(m))*(anodes(i)-eta*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j)) &
				/ gnodes(age+1,l) + &
				(1.d0-delta(k3))*(1.d0-delta(k2)*(1-gamma))*Dnodes(j) / gnodes(age+1,l) + u_ret
	      END IF
	      CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,1,1,k,l2,m),xp_nadj_nodes(i,j,1,1,k,l2,m),xp_nadj_w(i,j,1,1,k,l2,m))
               END DO
              END DO
             END DO
            END DO
	   END DO
	  END DO
	 END DO
  !$OMP END PARALLEL DO

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold,l2)
  DO j=1,nD
    DO i=1,na
     DO i2=1,ngp
      DO j2=1,nrk
      EV(i,j,i2,j2) = 0.d0

      DO k=1,nw
        DO l=1,ngp
         DO m=1,nrk
        V_hold(1) =     xp_w(i,j,1,1,k,l,m)*Dp_w(j,1,l)*Vnoadjust(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l),age+1,ndp,l,m) + &
	 		xp_w(i,j,1,1,k,l,m)*(1.d0-Dp_w(j,1,l))*Vnoadjust(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l)+1,age+1,ndp,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*Dp_w(j,1,l)*Vnoadjust(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l),age+1,ndp,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*(1.d0-Dp_w(j,1,l))*Vnoadjust(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l)+1,age+1,ndp,l,m)
        V_hold(2) =     xp_w(i,j,1,1,k,l,m)*Dp_w(j,1,l)*Vadjust(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l),age+1,ndp,l,m) + &
	 		xp_w(i,j,1,1,k,l,m)*(1.d0-Dp_w(j,1,l))*Vadjust(xpnodes(i,j,1,1,k,l,m),Dp_nodes(j,1,l)+1,age+1,ndp,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*Dp_w(j,1,l)*Vadjust(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l),age+1,ndp,l,m) + &
			(1.d0-xp_w(i,j,1,1,k,l,m))*(1.d0-Dp_w(j,1,l))*Vadjust(xpnodes(i,j,1,1,k,l,m)+1,Dp_nodes(j,1,l)+1,age+1,ndp,l,m)
        EV(i,j,i2,j2) =  EV(i,j,i2,j2) + beta * betanodes(age)*  Probw(1,k,age+1) * Probg(i2,l) * Probrk(j2,m) *&
			(gnodes(age+1,l)**(1.d0-psi)) * MAXVAL( V_hold ,1 )

       END DO
      END DO
     END DO

     DO k2=1,ndp
     EVn(i,j,k2,i2,j2) = 0.d0

      DO k=1,nw
       DO k3=1,ndp
        DO l=1,ngp
        l2 = (k2-1)*ndp*ngp + (k3-1)*ngp + l
         DO m=1,nrk
        V_hold(1) =     xp_nadj_w(i,j,1,1,k,l2,m)*Dp_nadj_w(j,k2,1,l)* &
			  Vnoadjust(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,k2,1,l),age+1,k3,l,m) + &
	 		xp_nadj_w(i,j,1,1,k,l2,m)*(1.d0-Dp_nadj_w(j,k2,1,l))* &
			  Vnoadjust(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,k2,1,l)+1,age+1,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*Dp_nadj_w(j,k2,1,l)* &
			  Vnoadjust(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,k2,1,l),age+1,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*(1.d0-Dp_nadj_w(j,k2,1,l))* &
			  Vnoadjust(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,k2,1,l)+1,age+1,k3,l,m)
        V_hold(2) =     xp_nadj_w(i,j,1,1,k,l2,m)*Dp_nadj_w(j,k2,1,l)* &
			  Vadjust(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,k2,1,l),age+1,k3,l,m) + &
	 		xp_nadj_w(i,j,1,1,k,l2,m)*(1.d0-Dp_nadj_w(j,k2,1,l))* &
			  Vadjust(xp_nadj_nodes(i,j,1,1,k,l2,m),Dp_nadj_nodes(j,k2,1,l)+1,age+1,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*Dp_nadj_w(j,k2,1,l)* &
		 	  Vadjust(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,k2,1,l),age+1,k3,l,m) + &
			(1.d0-xp_nadj_w(i,j,1,1,k,l2,m))*(1.d0-Dp_nadj_w(j,k2,1,l))* &
			  Vadjust(xp_nadj_nodes(i,j,1,1,k,l2,m)+1,Dp_nadj_nodes(j,k2,1,l)+1,age+1,k3,l,m)
        EVn(i,j,k2,i2,j2)  =  EVn(i,j,k2,i2,j2) + beta * betanodes(age) * &
			Probdp(k2,k3)* Probw(1,k,age+1)* Probg(i2,l) * Probrk(j2,m) *&
			(gnodes(age+1,l)**(1.d0-psi)) * MAXVAL( V_hold ,1 )
        END DO
       END DO
      END DO
     END DO

      END DO

     END DO
    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  ELSE

 ! When working
 ! ------------

 !$OMP PARALLEL DO PRIVATE(o2)
 DO j=1,nD
   DO k=1,ne
    DO o=1,ngp

   Dp(j,k,o) = Dnodes(j) / ( gnodes(age+1,o)*enodes(k) )
   CALL sub_intpnode(nD,Dnodes,Dp(j,k,o),Dp_nodes(j,k,o),Dp_w(j,k,o))

   DO l=1,ndp
   Dp_nadj(j,l,k,o) = (1.d0-delta(l)*(1.d0-gamma))*Dnodes(j) / ( gnodes(age+1,o)*enodes(k) )
   CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,l,k,o),Dp_nadj_nodes(j,l,k,o),Dp_nadj_w(j,l,k,o))
   END DO

  DO i=1,na
    DO l=1,nu
     DO m=1,nw
      DO p=1,nrk

    IF (anodes(i) >= eta*Dnodes(j)) THEN
    xp(i,j,k,l,m,o,p) = wnodes(m,age+1)*r*(anodes(i)-eta*Dnodes(j)) / (gnodes(age+1,o)*enodes(k)) + &
		(1.d0-delta(ndp))*Dnodes(j) / ( gnodes(age+1,o)*enodes(k) ) + unodes(l)
    ELSE
    xp(i,j,k,l,m,o,p) = (r+rknodes(p))*(anodes(i)-eta*Dnodes(j) ) &
		/ (gnodes(age+1,o)*enodes(k)) + &
		(1.d0-delta(ndp))*Dnodes(j) / ( gnodes(age+1,o)*enodes(k) ) + unodes(l)
    END IF
    CALL sub_intpnode(nx,xnodes,xp(i,j,k,l,m,o,p),xpnodes(i,j,k,l,m,o,p),xp_w(i,j,k,l,m,o,p))

    DO k2=1,ndp
      DO k3=1,ndp
        o2= (k2-1)*ndp*ngp + (k3-1)*ngp + o
    IF (anodes(i) >= eta*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j)) THEN
    xp_nadj(i,j,k,l,m,o2,p) = wnodes(m,age+1)*r*(anodes(i)-eta*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j)) &
		 / (gnodes(age+1,o)*enodes(k)) + &
		(1.d0-delta(k3))*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j) / ( gnodes(age+1,o)*enodes(k) ) + unodes(l)
    ELSE
    xp_nadj(i,j,k,l,m,o2,p) = (r+rknodes(p))*( anodes(i)-eta*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j) ) &
		/ (gnodes(age+1,o)*enodes(k)) + &
		(1.d0-delta(k3))*(1.d0-delta(k2)*(1.d0-gamma))*Dnodes(j) / ( gnodes(age+1,o)*enodes(k) ) + unodes(l)
    END IF
    CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,k,l,m,o2,p),xp_nadj_nodes(i,j,k,l,m,o2,p),xp_nadj_w(i,j,k,l,m,o2,p))
      END DO
    END DO
       END DO
      END DO
     END DO
    END DO
   END DO
  END DO
 END DO
 !$OMP END PARALLEL DO


  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold,o2)
  DO j=1,nD
    DO i=1,na
     DO i2=1,ngp
      DO j2=1,nrk

      EV(i,j,i2,j2) = 0.d0
      DO k = 1,ne
       DO l = 1,nu
        DO m = 1,nw
         DO o = 1,ngp
          DO p = 1,nrk
        V_hold(1) =   xp_w(i,j,k,l,m,o,p)*Dp_w(j,k,o)*Vnoadjust(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o),age+1,ndp,o,p) + &
	 		xp_w(i,j,k,l,m,o,p)*(1.d0-Dp_w(j,k,o))*Vnoadjust(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o)+1,age+1,ndp,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*Dp_w(j,k,o)*Vnoadjust(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o),age+1,ndp,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*(1.d0-Dp_w(j,k,o))*Vnoadjust(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o)+1,age+1,ndp,o,p)
        V_hold(2) =     xp_w(i,j,k,l,m,o,p)*Dp_w(j,k,o)*Vadjust(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o),age+1,ndp,o,p) + &
	 		xp_w(i,j,k,l,m,o,p)*(1.d0-Dp_w(j,k,o))*Vadjust(xpnodes(i,j,k,l,m,o,p),Dp_nodes(j,k,o)+1,age+1,ndp,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*Dp_w(j,k,o)*Vadjust(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o),age+1,ndp,o,p) + &
			(1.d0-xp_w(i,j,k,l,m,o,p))*(1.d0-Dp_w(j,k,o))*Vadjust(xpnodes(i,j,k,l,m,o,p)+1,Dp_nodes(j,k,o)+1,age+1,ndp,o,p)
        EV(i,j,i2,j2) = EV(i,j,i2,j2) + beta * betanodes(age)*Probe(1,k)*Probu(1,l)*Probw(1,m,age+1)*Probg(i2,o)*Probrk(j2,p)* &
			 (gnodes(age+1,o)*enodes(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
          END DO
         END DO
	END DO
       END DO
      END DO

    DO k2=1,ndp
      EVn(i,j,k2,i2,j2) = 0.d0

      DO k = 1,ne
       DO l = 1,nu
        DO m = 1,nw
         DO k3 = 1,ndp
         DO o = 1,ngp
          DO p = 1,nrk
          o2 = (k2-1)*ndp*ngp + (k3-1)*ngp + o
        V_hold(1) =     xp_nadj_w(i,j,k,l,m,o2,p)*Dp_nadj_w(j,k2,k,o)* &
			Vnoadjust(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,k2,k,o),age+1,k3,o,p) + &
	 		xp_nadj_w(i,j,k,l,m,o2,p)*(1.d0-Dp_nadj_w(j,k2,k,o))* &
			Vnoadjust(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,k2,k,o)+1,age+1,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*Dp_nadj_w(j,k2,k,o)* &
			Vnoadjust(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,k2,k,o),age+1,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*(1.d0-Dp_nadj_w(j,k2,k,o))* &
			Vnoadjust(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,k2,k,o)+1,age+1,k3,o,p)
        V_hold(2) =     xp_nadj_w(i,j,k,l,m,o2,p)*Dp_nadj_w(j,k2,k,o)* &
			Vadjust(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,k2,k,o),age+1,k3,o,p) + &
	 		xp_nadj_w(i,j,k,l,m,o2,p)*(1.d0-Dp_nadj_w(j,k2,k,o))* &
			Vadjust(xp_nadj_nodes(i,j,k,l,m,o2,p),Dp_nadj_nodes(j,k2,k,o)+1,age+1,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*Dp_nadj_w(j,k2,k,o)* &
			Vadjust(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,k2,k,o),age+1,k3,o,p) + &
			(1.d0-xp_nadj_w(i,j,k,l,m,o2,p))*(1.d0-Dp_nadj_w(j,k2,k,o))* &
			Vadjust(xp_nadj_nodes(i,j,k,l,m,o2,p)+1,Dp_nadj_nodes(j,k2,k,o)+1,age+1,k3,o,p)
        EVn(i,j,k2,i2,j2) = EVn(i,j,k2,i2,j2) + beta * betanodes(age)*Probdp(k2,k3)*Probe(1,k)*Probu(1,l)* &
		         Probw(1,m,age+1)*Probg(i2,o)*Probrk(j2,p)*  &
			 (gnodes(age+1,o)*enodes(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
           END DO
          END DO
         END DO
	END DO
       END DO
      END DO

      END DO

     END DO
    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,index1,adj_hold)
   DO j=1,nz
    DO k=1,ngp
     DO l=1,nrk
      DO i2=1,na
       DO j2=1,nD
       index1 = (i2-1)*nD + j2
       C = znodes(j)-(1.d0-eta)*Dnodes(j2)-anodes(i2)
       IF (C>0.d0) THEN
       adj_hold(index1) = fel( C,Dnodes(j2), eqvnodes(age) ) + EV(i2,j2,k,l)
       ELSE
       adj_hold(index1) = vmin
       END IF
       END DO
      END DO
      choice = MAXLOC( adj_hold, 1)
      Vadjust_z(j,k,l) = adj_hold(choice)
      a_adj_z(j,k,l) = anodes( dummy_choice_a(choice) )
      D_adj_z(j,k,l) = Dnodes( dummy_choice_D(choice) )
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold,choice,nadj_hold)
   DO j=1,nD
    DO i=1,nx
     DO m=1,ndp
      DO k=1,ngp
       DO l=1,nrk
      DO i2=1,na
       D_hold = (1-delta(m)*(1.d0-gamma))*Dnodes(j)
       C = xnodes(i) - anodes(i2) - (1.d0-eta)*D_hold
         IF (C>0.d0) THEN
         nadj_hold(i2) = fel( C, D_hold, eqvnodes(age) )+ EVn(i2,j,m,k,l)
         ELSE
         nadj_hold(i2) = vmin
         END IF
      END DO
       choice = MAXLOC( nadj_hold, 1)
       Vnoadjust(i,j,age,m,k,l) = nadj_hold(choice)
       a_nadj(i,j,age,m,k,l) = anodes( choice )
       c_nadj(i,j,age,m,k,l) = xnodes(i) - a_nadj(i,j,age,m,k,l) - &
		(1.d0-eta)*(1-delta(m)*(1.d0-gamma))*Dnodes(j)
       END DO
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
     DO m=1,ndp
      DO k=1,ngp
       DO l=1,nrk
       Vadjust(i,j,age,m,k,l) = zweight(i,j)*Vadjust_z( z_intnodes(i,j),k,l) + &
		            (1.d0-zweight(i,j))*Vadjust_z( z_intnodes(i,j)+1,k,l)
       a_adj(i,j,age,m,k,l) = zweight(i,j)*a_adj_z( z_intnodes(i,j),k,l ) + &
		            (1.d0-zweight(i,j))*a_adj_z( z_intnodes(i,j)+1,k,l )
       D_adj(i,j,age,m,k,l) = zweight(i,j)*D_adj_z( z_intnodes(i,j),k,l ) + &
		            (1.d0-zweight(i,j))*D_adj_z( z_intnodes(i,j)+1,k,l)
       c_adj(i,j,age,m,k,l) = adjust_resource(i,j) - a_adj(i,j,age,m,k,l) - (1.d0-eta)*D_adj(i,j,age,m,k,l)

       IF (Vadjust(i,j,age,m,k,l)<=vmin) THEN
       OPEN (UNIT=555, FILE="out/Output.txt", ACTION="WRITE", POSITION="APPEND")
       WRITE(555,*) ' vadj<vmin : ',Vadjust(i,j,age,m,k,l),Vadjust_z( z_intnodes(i,j),k,l),&
	z_intnodes(i,j), znodes(z_intnodes(i,j))
       CLOSE(555)
       END IF

	   IF (Vadjust(i,j,age,m,k,l) >= Vnoadjust(i,j,age,m,k,l)) THEN
	   V(i,j,age,m,k,l) = Vadjust(i,j,age,m,k,l)
	   cchoice(i,j,age,m,k,l) = c_adj(i,j,age,m,k,l)
	   ELSE
	   V(i,j,age,m,k,l) = Vnoadjust(i,j,age,m,k,l)
	   cchoice(i,j,age,m,k,l) = c_nadj(i,j,age,m,k,l)
	   END IF
       END DO
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL



END DO

  DEALLOCATE(  c_adj, c_nadj )

END SUBROUTINE sub_valueiterate
