subroutine sub_valueiterate(Vnoadjust, Vadjust, V, a_adj,  &
	a_nadj,  D_adj, cchoice )
  USE OMP_LIB
  USE SHARE
  IMPLICIT NONE

  REAL(8), DIMENSION(nx,nD,ng,ndp), INTENT(OUT) :: Vnoadjust, Vadjust, V
  REAL(8), DIMENSION(nx,nD,ng,ndp), INTENT(OUT) :: a_adj,  &
	a_nadj,  D_adj, cchoice
  REAL(8), DIMENSION(nx,nD,ng,ndp) :: c_adj, c_nadj

  INTEGER :: i,iter,j,k,l,m,i2,j2,k2,l2,m2
  REAL(8), DIMENSION(nD*na) :: adj_hold
  REAL(8), DIMENSION(na) :: nadj_hold
  REAL(8), DIMENSION(nz) :: Vadjust_z, a_adj_z,  D_adj_z
  REAL(8), DIMENSION(na,nD) :: EV
  REAL(8), DIMENSION(na,nD,ndp) ::  EVn
  REAL(8), DIMENSION(nD,ne) :: Dp, Dp_w
  REAL(8), DIMENSION(nD,ndp,ne) :: Dp_nadj, Dp_nadj_w
  INTEGER, DIMENSION(nD,ne) :: Dp_nodes
  INTEGER, DIMENSION(nD,ndp,ne) :: Dp_nadj_nodes
  REAL(8), DIMENSION(na,nD,ne,nu) :: xp, xp_w
  REAL(8), DIMENSION(na,nD,ndp,ne,nu) :: xp_nadj, xp_nadj_w
  INTEGER, DIMENSION(na,nD,ne,nu) :: xpnodes
  INTEGER, DIMENSION(na,nD,ndp,ne,nu) :: xp_nadj_nodes
  REAL(8), DIMENSION(nx,nD,ndp) :: adjust_resource, zweight
  INTEGER, DIMENSION(nx,nD,ndp) :: z_intnodes
  INTEGER, DIMENSION(nD*na) :: dummy_choice_a, dummy_choice_D
  REAL(8), DIMENSION(2) :: V_hold
  INTEGER :: choice, index1
  REAL(8) :: C, D_hold
  INTEGER :: age

REAL(8), EXTERNAL :: fel

IF (nz<nx) THEN
  OPEN (UNIT=555, FILE="out/Output.txt", STATUS="OLD", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' WARNING! nz<nx '
  CLOSE(555)
END IF

  !$OMP PARALLEL DO
   DO j=1,nD
   Vnoadjust(:,j,:,:) = 0.d0
   Vadjust(:,j,:,:) = 0.d0
   V(:,j,:,:) = 0.d0
   a_adj(:,j,:,:) = 0.d0
   a_nadj(:,j,:,:) = 0.d0
   D_adj(:,j,:,:) = 0.d0
   c_adj(:,j,:,:) = 0.d0
   c_nadj(:,j,:,:) = 0.d0
   cchoice(:,j,:,:) = 0.d0
   EV(:,j) = 0.d0
   EVn(:,j,:) = 0.d0
   Dp(j,:) = 0.d0
   Dp_w(j,:) = 0.d0
   Dp_nadj(j,:,:) = 0.d0
   Dp_nadj_w(j,:,:) = 0.d0
   Dp_nodes(j,:) = 0
   Dp_nadj_nodes(j,:,:) = 0
   xp(:,j,:,:) = 0.d0
   xp_w(:,j,:,:) = 0.d0
   xp_nadj(:,j,:,:,:) = 0.d0
   xp_nadj_w(:,j,:,:,:) = 0.d0
   xpnodes(:,j,:,:) = 0
   xp_nadj_nodes(:,j,:,:,:) = 0
   END DO
  !$OMP END PARALLEL DO

DO i=1,na
 DO j=1,nD
  index1 = (i-1)*nD + j
  dummy_choice_a( index1 ) = i
  dummy_choice_D( index1 ) = j
 END DO
END DO

DO i=1,nx
 DO j=1,nD
   DO k=1,ndp
   adjust_resource(i,j,k) = (1.d0-delta(k)-F-r*eta)*Dnodes(j) + xnodes(i)
   CALL sub_intpnode(nz,znodes,adjust_resource(i,j,k),z_intnodes(i,j,k),zweight(i,j,k))
   END DO
 END DO
END DO

! Age=trest+twork (a'=eta*D', no assets remaining, no debt)
! ---------------

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,adj_hold)
   DO j=1,nz
       DO j2=1,nD
         C = znodes(j)-Dnodes(j2)
         IF (C>0.d0) THEN
         adj_hold(j2) = fel( C,Dnodes(j2), eqvnodes(ng) )
         ELSE
         C = cmin
         adj_hold(j2) = vmin
         END IF
       END DO
      choice = MAXLOC( adj_hold(:nD), 1)
      Vadjust_z(j) = adj_hold(choice)
      a_adj_z(j) = eta*Dnodes( dummy_choice_D(choice) )
      D_adj_z(j) = Dnodes( dummy_choice_D(choice) )
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold)
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
       C = xnodes(i) - (delta(k)*gamma+r*eta)*Dnodes(j)
       D_hold = (1.d0-delta(k)*(1.d0-gamma))*Dnodes(j)
       IF (C>0.d0) THEN
       c_nadj(i,j,ng,k) = C
       Vnoadjust(i,j,ng,k) = fel( c_nadj(i,j,ng,k), D_hold, eqvnodes(ng) )
       ELSE
       c_nadj(i,j,ng,k) = cmin
       Vnoadjust(i,j,ng,k) = vmin
       END IF
       a_nadj(i,j,ng,k) = eta*D_hold
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
       Vadjust(i,j,ng,k) = zweight(i,j,k)*Vadjust_z( z_intnodes(i,j,k) ) + &
		            (1.d0-zweight(i,j,k))*Vadjust_z( z_intnodes(i,j,k)+1)
       D_adj(i,j,ng,k) = zweight(i,j,k)*D_adj_z( z_intnodes(i,j,k) ) + &
		            (1.d0-zweight(i,j,k))*D_adj_z( z_intnodes(i,j,k)+1)
       a_adj(i,j,ng,k) = eta*D_adj(i,j,ng,k)
       c_adj(i,j,ng,k) = adjust_resource(i,j,k) - D_adj(i,j,ng,k)

	   IF (Vadjust(i,j,ng,k) >= Vnoadjust(i,j,ng,k)) THEN
	   V(i,j,ng,k) = Vadjust(i,j,ng,k)
	   cchoice(i,j,ng,k) = c_adj(i,j,ng,k)
	   ELSE
	   V(i,j,ng,k) = Vnoadjust(i,j,ng,k)
	   cchoice(i,j,ng,k) = c_nadj(i,j,ng,k)
	   END IF
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

! Age<trest+twork
! ---------------
DO age = ng-1,1,-1

  IF (age>=twork) THEN
 ! When retired
 ! ------------
 IF (age==ng-1) THEN
  !$OMP PARALLEL DO
	  DO j=1,nD
	   Dp(j,1) = Dnodes(j) / gnodes(age+1)
	   CALL sub_intpnode(nD,Dnodes,Dp(j,1),Dp_nodes(j,1),Dp_w(j,1))
           DO k=1,ndp
	     Dp_nadj(j,k,1) = (1.d0-delta(k)*(1-gamma))*Dnodes(j) / gnodes(age+1)
	     CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,k,1),Dp_nadj_nodes(j,k,1),Dp_nadj_w(j,k,1))
	   END DO

	 DO i=1,na
	    IF (anodes(i) >= eta*Dnodes(j)) THEN
	    xp(i,j,1,1) = r*anodes(i) / gnodes(age+1) + u_ret
	    ELSE
	    xp(i,j,1,1) = (r*anodes(i) + rk*(anodes(i)-eta*Dnodes(j)) ) &
				/ gnodes(age+1) + u_ret
	    END IF
	    CALL sub_intpnode(nx,xnodes,xp(i,j,1,1),xpnodes(i,j,1,1),xp_w(i,j,1,1))
            DO k=1,ndp
	      IF ( anodes(i) >= eta*(1.d0-delta(k)*(1.d0-gamma))*Dnodes(j) ) THEN
	      xp_nadj(i,j,k,1,1) = r*anodes(i) / gnodes(age+1) + u_ret
	      ELSE
	      xp_nadj(i,j,k,1,1) = (r*anodes(i) + &
				rk*(anodes(i)-eta*(1.d0-delta(k)*(1.d0-gamma))*Dnodes(j)) ) &
				/ gnodes(age+1) + u_ret
	      END IF
	      CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,k,1,1),xp_nadj_nodes(i,j,k,1,1),xp_nadj_w(i,j,k,1,1))
	    END DO
	  END DO
	 END DO
  !$OMP END PARALLEL DO
 END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold)
  DO j=1,nD
    DO i=1,na

        V_hold(1) =     xp_w(i,j,1,1)*Dp_w(j,1)*Vnoadjust(xpnodes(i,j,1,1),Dp_nodes(j,1),age+1,ndp) + &
	 		xp_w(i,j,1,1)*(1.d0-Dp_w(j,1))*Vnoadjust(xpnodes(i,j,1,1),Dp_nodes(j,1)+1,age+1,ndp) + &
			(1.d0-xp_w(i,j,1,1))*Dp_w(j,1)*Vnoadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1),age+1,ndp) + &
			(1.d0-xp_w(i,j,1,1))*(1.d0-Dp_w(j,1))*Vnoadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1)+1,age+1,ndp)
        V_hold(2) =     xp_w(i,j,1,1)*Dp_w(j,1)*Vadjust(xpnodes(i,j,1,1),Dp_nodes(j,1),age+1,ndp) + &
	 		xp_w(i,j,1,1)*(1.d0-Dp_w(j,1))*Vadjust(xpnodes(i,j,1,1),Dp_nodes(j,1)+1,age+1,ndp) + &
			(1.d0-xp_w(i,j,1,1))*Dp_w(j,1)*Vadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1),age+1,ndp) + &
			(1.d0-xp_w(i,j,1,1))*(1.d0-Dp_w(j,1))*Vadjust(xpnodes(i,j,1,1)+1,Dp_nodes(j,1)+1,age+1,ndp)
        EV(i,j)   =  beta * betanodes(age) * (gnodes(age+1)**(1.d0-psi)) * MAXVAL( V_hold ,1 )

     DO i2=1,ndp

	EVn(i,j,i2)=0.d0
        DO k=1,ndp
        V_hold(1) =     xp_nadj_w(i,j,i2,1,1)*Dp_nadj_w(j,i2,1)* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1),Dp_nadj_nodes(j,i2,1),age+1,k) + &
	 		xp_nadj_w(i,j,i2,1,1)*(1.d0-Dp_nadj_w(j,i2,1))* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1),Dp_nadj_nodes(j,i2,1)+1,age+1,k) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1))*Dp_nadj_w(j,i2,1)* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1)+1,Dp_nadj_nodes(j,i2,1),age+1,k) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1))*(1.d0-Dp_nadj_w(j,i2,1))* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1)+1,Dp_nadj_nodes(j,i2,1)+1,age+1,k)
        V_hold(2) =     xp_nadj_w(i,j,i2,1,1)*Dp_nadj_w(j,i2,1)* &
			  Vadjust(xp_nadj_nodes(i,j,i2,1,1),Dp_nadj_nodes(j,i2,1),age+1,k) + &
	 		xp_nadj_w(i,j,i2,1,1)*(1.d0-Dp_nadj_w(j,i2,1))* &
			  Vadjust(xp_nadj_nodes(i,j,i2,1,1),Dp_nadj_nodes(j,i2,1)+1,age+1,k) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1))*Dp_nadj_w(j,i2,1)* &
		 	  Vadjust(xp_nadj_nodes(i,j,i2,1,1)+1,Dp_nadj_nodes(j,i2,1),age+1,k) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1))*(1.d0-Dp_nadj_w(j,i2,1))* &
			  Vadjust(xp_nadj_nodes(i,j,i2,1,1)+1,Dp_nadj_nodes(j,i2,1)+1,age+1,k)
        EVn(i,j,i2)  = 	EVn(i,j,i2) + beta * betanodes(age)* Probdp(i2,k)* (gnodes(age+1)**(1.d0-psi)) * MAXVAL( V_hold ,1 )

        END DO
    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  ELSE
 ! When working
 ! ------------
 !$OMP PARALLEL DO
 DO j=1,nD
   DO k=1,ne
   Dp(j,k) = Dnodes(j) / ( gnodes(age+1)*enodes(k) )
   CALL sub_intpnode(nD,Dnodes,Dp(j,k),Dp_nodes(j,k),Dp_w(j,k))
   DO l=1,ndp
     Dp_nadj(j,l,k) = (1.d0-delta(l)*(1.d0-gamma))*Dnodes(j) / ( gnodes(age+1)*enodes(k) )
     CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,l,k),Dp_nadj_nodes(j,l,k),Dp_nadj_w(j,l,k))
   END DO
  END DO

  DO i=1,na
   DO k=1,ne
    DO l=1,nu
    IF (anodes(i) >= eta*Dnodes(j)) THEN
    xp(i,j,k,l) = r*anodes(i) / (gnodes(age+1)*enodes(k)) + unodes(l)
    ELSE
    xp(i,j,k,l) = ( r*anodes(i) + rk*(anodes(i)-eta*Dnodes(j) ) ) &
		/ (gnodes(age+1)*enodes(k)) + unodes(l)
    END IF
    CALL sub_intpnode(nx,xnodes,xp(i,j,k,l),xpnodes(i,j,k,l),xp_w(i,j,k,l))
     DO m=1,ndp
      IF (anodes(i) >= eta*(1.d0-delta(m)*(1.d0-gamma))*Dnodes(j)) THEN
      xp_nadj(i,j,m,k,l) = r*anodes(i) / (gnodes(age+1)*enodes(k)) + unodes(l)
      ELSE
      xp_nadj(i,j,m,k,l) = ( r*anodes(i) + rk*( anodes(i)-eta*(1.d0-delta(m)*(1.d0-gamma))*Dnodes(j) ) ) &
		/ (gnodes(age+1)*enodes(k)) + unodes(l)
      END IF
      CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,m,k,l),xp_nadj_nodes(i,j,m,k,l),xp_nadj_w(i,j,m,k,l))
     END DO
    END DO
   END DO
  END DO
 END DO
 !$OMP END PARALLEL DO

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold)
  DO j=1,nD
    DO i=1,na
      EV(i,j) = 0.d0
      DO k = 1,ne
       DO l = 1,nu

        V_hold(1) =   xp_w(i,j,k,l)*Dp_w(j,k)*Vnoadjust(xpnodes(i,j,k,l),Dp_nodes(j,k),age+1,ndp) + &
	 		xp_w(i,j,k,l)*(1.d0-Dp_w(j,k))*Vnoadjust(xpnodes(i,j,k,l),Dp_nodes(j,k)+1,age+1,ndp) + &
			(1.d0-xp_w(i,j,k,l))*Dp_w(j,k)*Vnoadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k),age+1,ndp) + &
			(1.d0-xp_w(i,j,k,l))*(1.d0-Dp_w(j,k))*Vnoadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k)+1,age+1,ndp)
        V_hold(2) =     xp_w(i,j,k,l)*Dp_w(j,k)*Vadjust(xpnodes(i,j,k,l),Dp_nodes(j,k),age+1,ndp) + &
	 		xp_w(i,j,k,l)*(1.d0-Dp_w(j,k))*Vadjust(xpnodes(i,j,k,l),Dp_nodes(j,k)+1,age+1,ndp) + &
			(1.d0-xp_w(i,j,k,l))*Dp_w(j,k)*Vadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k),age+1,ndp) + &
			(1.d0-xp_w(i,j,k,l))*(1.d0-Dp_w(j,k))*Vadjust(xpnodes(i,j,k,l)+1,Dp_nodes(j,k)+1,age+1,ndp)
        EV(i,j) = EV(i,j) + beta * betanodes(age)*Probe(1,k)*Probu(1,l) *&
			 (gnodes(age+1)*enodes(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
       END DO
      END DO

     DO i2=1,ndp
      EVn(i,j,i2) = 0.d0
      DO k = 1,ne
       DO l = 1,nu
        DO m = 1,ndp
        V_hold(1) =     xp_nadj_w(i,j,i2,k,l)*Dp_nadj_w(j,i2,k)* &
			Vnoadjust(xp_nadj_nodes(i,j,i2,k,l),Dp_nadj_nodes(j,i2,k),age+1,m) + &
	 		xp_nadj_w(i,j,i2,k,l)*(1.d0-Dp_nadj_w(j,i2,k))* &
			Vnoadjust(xp_nadj_nodes(i,j,i2,k,l),Dp_nadj_nodes(j,i2,k)+1,age+1,m) + &
			(1.d0-xp_nadj_w(i,j,i2,k,l))*Dp_nadj_w(j,i2,k)* &
			Vnoadjust(xp_nadj_nodes(i,j,i2,k,l)+1,Dp_nadj_nodes(j,i2,k),age+1,m) + &
			(1.d0-xp_nadj_w(i,j,i2,k,l))*(1.d0-Dp_nadj_w(j,i2,k))* &
			Vnoadjust(xp_nadj_nodes(i,j,i2,k,l)+1,Dp_nadj_nodes(j,i2,k)+1,age+1,m)
        V_hold(2) =     xp_nadj_w(i,j,i2,k,l)*Dp_nadj_w(j,i2,k)* &
			Vadjust(xp_nadj_nodes(i,j,i2,k,l),Dp_nadj_nodes(j,i2,k),age+1,m) + &
	 		xp_nadj_w(i,j,i2,k,l)*(1.d0-Dp_nadj_w(j,i2,k))* &
			Vadjust(xp_nadj_nodes(i,j,i2,k,l),Dp_nadj_nodes(j,i2,k)+1,age+1,m) + &
			(1.d0-xp_nadj_w(i,j,i2,k,l))*Dp_nadj_w(j,i2,k)* &
			Vadjust(xp_nadj_nodes(i,j,i2,k,l)+1,Dp_nadj_nodes(j,i2,k),age+1,m) + &
			(1.d0-xp_nadj_w(i,j,i2,k,l))*(1.d0-Dp_nadj_w(j,i2,k))* &
			Vadjust(xp_nadj_nodes(i,j,i2,k,l)+1,Dp_nadj_nodes(j,i2,k)+1,age+1,m)
        EVn(i,j,i2) = EVn(i,j,i2) + beta * betanodes(age)*Probe(1,k)*Probu(1,l)* Probdp(i2,m) * &
			 (gnodes(age+1)*enodes(k))**(1.d0-psi) * MAXVAL( V_hold ,1 )
        END DO
       END DO
      END DO

    END DO

   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,index1,adj_hold)
   DO j=1,nz
      DO i2=1,na
       DO j2=1,nD
       index1 = (i2-1)*nD + j2
       C = znodes(j)-(1.d0-eta)*Dnodes(j2)-anodes(i2)
       IF (C>0.d0) THEN
       adj_hold(index1) = fel( C,Dnodes(j2), eqvnodes(age) ) + EV(i2,j2)
       ELSE
       adj_hold(index1) = vmin
       END IF
       END DO
      END DO
      choice = MAXLOC( adj_hold, 1)
      Vadjust_z(j) = adj_hold(choice)
      a_adj_z(j) = anodes( dummy_choice_a(choice) )
      D_adj_z(j) = Dnodes( dummy_choice_D(choice) )
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold,choice,nadj_hold)
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
      DO i2=1,na
       C = xnodes(i) - anodes(i2) + &
	     ( eta * (1-delta(k)*(1.d0-gamma) - r ) - delta(k)*gamma )*Dnodes(j)
       D_hold = (1-delta(k)*(1.d0-gamma))*Dnodes(j)
         IF (C>0.d0) THEN
         nadj_hold(i2) = fel( C, D_hold, eqvnodes(age) )+ EVn(i2,j,k)
         ELSE
         nadj_hold(i2) = vmin
         END IF
      END DO
       choice = MAXLOC( nadj_hold, 1)
       Vnoadjust(i,j,age,k) = nadj_hold(choice)
       a_nadj(i,j,age,k) = anodes( choice )
       c_nadj(i,j,age,k) = xnodes(i) - a_nadj(i,j,age,k) + &
	     ( eta * (1-delta(k)*(1.d0-gamma) - r) - delta(k)*gamma )*Dnodes(j)
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
       Vadjust(i,j,age,k) = zweight(i,j,k)*Vadjust_z( z_intnodes(i,j,k)) + &
		            (1.d0-zweight(i,j,k))*Vadjust_z( z_intnodes(i,j,k)+1)
       a_adj(i,j,age,k) = zweight(i,j,k)*a_adj_z( z_intnodes(i,j,k) ) + &
		            (1.d0-zweight(i,j,k))*a_adj_z( z_intnodes(i,j,k)+1)
       D_adj(i,j,age,k) = zweight(i,j,k)*D_adj_z( z_intnodes(i,j,k) ) + &
		            (1.d0-zweight(i,j,k))*D_adj_z( z_intnodes(i,j,k)+1 )
       c_adj(i,j,age,k) = adjust_resource(i,j,k) - a_adj(i,j,age,k) - (1.d0-eta)*D_adj(i,j,age,k)

	   IF (Vadjust(i,j,age,k) >= Vnoadjust(i,j,age,k)) THEN
	   V(i,j,age,k) = Vadjust(i,j,age,k)
	   cchoice(i,j,age,k) = c_adj(i,j,age,k)
	   ELSE
	   V(i,j,age,k) = Vnoadjust(i,j,age,k)
	   cchoice(i,j,age,k) = c_nadj(i,j,age,k)
	   END IF
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


END DO

END SUBROUTINE sub_valueiterate
