clear all
clc
close all


for o=1:3
    
    if o==3
    % Full baseline model
    model = load('full_model\out_rackham\Shocksimulategrowth.txt');  
    elseif o==2
    % Model with wealth and spread shocks
    model = load('full_model\out\Shocksimulaterate.txt');         
    else
    % Model with wealth shocks
    model = load('full_model\out\Shocksimulateprice.txt');          
    end

twork = 40;
trest = 20;
burn = trest+twork+1;

% Shock simulate parameters
rep = 150;
shck_c = 5;
shockseriescoh_n = 56;
yearN = 2018;
year0 = yearN - shockseriescoh_n;
time = year0:yearN;
frst_yfig = 1980;
frst_yfig_i = dsearchn(time',frst_yfig);
last_yfig = 2015;
last_yfig_i = dsearchn(time',last_yfig);

cts = model(1,:);
cgrwts = model(2,:);
its = model(3,:);
newcar = model(4,:);
valnewcar = model(5,:);
bts= model(6,:);
sav = model(7,:);
inc = model(8,:);
wts = model(9,:);

cts = reshape(cts,2*(trest+twork),rep,shck_c);
cgrwts = reshape(cgrwts,2*(trest+twork),rep,shck_c);
its = reshape(its,2*(trest+twork),rep,shck_c);
newcar = reshape(newcar,2*(trest+twork),rep,shck_c);
valnewcar = reshape(valnewcar,2*(trest+twork),rep,shck_c);
bts = reshape(bts,2*(trest+twork),rep,shck_c);
sav = reshape(sav,2*(trest+twork),rep,shck_c);
inc = reshape(inc,2*(trest+twork),rep,shck_c);
wts = reshape(wts,2*(trest+twork),rep,shck_c);

sav_r = sav./inc;

% Reshape and take average
cts = squeeze(mean(log(cts(end-shockseriescoh_n-1:end-1,:,:)),2));
cgrwts = squeeze(mean(cgrwts(end-shockseriescoh_n-1:end-1,:,:),2));
its =  squeeze(mean(log(its(end-shockseriescoh_n-1:end-1,:,:)),2));
newcar =  squeeze(mean(newcar(end-shockseriescoh_n-1:end-1,:,:),2));
valnewcar =  squeeze(mean(log(valnewcar(end-shockseriescoh_n-1:end-1,:,:)),2));
bts=  squeeze(mean(log(bts(end-shockseriescoh_n-1:end-1,:,:)),2));
sav_r =  squeeze(mean(sav_r(end-shockseriescoh_n-1:end-1,:,:),2));
wts =  squeeze(mean(log(wts(end-shockseriescoh_n-1:end-1,:,:)),2));

% Shorten series for figures
fig_cts = cts(frst_yfig_i:last_yfig_i,:);
fig_its = its(frst_yfig_i:last_yfig_i,:);
fig_newcar = newcar(frst_yfig_i:last_yfig_i,:);
fig_valnewcar = valnewcar(frst_yfig_i:last_yfig_i,:);
fig_bts= bts(frst_yfig_i:last_yfig_i,:);
fig_sav_r = sav_r(frst_yfig_i:last_yfig_i,:);
fig_cgrwts = cgrwts(frst_yfig_i:last_yfig_i,:);

time_long = time;
time = time(frst_yfig_i:last_yfig_i);

data = csvread('shocksim_data.csv',1,0); 

data_time = data(:,1);
c_dtr = data(:,2);
cgrw_dtr = data(:,3);
id_dtr = data(:,4);
padj_dtr = data(:,5);
val_dtr = data(:,6);
sav_r_dtr = data(:,7);
loan_dtr = data(:,8);

nrm_yr0 = 1981;
nrm_yr = 2007;

nrm_data_n1 = dsearchn(data_time,nrm_yr0); 
nrm_model_n1 = dsearchn(time',nrm_yr0);

nrm_data_n2 = dsearchn(data_time,nrm_yr); 
nrm_model_n2 = dsearchn(time',nrm_yr); 

% Normalize Data

% NIPA
c_dtr = c_dtr - mean(c_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_cts(nrm_model_n1:nrm_model_n2,1));
id_dtr = id_dtr - mean(id_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_its(nrm_model_n1:nrm_model_n2,1));
sav_r_dtr = sav_r_dtr - mean(sav_r_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_sav_r(nrm_model_n1:nrm_model_n2,1));
loan_dtr = loan_dtr - mean(loan_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_bts(nrm_model_n1:nrm_model_n2,1));
 
% CEX
padj_dtr = padj_dtr - mean(padj_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_newcar(nrm_model_n1:nrm_model_n2,1));
val_dtr = val_dtr - mean(val_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_valnewcar(nrm_model_n1:nrm_model_n2,1));
cgrw_dtr = cgrw_dtr - mean(cgrw_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_cgrwts(nrm_model_n1:nrm_model_n2,1));

fig_cts         = [fig_cts,c_dtr]; 
fig_its         = [fig_its,id_dtr]; 
fig_newcar      = [fig_newcar,padj_dtr];
fig_valnewcar   = [fig_valnewcar, val_dtr];
fig_bts         = [fig_bts, loan_dtr]; 
fig_sav_r       = [fig_sav_r, sav_r_dtr];
fig_cgrwts      = [fig_cgrwts,cgrw_dtr]; 

recess_c = [.8, .8, .8];
recess_e = 'none';

r_time0 = [1980. 1980.5 1980.5 1980];
r_time1 = [1981.5 1982.75 1982.75 1981.5];
r_time2 = [1990.5 1991,1991,1990.5];
r_time3 = [2001, 2001.75, 2001.75, 2001];
r_time4 = [2007.75 2009.25, 2009.25, 2007.75];

fnt_sz=16;
fnt_sz_leg=11;

% Figure size
GROW = 0.05;

f1=figure( (o-1)*6 +1 );
r_blk = [min(fig_cts(:)),min(fig_cts(:)),max(fig_cts(:)),max(fig_cts(:))];
if r_blk(1)>0
    r_blk(1:2) = r_blk(1:2)*(1-GROW);
else
    r_blk(1:2) = r_blk(1:2)*(1+GROW);
end
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e) 
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)

g2=plot(time,fig_cts(:,2),'-r','LineWidth',3);
g3=plot(time,fig_cts(:,3),'-g','LineWidth',3);
if o>=2
g5=plot(time,fig_cts(:,5),'-m','LineWidth',3);
end
if o>=3
g4=plot(time,fig_cts(:,4),'-c','LineWidth',3);
end
g1=plot(time,fig_cts(:,1),'v-b','LineWidth',3);
g6=plot(time,fig_cts(:,6),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
%title('log. consumption')
axis tight
grid on
set(gcf, 'Name', 'log consumption')

if o>=3
  legend1=legend([g1,g2,g3,g5,g4,g6],{'all','income','wealth','loan rate','profile','data'},'Orientation','horizontal','FontSize',fnt_sz_leg);
end
if o==2
 legend1=legend([g1,g2,g3,g5,g6],{'all','income','wealth','loan rate','data'},'Orientation','horizontal','FontSize',fnt_sz_leg);
end
if o==1
 legend1=legend([g1,g2,g3,g6],{'all','income','wealth','data'},'Orientation','horizontal','FontSize',fnt_sz_leg);
end
legend1.NumColumns = 3;
legend1.Location = 'South';

f1=figure((o-1)*6 + 2);
r_blk = [min(fig_its(:)),min(fig_its(:)),max(fig_its(:)),max(fig_its(:))];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)     
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)

g2=plot(time,fig_its(:,2),'-r','LineWidth',3);
g3=plot(time,fig_its(:,3),'-g','LineWidth',3);
if o>=2
g5=plot(time,fig_its(:,5),'-m','LineWidth',3);
end
if o>=3
g4=plot(time,fig_its(:,4),'-c','LineWidth',3);
end
g1=plot(time,fig_its(:,1),'v-b','LineWidth',3);
g6=plot(time,fig_its(:,6),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
axis tight
grid on
set(gcf, 'Name', 'log car investment')

f1=figure((o-1)*6 + 3);
r_blk = [min(fig_newcar(:)),min(fig_newcar(:)),max(fig_newcar(:)),max(fig_newcar(:))];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e) 
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)

g2=plot(time,fig_newcar(:,2),'-r','LineWidth',3);
g3=plot(time,fig_newcar(:,3),'-g','LineWidth',3);
if o>=2
g5=plot(time,fig_newcar(:,5),'-m','LineWidth',3);
end
if o>=3
g4=plot(time,fig_newcar(:,4),'-c','LineWidth',3);
end
g1=plot(time,fig_newcar(:,1),'v-b','LineWidth',3);
g6=plot(time,fig_newcar(:,6),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
%title('% purchasing car')
axis tight
grid on
set(gcf, 'Name', '% purchasing car')


f1=figure((o-1)*6 + 4);
r_blk = [min(fig_valnewcar(:)),min(fig_valnewcar(:)),max(fig_valnewcar(:)),max(fig_valnewcar(:))];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)     
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)

g2=plot(time,fig_valnewcar(:,2),'-r','LineWidth',3);
g3=plot(time,fig_valnewcar(:,3),'-g','LineWidth',3);
if o>=2
g5=plot(time,fig_valnewcar(:,5),'-m','LineWidth',3);
end
if o>=3
g4=plot(time,fig_valnewcar(:,4),'-c','LineWidth',3);
end
g1=plot(time,fig_valnewcar(:,1),'v-b','LineWidth',3);
g6=plot(time,fig_valnewcar(:,6),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
%title('log. value of car purchase')
axis tight
grid on
set(gcf, 'Name', 'log value | purchase')

f1=figure((o-1)*6 + 5);
r_blk = [min(fig_sav_r(:)),min(fig_sav_r(:)),max(fig_sav_r(:)),max(fig_sav_r(:))];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)     
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)


g2=plot(time,fig_sav_r(:,2),'-r','LineWidth',3);
g3=plot(time,fig_sav_r(:,3),'-g','LineWidth',3);

if o>=2
g5=plot(time,fig_sav_r(:,5),'-m','LineWidth',3);
end
if o>=3
g4=plot(time,fig_sav_r(:,4),'-c','LineWidth',3);
end
g1=plot(time,fig_sav_r(:,1),'v-b','LineWidth',3);
g6=plot(time,fig_sav_r(:,6),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
axis tight
grid on
set(gcf, 'Name', 'saving ratio')

f1=figure((o-1)*6 + 6);
r_blk = [min(fig_bts(:)),min(fig_bts(:)),max(fig_bts(:)),max(fig_bts(:))];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)     
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)

g2=plot(time,fig_bts(:,2),'-r','LineWidth',3);
g3=plot(time,fig_bts(:,3),'-g','LineWidth',3);
if o>=2
g5=plot(time,fig_bts(:,5),'-m','LineWidth',3);
end
if o>=3
g4=plot(time,fig_bts(:,4),'-c','LineWidth',3);
end
g1=plot(time,fig_bts(:,1),'v-b','LineWidth',3);
g6=plot(time,fig_bts(:,6),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
%title('log. car loans')
axis tight
grid on
set(gcf, 'Name', 'log car loans')

% Model fit
m_fit0=2006;
m_fit0_i=dsearchn(time',m_fit0);
m_fitN=2015;
m_fitN_i=dsearchn(time',m_fitN);

m_fitNcex2=2014;
m_fitNcex2_i=dsearchn(time',m_fitNcex2);

m_fit_i_nm1 = m_fit0_i;
m_fit_i_nm2 = m_fit0_i;

absdev_cgrwts = sum( abs( fig_cgrwts(m_fit0_i:m_fitNcex2_i,1)-fig_cgrwts(m_fit0_i:m_fitNcex2_i,end) - ...
    (mean(fig_cgrwts(m_fit_i_nm1:m_fit_i_nm2,1))-mean(fig_cgrwts(m_fit_i_nm1:m_fit_i_nm2,end)))    ) ) ;
absdev_its = sum( abs( fig_its(m_fit0_i:m_fitN_i,1)-fig_its(m_fit0_i:m_fitN_i,end) - ...
    (mean(fig_its(m_fit_i_nm1:m_fit_i_nm2,1))-mean(fig_its(m_fit_i_nm1:m_fit_i_nm2,end)))    ) ) ;
absdev_newcar = sum( abs( fig_newcar(m_fit0_i:m_fitN_i,1)-fig_newcar(m_fit0_i:m_fitN_i,end) - ...
    (mean(fig_newcar(m_fit_i_nm1:m_fit_i_nm2,1))-mean(fig_newcar(m_fit_i_nm1:m_fit_i_nm2,end)))  ) ) ;
absdev_valnewcar = sum( abs( fig_valnewcar(m_fit0_i:m_fitN_i-1,1)-fig_valnewcar(m_fit0_i+1:m_fitN_i,end) - ...
    (mean(fig_valnewcar(m_fit_i_nm1:m_fit_i_nm2,1))-mean(fig_valnewcar(m_fit_i_nm1+1:m_fit_i_nm2+1,end)))  ) ) ;
absdev_sav_r = sum( abs( fig_sav_r(m_fit0_i:m_fitN_i,1)-fig_sav_r(m_fit0_i:m_fitN_i,end) - ...
    (mean(fig_sav_r(m_fit_i_nm1:m_fit_i_nm2,1))-mean(fig_sav_r(m_fit_i_nm1:m_fit_i_nm2,end))) ) ) ;
absdev_bts = sum( abs( fig_bts(m_fit0_i:m_fitN_i,1)-fig_bts(m_fit0_i:m_fitN_i,end) - ...
    (mean(fig_bts(m_fit_i_nm1:m_fit_i_nm2,1))-mean(fig_bts(m_fit_i_nm1:m_fit_i_nm2,end)))    ) ) ;
   
ABSDEV_OUT = [absdev_cgrwts,absdev_its,absdev_newcar,absdev_valnewcar,absdev_sav_r,absdev_bts];
ABSDEV_OUT = [ABSDEV_OUT,mean(ABSDEV_OUT)];

disp('Model fit (Absolute Deviation)')
if o==3
disp('+ profile')    
elseif o==2
disp('+ loan premium')        
else
disp('+ wealth')            
end

print_absdev = sprintf('  %1.3f  ',ABSDEV_OUT);
disp(['Cgrw       ','Id      ','% buy      ','val      ','sav      ','loans      ','MEAN      ']) 
disp(print_absdev )
end

% Predicted consumption growth
reg_y1 = 1950;
reg_yn = 2018;

c_yg = cts(2:end,1)-cts(1:end-1,1);
id_yg = its(2:end,1)-its(1:end-1,1);
y_yg = wts(2:end,1)-wts(1:end-1,1);
time_long = time_long(2:end)';

b1_i = dsearchn(time_long,reg_y1); % fig 1 start
c1_i = dsearchn(time_long,reg_yn); % fig end

X1 = [ones(size(y_yg)),y_yg];
beta_id_y = regress(id_yg(b1_i:c1_i), X1(b1_i:c1_i,:) );
beta_c_y = regress(c_yg(b1_i:c1_i), X1(b1_i:c1_i,:) );

pred_id = X1*beta_id_y;
pred_c = X1*beta_c_y;

gap_id    = id_yg - pred_id;
gap_c    = c_yg - pred_c;

b1_i = dsearchn(time_long,frst_yfig); % fig 1 start
c1_i = dsearchn(time_long,last_yfig); % fig end

y_mnlim1 = -20;
y_mxlim1 = 20;
y_mnlim2 = -2;
y_mxlim2 = 2;

figure(19)
xx = [gap_c(b1_i:c1_i);gap_id(b1_i:c1_i)];
r_blk = [y_mnlim1,y_mnlim1,y_mxlim1,y_mxlim1];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)     
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
plot(time_long(b1_i:c1_i),zeros(size(time_long(b1_i:c1_i))),'-k','LineWidth',1)
yyaxis left
ax = gca;
ax.YColor = 'black';
g1 = plot(time_long(b1_i:c1_i),100*gap_id(b1_i:c1_i),'-b','LineWidth',3);
axis([frst_yfig,last_yfig,y_mnlim1,y_mxlim1])
ylabel('unpredicted growth')

yyaxis right
ax = gca;
ax.YColor = 'black';
g2 = plot(time_long(b1_i:c1_i),100*gap_c(b1_i:c1_i),'-r','LineWidth',3);
axis([frst_yfig,last_yfig,y_mnlim2,y_mxlim2])
ylabel('unpredicted growth')
hold off
legend([g1,g2],{'car expenditure (LHS)','consumption (RHS)'},'Location','SouthWest')
set(gca,'FontSize',fnt_sz)
set(ax, 'OuterPosition', [0, 0, 0.98, 1]);
set(gcf, 'Name', 'Role of non-current income (Figure 16)')
