clear all
clc
close all

model = load('fuel_model\out\Shocksimulate.txt');

twork = 40;
trest = 20;
burn = trest+twork+1;

% Shock simulate parameters
rep = 100;
shck_c = 3;
shockseriescoh_n = 56;
yearN = 2018;
year0 = yearN - shockseriescoh_n;
time = year0:yearN;
frst_yfig = 1980;
frst_yfig_i = dsearchn(time',frst_yfig);
last_yfig = 2015;
last_yfig_i = dsearchn(time',last_yfig);

its = model(1,:);
newcar = model(2,:);
valnewcar = model(3,:);

its = reshape(its,2*(trest+twork),rep,shck_c);
newcar = reshape(newcar,2*(trest+twork),rep,shck_c);
valnewcar = reshape(valnewcar,2*(trest+twork),rep,shck_c);

% Reshape and take average
its =  squeeze(mean(log(its(end-shockseriescoh_n-1:end-1,:,:)),2));
newcar =  squeeze(mean(newcar(end-shockseriescoh_n-1:end-1,:,:),2));
valnewcar =  squeeze(mean(log(valnewcar(end-shockseriescoh_n-1:end-1,:,:)),2));

% Shorten series for figures
fig_its = its(frst_yfig_i:last_yfig_i,:);
fig_newcar = newcar(frst_yfig_i:last_yfig_i,:);
fig_valnewcar = valnewcar(frst_yfig_i:last_yfig_i,:);

time_long = time;
time = time(frst_yfig_i:last_yfig_i);

data = csvread('shocksim_data.csv',1,0); 

data_time = data(:,1);
id_dtr = data(:,4);
padj_dtr = data(:,5);
val_dtr = data(:,6);


nrm_yr0 = 1981;
nrm_yr = 2007;

nrm_data_n1 = dsearchn(data_time,nrm_yr0); 
nrm_model_n1 = dsearchn(time',nrm_yr0);

nrm_data_n2 = dsearchn(data_time,nrm_yr); 
nrm_model_n2 = dsearchn(time',nrm_yr); 

% Normalize Data

% NIPA
id_dtr = id_dtr - mean(id_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_its(nrm_model_n1:nrm_model_n2,1));

% CEX
padj_dtr = padj_dtr - mean(padj_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_newcar(nrm_model_n1:nrm_model_n2,1));
val_dtr = val_dtr - mean(val_dtr(nrm_data_n1:nrm_data_n2)) + mean(fig_valnewcar(nrm_model_n1:nrm_model_n2,1));

fig_its         = [fig_its,id_dtr]; 
fig_newcar      = [fig_newcar,padj_dtr];
fig_valnewcar   = [fig_valnewcar, val_dtr];

recess_c = [.8, .8, .8];
recess_e = 'none';
r_time0 = [1980. 1980.5 1980.5 1980];
r_time1 = [1981.5 1982.75 1982.75 1981.5];
r_time2 = [1990.5 1991,1991,1990.5];
r_time3 = [2001, 2001.75, 2001.75, 2001];
r_time4 = [2007.75 2009.25, 2009.25, 2007.75];

fnt_sz=16;
fnt_sz_leg=11;

% Figure size
GROW = 0.05;

f1=figure(1);
r_blk = [min(fig_its(:)),min(fig_its(:)),max(fig_its(:)),max(fig_its(:))];
if r_blk(1)>0
    r_blk(1:2) = r_blk(1:2)*(1-GROW);
else
    r_blk(1:2) = r_blk(1:2)*(1+GROW);
end
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)  
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
g2=plot(time,fig_its(:,2),'-r','LineWidth',3);
g3=plot(time,fig_its(:,3),'-g','LineWidth',3);
g1=plot(time,fig_its(:,1),'v-b','LineWidth',3);
g4=plot(time,fig_its(:,4),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
%title('log. car investment')
axis tight
grid on
legend1=legend([g1,g2,g3,g4],{'both','income','fuel','data'},'Orientation','horizontal','FontSize',fnt_sz_leg);
legend1.NumColumns = 4;
legend1.Location = 'South';
set(gcf, 'Name', 'log car investment')

f1=figure(2);
r_blk = [min(fig_newcar(:)),min(fig_newcar(:)),max(fig_newcar(:)),max(fig_newcar(:))];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)  
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
g2=plot(time,fig_newcar(:,2),'-r','LineWidth',3);
g3=plot(time,fig_newcar(:,3),'-g','LineWidth',3);
g1=plot(time,fig_newcar(:,1),'v-b','LineWidth',3);
g4=plot(time,fig_newcar(:,4),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
%title('% purchasing car')
axis tight
grid on
set(gcf, 'Name', '% purchasing car')

f1=figure(3);
r_blk = [min(fig_valnewcar(:)),min(fig_valnewcar(:)),max(fig_valnewcar(:)),max(fig_valnewcar(:))];
hold on
fill(r_time0,r_blk,recess_c,'EdgeColor',recess_e)  
fill(r_time1,r_blk,recess_c,'EdgeColor',recess_e)   
fill(r_time2,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time3,r_blk,recess_c,'EdgeColor',recess_e)
fill(r_time4,r_blk,recess_c,'EdgeColor',recess_e)
g2=plot(time,fig_valnewcar(:,2),'-r','LineWidth',3);
g3=plot(time,fig_valnewcar(:,3),'-g','LineWidth',3);
g1=plot(time,fig_valnewcar(:,1),'v-b','LineWidth',3);
g4=plot(time,fig_valnewcar(:,4),'--k','LineWidth',2);
hold off
set(gca,'FontSize',fnt_sz)
set(gca,'Layer','top')
%title('log. value of car purchase')
axis tight
grid on
set(gcf, 'Name', 'log value | purchase')
