close all
clear all
clc

DATA = load('cash_for_clunkers/out/Shocksimulate_mnth.txt');
DATA_an = load('cash_for_clunkers/out/Shocksimulate_mnth_an.txt');

no_shock =  [1,3];
shock =[2,4];

mnth = 6;
m_years = 7;
numshock_m = m_years*mnth;
yr_pr = 4;    
rep = 50; 
shck_c_m = 2;
ex_m = 2* shck_c_m;
clunk_mnth = 4;
clunk_period_m = yr_pr*mnth + min(clunk_mnth,mnth);
clunk_dur_m = min(1,mnth-min(clunk_mnth,mnth)+1);

y0 = 2005;
ydrop = 2;
mdrop = ydrop*mnth;
t = y0:1/mnth:( (y0+m_years-1)+(mnth-1)/mnth );
t_an = y0+.5:y0+m_years-1+0.5;

newcar = reshape(DATA(1,:),numshock_m,rep,ex_m);
valnewcar = reshape(DATA(2,:),numshock_m,rep,ex_m);
valnewcar_byp = reshape(DATA(3,:),numshock_m,rep,ex_m);

newcar_an = reshape(DATA_an(1,:),m_years,rep,ex_m);
valnewcar_an = reshape(DATA_an(2,:),m_years,rep,ex_m);
valnewcar_byp_an = reshape(DATA_an(3,:),m_years,rep,ex_m);

newcar = squeeze(mean(newcar,2));
valnewcar = squeeze(mean(log(valnewcar),2));
valnewcar_byp = squeeze(mean(log(valnewcar_byp),2));

newcar_an = squeeze(mean(newcar_an,2));
valnewcar_an = squeeze(mean(log(valnewcar_an),2));
valnewcar_byp_an = squeeze(mean(log(valnewcar_byp_an),2));

ln_wd_byp = 2;
ln_wd = 5;
ln_wd2 = 4;
pad = 0.025;

fnt_sz = 20;
fnt_sz2 = 18;

xticks_label = [2007 2008 2009 2010 2011];

recess_c = [.8, .8, .8];
clunk_c = [.4, .4, .4];
recess_e = 'none';
r_time = [max(2007+11/12,y0), 2009 + 5/12, 2009 + 5/12, max(2007+11/12,y0)];
c_time = [2009+5.5/12 2009+7.5/12 2009+7.5/12 2009+5.5/12];

% Policy ON or OFF
fig_i = 1;
figure(fig_i)
blk = [(1-pad)*min(reshape(newcar(mdrop+1:end,no_shock),[],1)),(1-pad)*min(reshape(newcar(mdrop+1:end,no_shock),[],1)),...
    (1+pad)*max(reshape(newcar(mdrop+1:end,no_shock),[],1)),(1+pad)*max(reshape(newcar(mdrop+1:end,no_shock),[],1))];
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g1 = plot(t(mdrop+1:end),newcar(mdrop+1:end,no_shock(1)),'-b',t(mdrop+1:end),newcar(mdrop+1:end,no_shock(2)),'--r','LineWidth',ln_wd);
hold off
axis tight
legend([g1],{'CfC','No CfC'},'FontSize',fnt_sz2,'Location','NorthWest')
set(gca,'FontSize',fnt_sz)
set(gcf, 'Name', '% purchase, no shocks')

fig_i = fig_i+1;
figure(fig_i)
blk = [(1-pad)*min(reshape(newcar(mdrop+1:end,shock),[],1)),(1-pad)*min(reshape(newcar(mdrop+1:end,shock),[],1)),...
    (1+pad)*max(reshape(newcar(mdrop+1:end,shock),[],1)),(1+pad)*max(reshape(newcar(mdrop+1:end,shock),[],1))];
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g1 = plot(t(mdrop+1:end),newcar(mdrop+1:end,shock(1)),'-b',t(mdrop+1:end),newcar(mdrop+1:end,shock(2)),'--r','LineWidth',ln_wd);
hold off
axis tight
set(gca,'FontSize',fnt_sz)
set(gca,'FontSize',fnt_sz)
set(gcf, 'Name', '% purchase, monthly shock')

fig_i = fig_i+1;
figure(fig_i)
blk = [(1-pad)*min(reshape(newcar_an(ydrop+1:end,no_shock),[],1)),(1-pad)*min(reshape(newcar_an(ydrop+1:end,no_shock),[],1)),...
    (1+pad)*max(reshape(newcar_an(ydrop+1:end,no_shock),[],1)),(1+pad)*max(reshape(newcar_an(ydrop+1:end,no_shock),[],1))];
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g1 = plot(t_an(ydrop+1:end),newcar_an(ydrop+1:end,no_shock(1)),'v-b',t_an(ydrop+1:end),newcar_an(ydrop+1:end,no_shock(2)),'v--r','LineWidth',ln_wd);
hold off
axis( [2007 2011+5/6 min(blk(:)) max(blk(:))] );
set(gca,'FontSize',fnt_sz)
set(gcf, 'Name', '% purchase (an.), no shocks')

fig_i = fig_i+1;
figure(fig_i)
blk = [(1-pad)*min(reshape(newcar_an(ydrop+1:end,shock),[],1)),(1-pad)*min(reshape(newcar_an(ydrop+1:end,shock),[],1)),...
    (1+pad)*max(reshape(newcar_an(ydrop+1:end,shock),[],1)),(1+pad)*max(reshape(newcar_an(ydrop+1:end,shock),[],1))];
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g1 = plot(t_an(ydrop+1:end),newcar_an(ydrop+1:end,2),'v-b',t_an(ydrop+1:end),newcar_an(ydrop+1:end,4),'v--r','LineWidth',ln_wd);
hold off
axis( [2007 2011+5/6 min(blk(:)) max(blk(:))] );
set(gca,'FontSize',fnt_sz)
set(gcf, 'Name', '% purchase (an.), monthly shocks')

fig_i = fig_i+1;
figure(fig_i)
if valnewcar_byp(1,1)>0
blk = [(1-pad)*min(reshape(valnewcar(mdrop+1:end,no_shock),[],1)),(1-pad)*min(reshape(valnewcar(mdrop+1:end,no_shock),[],1)),...
    (1+pad)*max(reshape(valnewcar(mdrop+1:end,no_shock),[],1)),(1+pad)*max(reshape(valnewcar(mdrop+1:end,no_shock),[],1))];
else
blk = [(1+pad)*min(reshape(valnewcar(mdrop+1:end,no_shock),[],1)),(1+pad)*min(reshape(valnewcar(mdrop+1:end,no_shock),[],1)),...
    (1-pad)*max(reshape(valnewcar(mdrop+1:end,no_shock),[],1)),(1-pad)*max(reshape(valnewcar(mdrop+1:end,no_shock),[],1))];
end 
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g0 = plot(t(mdrop+1:end),valnewcar(mdrop+1:end,no_shock(1)),'-b','LineWidth',ln_wd_byp);
g1 = plot(t(mdrop+1:end),valnewcar_byp(mdrop+1:end,no_shock(1)),'-b',t(mdrop+1:end),valnewcar_byp(mdrop+1:end,no_shock(2)),'--r','LineWidth',ln_wd);
axis tight
hold off
legend([g1(1);g0;g1(2)],{'CfC','Full price','No CfC'},'FontSize',fnt_sz2,'Location','NorthWest')
set(gca,'FontSize',fnt_sz)
xticks(xticks_label)
set(gcf, 'Name', 'log. val new car, no shocks')

fig_i = fig_i+1;
figure(fig_i)
if valnewcar_byp(1,1)>0
blk = [(1-pad)*min(reshape(valnewcar(mdrop+1:end,shock),[],1)),(1-pad)*min(reshape(valnewcar(mdrop+1:end,shock),[],1)),...
    (1+pad)*max(reshape(valnewcar(mdrop+1:end,shock),[],1)),(1+pad)*max(reshape(valnewcar(mdrop+1:end,shock),[],1))];
else
blk = [(1+pad)*min(reshape(valnewcar(mdrop+1:end,shock),[],1)),(1+pad)*min(reshape(valnewcar(mdrop+1:end,shock),[],1)),...
    (1-pad)*max(reshape(valnewcar(mdrop+1:end,shock),[],1)),(1-pad)*max(reshape(valnewcar(mdrop+1:end,shock),[],1))];
end
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g0 = plot(t(mdrop+1:end),valnewcar(mdrop+1:end,shock(1)),'-b','LineWidth',ln_wd_byp);
g1 = plot(t(mdrop+1:end),valnewcar_byp(mdrop+1:end,shock(1)),'-b',t(mdrop+1:end),valnewcar_byp(mdrop+1:end,shock(2)),'--r','LineWidth',ln_wd);
hold off
axis tight
set(gca,'FontSize',fnt_sz)
xticks(xticks_label)
set(gcf, 'Name', 'log. val new car, monthly shocks')

fig_i = fig_i+1;
figure(fig_i)
if valnewcar_byp_an(1,1)>0
blk = [(1-pad)*min(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1)),(1-pad)*min(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1)),...
    (1+pad)*max(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1)),(1+pad)*max(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1))];
else
blk = [(1+pad)*min(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1)),(1+pad)*min(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1)),...
    (1-pad)*max(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1)),(1-pad)*max(reshape(valnewcar_an(ydrop+1:end,no_shock),[],1))];
end
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g0 = plot(t_an(ydrop+1:end),valnewcar_an(ydrop+1:end,no_shock(1)),'-b','LineWidth',ln_wd_byp);
g1 = plot(t_an(ydrop+1:end),valnewcar_byp_an(ydrop+1:end,no_shock(1)),'v-b',t_an(ydrop+1:end),valnewcar_byp_an(ydrop+1:end,no_shock(2)),'v--r','LineWidth',ln_wd);
hold off
axis( [2007 2011+5/6 min(blk(:)) max(blk(:))] );
set(gca,'FontSize',fnt_sz)
xticks(xticks_label )
set(gcf, 'Name', 'log. val new car (an.), no shock')

fig_i = fig_i+1;
figure(fig_i)
if valnewcar_byp_an(1,1)>0
blk = [(1-pad)*min(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1)),(1-pad)*min(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1)),...
    (1+pad)*max(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1)),(1+pad)*max(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1))];
else
blk = [(1+pad)*min(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1)),(1+pad)*min(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1)),...
    (1-pad)*max(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1)),(1-pad)*max(reshape(valnewcar_byp_an(ydrop+1:end,shock),[],1))];
end
hold on
fill(r_time,blk,recess_c,'EdgeColor',recess_e)
fill(c_time,blk,clunk_c,'EdgeColor',recess_e)
g0 = plot(t_an(ydrop+1:end),valnewcar_an(ydrop+1:end,shock(1)),'-b','LineWidth',ln_wd_byp);
g1 = plot(t_an(ydrop+1:end),valnewcar_byp_an(ydrop+1:end,shock(1)),'v-b',t_an(ydrop+1:end),valnewcar_byp_an(ydrop+1:end,shock(2)),'v--r','LineWidth',ln_wd);
hold off
axis( [2007 2011+5/6 min(blk(:)) max(blk(:))] );
set(gcf, 'Name', 'log. val new car, monthly shocks')
set(gca,'FontSize',fnt_sz)
xticks(xticks_label)
