  SUBROUTINE sub_intpnode(n,x,xi,xnode,weight)
! Generates left node and weight for use in one dimensional interpolation.
! x should be ascending with x(1) as minimum and x(n) as max

  IMPLICIT NONE

  INTEGER, INTENT(IN) :: n
  REAL(8), DIMENSION(n), INTENT(IN) :: x
  REAL(8), INTENT(IN) :: xi
  INTEGER, INTENT(OUT) :: xnode
  REAL(8), INTENT(OUT) :: weight
  REAL(8) :: xi_c, tol

   tol = 1.5d0

   IF ( x(1)>=0 ) THEN
   xi_c = MAX( MIN( xi, x(n)*(1.d0+tol)), x(1)*(1.d0-tol) )
   ELSE IF ( x(1) < 0 .AND. x(n) > 0 ) THEN
   xi_c = MAX( MIN( xi, x(n)*(1.d0+tol)), x(1)*(1.d0+tol) )
   ELSE
   xi_c = MAX( MIN( xi, x(n)*(1.d0-tol)), x(1)*(1.d0+tol) )
   END IF

   xnode = MINLOC(ABS(xi_c-x),1)

   IF (xi_c > x(n) ) THEN
   xnode = xnode - 1
   END IF
   IF (xi_c < x(1) ) THEN
   xnode = xnode + 1
   END IF

   IF (xi_c==x(xnode)) THEN
    IF (xnode<n) THEN
        weight=1.d0
    ELSE
        xnode=xnode-1
        weight=0.d0
    END IF
   ELSE
    IF (xi_c-x(xnode)>0) THEN
        weight=1.d0-( xi_c-x(xnode) )/ &
		( x(xnode+1)-x(xnode) )
    ELSE
        xnode=xnode-1
        weight=1.d0-( xi_c-x(xnode) )/ &
		( x(xnode+1)-x(xnode) )
    END IF
   END IF

  END SUBROUTINE sub_intpnode
