SUBROUTINE sub_pollin(Vnoadjust,Vadjust,a_adj,a_nadj,D_adj,&
	ixcross,idcross,iage,idp,igp,iapcross,idpcross,ccross,adjcross )

 USE share
 IMPLICIT NONE
 REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(IN) :: Vnoadjust, Vadjust
 REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(IN) :: a_adj, a_nadj,  D_adj
 REAL(8), INTENT(IN) :: ixcross, idcross
 INTEGER, INTENT(IN) :: iage,idp,igp
 REAL(8), INTENT(OUT) :: iapcross, idpcross, ccross
 INTEGER, INTENT(OUT) :: adjcross

 REAL(8) :: v_adj, v_noadj
 REAL(8) :: s0,s1,s2,s3
 REAL(8) :: x1,x2,w1,w2
 INTEGER :: y1,y2

 x1 = MAX ( MIN ( ixcross , xmax ), xmin )
 x2 = MAX ( MIN ( idcross , Dmax ), Dmin )

   y1 = MINLOC(ABS(x1-xnodes),1)
   IF (x1==xnodes(y1)) THEN
    IF (y1<nx) THEN
        w1=1.d0
    ELSE
        y1=y1-1
        w1=0.d0
    END IF
   ELSE
    IF (x1-xnodes(y1)>0.d0) THEN
        w1=1.d0-( x1-xnodes(y1) )/ ( xnodes(y1+1)-xnodes(y1) )
    ELSE
        y1=y1-1
        w1=1.d0-( x1-xnodes(y1) )/ ( xnodes(y1+1)-xnodes(y1) )
    END IF
   END IF

   y2 = MINLOC(ABS(x2-Dnodes),1)
   IF (x2==Dnodes(y2)) THEN
    IF (y2<nD) THEN
        w2=1.d0
    ELSE
        y2=y2-1
        w2=0.d0
    END IF
   ELSE
    IF (x2-Dnodes(y2)>0.d0) THEN
        w2=1.d0-( x2-Dnodes(y2) )/ ( Dnodes(y2+1)-Dnodes(y2) )
    ELSE
        y2=y2-1
        w2=1.d0-( x2-Dnodes(y2) )/ ( Dnodes(y2+1)-Dnodes(y2) )
    END IF
   END IF

 s0 = Vadjust(y1,y2,iage,idp,igp)
 s1 = Vadjust(y1+1,y2,iage,idp,igp)
 s2 = Vadjust(y1,y2+1,iage,idp,igp)
 s3 = Vadjust(y1+1,y2+1,iage,idp,igp)

 v_adj = s0 * w1*w2 + &
	 s1 * (1.d0-w1)*w2 + &
	 s2 * w1*(1.d0-w2) + &
	 s3 * (1.d0-w1)*(1.d0-w2)

 s0 = Vnoadjust(y1,y2,iage,idp,igp)
 s1 = Vnoadjust(y1+1,y2,iage,idp,igp)
 s2 = Vnoadjust(y1,y2+1,iage,idp,igp)
 s3 = Vnoadjust(y1+1,y2+1,iage,idp,igp)

 v_noadj = s0 * w1*w2 + &
	 s1 * (1.d0-w1)*w2 + &
	 s2 * w1*(1.d0-w2) + &
	 s3 * (1.d0-w1)*(1.d0-w2)

 IF (v_adj >= v_noadj) THEN
 adjcross = 2

 s0 = a_adj(y1,y2,iage,idp,igp)
 s1 = a_adj(y1+1,y2,iage,idp,igp)
 s2 = a_adj(y1,y2+1,iage,idp,igp)
 s3 = a_adj(y1+1,y2+1,iage,idp,igp)

 iapcross = s0 * w1*w2 + &
	 s1 * (1.d0-w1)*w2 + &
	 s2 * w1*(1.d0-w2) + &
	 s3 * (1.d0-w1)*(1.d0-w2)

 s0 = D_adj(y1,y2,iage,idp,igp)
 s1 = D_adj(y1+1,y2,iage,idp,igp)
 s2 = D_adj(y1,y2+1,iage,idp,igp)
 s3 = D_adj(y1+1,y2+1,iage,idp,igp)

 idpcross = s0 * w1*w2 + &
	 s1 * (1.d0-w1)*w2 + &
	 s2 * w1*(1.d0-w2) + &
	 s3 * (1.d0-w1)*(1.d0-w2)

 ccross = (1.d0-delta(idp)-F-eta*r)*idcross + ixcross -(1.d0-eta)*idpcross-iapcross

 ELSE
 adjcross = 1
 idpcross = (1.d0-delta(idp)*(1.d0-gamma) )*idcross

 s0 = a_nadj(y1,y2,iage,idp,igp)
 s1 = a_nadj(y1+1,y2,iage,idp,igp)
 s2 = a_nadj(y1,y2+1,iage,idp,igp)
 s3 = a_nadj(y1+1,y2+1,iage,idp,igp)

 iapcross = s0 * w1*w2 + &
	 s1 * (1.d0-w1)*w2 + &
	 s2 * w1*(1.d0-w2) + &
	 s3 * (1.d0-w1)*(1.d0-w2)

 ccross = ixcross - iapcross + &
	     ( eta * (1-delta(idp)*(1.d0-gamma)- r) - delta(idp)*gamma )*idcross

 END IF


END SUBROUTINE
