  SUBROUTINE sub_shocks_b(age_t,init_y_shock, init_x_shock, init_d_shock, init_d_nadj_shock,init_delta_shock, &
	alive_t_shock,n_shck_shock,u_shck_shock,p_t_shock,v_shck_shock,m_shck_shock,dp_shck_shock,s_shck_shock)

  ! Generates sequence of idiosyncratic and aggregate shocks

  USE share
  USE OMP_LIB

  USE par_zig_mod

  IMPLICIT NONE

! SIMULATION
! --------------
  INTEGER, DIMENSION(numsim,agents), INTENT(OUT) :: age_t

! SHOCKS
! -------------
  REAL(8), DIMENSION(shocklives,agents,rep), INTENT(OUT) :: &
	 init_y_shock, init_x_shock, init_d_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(OUT) :: init_d_nadj_shock
  INTEGER, DIMENSION(shocklives,agents,rep), INTENT(OUT) :: init_delta_shock
  INTEGER, DIMENSION(numshock,agents,rep), INTENT(OUT) :: alive_t_shock
  REAL(8), DIMENSION(numshock,agents,rep), INTENT(OUT) :: dp_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(OUT) :: n_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(OUT) :: u_shck_shock
  REAL(8), DIMENSION(numshock,agents,rep,shck_c), INTENT(OUT) :: p_t_shock
  REAL(8), DIMENSION(numshock,twork,rep,shck_c), INTENT(OUT) :: v_shck_shock, m_shck_shock
  INTEGER, DIMENSION(numshock,shck_c), INTENT(OUT) :: s_shck_shock
  REAL(8), DIMENSION(numshock) :: v_shck_shock_store
  REAL(8) :: rand_shock, wts_temp, wts_temp2, uts_temp, &
	wage_adj, wage_adj2, init_y_shock_temp
  REAL(8), DIMENSION(agents) :: rand_shock_vec, rand_shock_vec2
  INTEGER :: j, time, i, k, age_temp, age_counter, &
	v_shck_counter, v_shck_coh_counter, s_shck_counter, wts_count, coh_fe_counter
  INTEGER, DIMENSION(agents) :: init_loc
  REAL(8), DIMENSION(numshock,rep,shck_c) :: agg_wts
  REAL(8), DIMENSION(1,ns) :: s_dis

  INTEGER  :: reset, npar, numthreads
  INTEGER, DIMENSION(agents)  :: kpar
  INTEGER, DIMENSION(:), ALLOCATABLE :: seed
  INTEGER :: grainsize = 32

  !$OMP PARALLEL
  !$OMP DO
  DO i=1, agents
  init_y_shock(:,i,:) = 0.d0
  init_x_shock(:,i,:) = 0.d0
  init_d_shock(:,i,:) = 0.d0
  init_d_nadj_shock(:,i,:) = 0
  init_delta_shock(:,i,:) = 0
  alive_t_shock(:,i,:) = 0
  n_shck_shock(:,i,:,:) = 0.d0
  u_shck_shock(:,i,:,:) = 0.d0
  p_t_shock(:,i,:,:) = 0.d0
  dp_shck_shock(:,i,:) = 0.d0
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  v_shck_shock = 0.d0
  m_shck_shock = 0.d0
  v_shck_shock_store = 0.d0
  s_shck_shock = 0

  ! 0. Set up parallel probability generator
  !----------
  !$OMP PARALLEL
  numthreads = OMP_get_num_threads()
  !$OMP END PARALLEL
  npar=numthreads+1

  ALLOCATE( seed(npar) )
  DO i = 1,npar
        seed(i) = 12345678 * i
  END DO

  reset=0
  CALL par_zigset(npar, seed, grainsize,reset)

  age_temp = 1
  age_counter = 1
  DO i=1, agents
    IF (age_counter>agent_age) THEN
    age_temp = age_temp +1
    age_counter = 1
    END IF
  age_t(1,i) = age_temp
  age_counter = age_counter+1
  END DO

  !$OMP PARALLEL
  !$OMP DO
  DO i=1, agents
    DO time =1,numsim
    	IF (time<numsim) THEN
    	  IF (age_t(time,i)<ng) THEN
    	  age_t(time+1,i) = age_t(time,i) + 1
    	  ELSE
    	  age_t(time+1,i) = 1
     	  END IF
    	END IF
    END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  DO time =1,shocklives
  !$OMP PARALLEL
  !$OMP DO
       DO i=1, agents
        DO j = 1, rep
          kpar(i) = omp_get_thread_num()+1

	  rand_shock_vec(i)=par_rnor(kpar(i))
	  init_y_shock(time,i,j) = EXP( ily_age1 + ily_stdage1 * rand_shock_vec(i) )

	  rand_shock_vec(i)=par_rnor(kpar(i))
	  init_d_shock(time,i,j) = EXP( ild_age1 + ild_stdage1 * rand_shock_vec(i) )
	  rand_shock_vec(i)=par_uni(kpar(i))
          IF ( rand_shock_vec(i)> p_adj_0 * p_adj_0_tune ) THEN
	  init_d_nadj_shock(time,i,j) = 1
          END IF
          rand_shock_vec(i)=par_rnor(kpar(i))
	  init_x_shock(time,i,j) = MAX( ik_age1 + ik_stdage1 * rand_shock_vec(i), -eta*init_d_shock(time,i,j) )
          IF (init_x_shock(time,i,j) >0.d0) THEN
          init_x_shock(time,i,j) = init_x_shock(time,i,j)*r
          ELSE
          init_x_shock(time,i,j) = init_x_shock(time,i,j) *(r +rk)
          END IF
          rand_shock_vec(i)=par_uni(kpar(i))
          IF (rand_shock_vec(i) <= Probdpcum(1,1) ) THEN
          init_delta_shock(time,i,j) = 1
          ELSE
          init_delta_shock(time,i,j) = 2
          END IF
        END DO
       END DO
  !$OMP END DO
  !$OMP END PARALLEL
  END DO

  !$OMP PARALLEL
  !$OMP DO
  DO i=1,agents
  DO j=1,rep
  rand_shock_vec(i)=par_rnor(kpar(i))
  u_shck_shock(1,i,j,:) = EXP( mu_ma(2) + sigma_ma(2) * rand_shock_vec(i) )
  p_t_shock(1,i,j,:) = init_y_shock(1,i,j)/u_shck_shock(1,i,j,1)
  END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL
  alive_t_shock(1,:,:) =1


  !$OMP PARALLEL DO PRIVATE(v_shck_counter,v_shck_coh_counter)
  DO j=1,rep
  v_shck_counter = max(shockseries1_n - shockseries1_start,0)
  v_shck_coh_counter = max(shockseriescoh_n - shockseries1_start,1)
   DO time =1,numshock
    ! WAGE SHOCKS
    IF (time<numshock-shockseries1_start .OR. time==numshock) THEN
    rand_shock_vec(j)=par_rnor(kpar(j))
    rand_shock_vec2(j)=par_rnor(kpar(j))
    DO k=1,shck_c
     DO i=1,twork
     v_shck_shock(time,i,j,k) = EXP( sigma_ag(2) * rand_shock_vec(j) )
     m_shck_shock(time,i,j,k) = v_shck_shock(time,i,j,k)**(beta_pve) * &
	EXP( rand_shock_vec2(j)*sigma_pve_res )
     END DO
    END DO
    ELSEIF (time<numshock-shockseriescoh_n+1) THEN
    v_shck_counter = v_shck_counter+1
      DO i = 1,twork
      v_shck_shock(time,i,j,:) = EXP( shockseries1(v_shck_counter) )
      m_shck_shock(time,i,j,:) = 1.d0
      END DO
    IF (j==1) v_shck_shock_store(time) = EXP( shockseries1(v_shck_counter) )

    ELSE
    v_shck_counter = v_shck_counter+1
    v_shck_coh_counter = v_shck_coh_counter+1
      IF (time<numshock-shck_c_period) THEN
      DO k=1,shck_c
       DO i=1,twork
         v_shck_shock(time,i,j,k) = EXP( shockseriescoh(v_shck_coh_counter,i) )
         m_shck_shock(time,i,j,k) = EXP( unempseriescoh(v_shck_coh_counter,i) )
       END DO
      END DO
      ELSE
        DO i=1,twork

         v_shck_shock(time,i,j,1:2) = EXP( shockseriescoh(v_shck_coh_counter,i) )
         m_shck_shock(time,i,j,1:2) = EXP( unempseriescoh(v_shck_coh_counter,i) )
         v_shck_shock(time,i,j,3) = 1.d0
         m_shck_shock(time,i,j,3) = 1.d0
        END DO
      END IF
    END IF


   END DO
  END DO
  !OMP END PARALLEL DO

  s_shck_shock = snorm
  s_shck_shock(numshock-s_shck_period:,1) = ns + 1 - snorm
  s_shck_shock(numshock-s_shck_period:,3) = ns + 1 - snorm

    DO j=1, rep
    coh_fe_counter = 0
      DO time=1,numshock

        IF (time .GE. numshock-coh_fe_n) THEN
        coh_fe_counter = coh_fe_counter+1
        END IF
        
  !$OMP PARALLEL DO PRIVATE(init_y_shock_temp)
  DO i=1, agents
	IF (time==1) THEN
        init_loc(i) = 2
        END IF
	rand_shock_vec(i)=par_rnor(kpar(i))
        DO k=1,shck_c
      	n_shck_shock(time,i,j,k) = EXP( mu_id(s_shck_shock(time,k)) + &
      		sigma_id( s_shck_shock(time,k) ) * rand_shock_vec(i) )
        END DO
	IF (time>1) THEN
	rand_shock_vec(i)=par_rnor(kpar(i))
        DO k=1,shck_c
          IF (age_t(time,i)==1) THEN
	  u_shck_shock(time,i,j,k) = EXP( mu_ma(2) + sigma_ma(2) * rand_shock_vec(i) )
          ELSE
	  u_shck_shock(time,i,j,k) = EXP( mu_ma(s_shck_shock(time,k)) + &
		sigma_ma( s_shck_shock(time,k) ) * rand_shock_vec(i) )
          END IF
        END DO
          IF (age_t(time,i)==1) THEN
                  DO k=1,shck_c
                     IF ( (time .GE. numshock-coh_fe_n) .AND. (time .LT. numshock) ) THEN
                       IF ( (time<numshock-shck_c_period) .OR. (k==1 .OR. k==2) ) THEN
                       init_y_shock_temp = init_y_shock(init_loc(i),i,j)* EXP( coh_fe(coh_fe_counter) )
                       ELSE
             	       init_y_shock_temp = init_y_shock(init_loc(i),i,j)*v_shck_shock(time,age_t(time,i),j,k)
                       END IF
                     ELSE
             	     init_y_shock_temp =  init_y_shock(init_loc(i),i,j)*v_shck_shock(time,age_t(time,i),j,k)
                     END IF
		  p_t_shock(time,i,j,k) = init_y_shock_temp/u_shck_shock(time,i,j,k)
                  END DO
                  init_loc(i) = init_loc(i) + 1
	  ELSE
	     DO k=1,shck_c
                IF (age_t(time,i)<=twork) THEN
		 p_t_shock(time,i,j,k) = gnodes(age_t(time,i))*p_t_shock(time-1,i,j,k) &
				*n_shck_shock(time,i,j,k)*v_shck_shock(time,age_t(time,i),j,k)
                ELSE
 		p_t_shock(time,i,j,k) = gnodes(age_t(time,i))*p_t_shock(time-1,i,j,k)
                END IF
             END DO
	  END IF
	END IF
	IF (time<numshock) THEN
	  IF (age_t(time,i)<ng) THEN
	    IF (alive_t_shock(time,i,j)== 1) THEN
            rand_shock_vec(i)=par_uni(kpar(i))
	    	IF( rand_shock_vec(i)<betanodes(age_t(time,i)) ) THEN
	 	alive_t_shock(time+1,i,j) = 1
		ELSE
		alive_t_shock(time+1,i,j) = 0
		END IF
	    END IF
	  ELSE
	 	alive_t_shock(time+1,i,j) = 1
	  END IF
	END IF
        dp_shck_shock(time,i,j)=par_uni(kpar(i))
  END DO
  !$OMP END PARALLEL DO
       END DO
    END DO

  END SUBROUTINE sub_shocks_b
