subroutine sub_valueiterate(Vnoadjust, Vadjust, V, a_adj,  &
	a_nadj,  D_adj, cchoice )
  USE OMP_LIB
  USE SHARE
  IMPLICIT NONE

  REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(OUT) :: Vnoadjust, Vadjust, V
  REAL(8), DIMENSION(nx,nD,ng,ndp,ns), INTENT(OUT) :: a_adj,  &
	a_nadj,  D_adj,  cchoice

  REAL(8), DIMENSION(:,:,:,:,:), ALLOCATABLE :: c_adj, c_nadj

  INTEGER :: i,iter,j,k,l,m,n,i2,j2,k2,l2,m2
  REAL(8), DIMENSION(nD*na) :: adj_hold
  REAL(8), DIMENSION(na) :: nadj_hold
  REAL(8), DIMENSION(nz,ns) :: Vadjust_z, a_adj_z,  D_adj_z
  REAL(8), DIMENSION(na,nD,ns) :: EV
  REAL(8), DIMENSION(na,nD,ndp,ns) :: EVn
  REAL(8), DIMENSION(nD,ne,ns) :: Dp, Dp_w
  REAL(8), DIMENSION(nD,ndp,ne,ns) :: Dp_nadj, Dp_nadj_w
  INTEGER, DIMENSION(nD,ne,ns) :: Dp_nodes
  INTEGER, DIMENSION(nD,ndp,ne,ns) :: Dp_nadj_nodes
  REAL(8), DIMENSION(na,nD,ne,nu,ns) :: xp, xp_w
  REAL(8), DIMENSION(na,nD,ndp,ne,nu,ns) :: xp_nadj, xp_nadj_w
  INTEGER, DIMENSION(na,nD,ne,nu,ns) :: xpnodes
  INTEGER, DIMENSION(na,nD,ndp,ne,nu,ns) :: xp_nadj_nodes
  REAL(8), DIMENSION(nx,nD,ndp) :: adjust_resource, zweight
  INTEGER, DIMENSION(nx,nD,ndp) :: z_intnodes
  INTEGER, DIMENSION(nD*na) :: dummy_choice_a, dummy_choice_D
  REAL(8), DIMENSION(2) :: V_hold
  INTEGER :: choice, index1
  REAL(8) :: C, D_hold
  INTEGER :: age

REAL(8), EXTERNAL :: fel

  ALLOCATE( c_adj(nx,nD,ng,ndp,ns), c_nadj(nx,nD,ng,ndp,ns) )

IF (nz<nx) THEN
  OPEN (UNIT=555, FILE="Output.txt", STATUS="OLD", ACTION="WRITE", POSITION="APPEND")
  WRITE(555,*) ' WARNING! nz<nx '
  CLOSE(555)
END IF

  !$OMP PARALLEL DO
   DO j=1,nD
   Vnoadjust(:,j,:,:,:) = 0.d0
   Vadjust(:,j,:,:,:) = 0.d0
   V(:,j,:,:,:) = 0.d0
   a_adj(:,j,:,:,:) = 0.d0
   a_nadj(:,j,:,:,:) = 0.d0
   D_adj(:,j,:,:,:) = 0.d0
   c_adj(:,j,:,:,:) = 0.d0
   c_nadj(:,j,:,:,:) = 0.d0
   cchoice(:,j,:,:,:) = 0.d0
   EV(:,j,:) = 0.d0
   EVn(:,j,:,:) = 0.d0
   Dp(j,:,:) = 0.d0
   Dp_w(j,:,:) = 0.d0
   Dp_nadj(j,:,:,:) = 0.d0
   Dp_nadj_w(j,:,:,:) = 0.d0
   Dp_nodes(j,:,:) = 0
   Dp_nadj_nodes(j,:,:,:) = 0
   xp(:,j,:,:,:) = 0.d0
   xp_w(:,j,:,:,:) = 0.d0
   xp_nadj(:,j,:,:,:,:) = 0.d0
   xp_nadj_w(:,j,:,:,:,:) = 0.d0
   xpnodes(:,j,:,:,:) = 0
   xp_nadj_nodes(:,j,:,:,:,:) = 0
   END DO
  !$OMP END PARALLEL DO

DO i=1,na
 DO j=1,nD
  index1 = (i-1)*nD + j
  dummy_choice_a( index1 ) = i
  dummy_choice_D( index1 ) = j
 END DO
END DO

DO i=1,nx
 DO j=1,nD
   DO k=1,ndp
   adjust_resource(i,j,k) = (1.d0-delta(k)-F-r*eta)*Dnodes(j) + xnodes(i)
   CALL sub_intpnode(nz,znodes,adjust_resource(i,j,k),z_intnodes(i,j,k),zweight(i,j,k))
   END DO
 END DO
END DO

! Age=trest+twork (a'=eta*D', no assets remaining, no debt)
! ---------------
  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,adj_hold)
   DO j=1,nz
       DO j2=1,nD
         C = znodes(j)-Dnodes(j2)
         IF (C>0.d0) THEN
         adj_hold(j2) = fel( C,Dnodes(j2), eqvnodes(ng) )
         ELSE
         C = cmin
         adj_hold(j2) = vmin
         END IF
       END DO
      choice = MAXLOC( adj_hold(:nD), 1)
      Vadjust_z(j,:) = adj_hold(choice)
      a_adj_z(j,:) = eta*Dnodes( dummy_choice_D(choice) )
      D_adj_z(j,:) = Dnodes( dummy_choice_D(choice) )
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold)
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
       C = xnodes(i) - (delta(k)*gamma+r*eta)*Dnodes(j)
       D_hold = (1.d0-delta(k)*(1.d0-gamma))*Dnodes(j)
       IF (C>0.d0) THEN
       c_nadj(i,j,ng,k,:) = C
       Vnoadjust(i,j,ng,k,:) = fel( c_nadj(i,j,ng,k,snorm), D_hold, eqvnodes(ng) )
       ELSE
       c_nadj(i,j,ng,k,:) = cmin
       Vnoadjust(i,j,ng,k,:) = vmin
       END IF
       a_nadj(i,j,ng,k,:) = eta*D_hold
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
     DO k=1,ndp
       Vadjust(i,j,ng,k,:) = zweight(i,j,k)*Vadjust_z( z_intnodes(i,j,k),snorm) + &
		            (1.d0-zweight(i,j,k))*Vadjust_z( z_intnodes(i,j,k)+1,snorm)
       D_adj(i,j,ng,k,:) = zweight(i,j,k)*D_adj_z( z_intnodes(i,j,k),snorm ) + &
		            (1.d0-zweight(i,j,k))*D_adj_z( z_intnodes(i,j,k)+1,snorm)
       a_adj(i,j,ng,k,:) = eta*D_adj(i,j,ng,k,snorm)
       c_adj(i,j,ng,k,:) = adjust_resource(i,j,k) - D_adj(i,j,ng,k,snorm)
	   IF (Vadjust(i,j,ng,k,snorm) >= Vnoadjust(i,j,ng,k,snorm)) THEN
	   V(i,j,ng,k,:) = Vadjust(i,j,ng,k,snorm)
	   cchoice(i,j,ng,k,:) = c_adj(i,j,ng,k,snorm)
	   ELSE
	   V(i,j,ng,k,:) = Vnoadjust(i,j,ng,k,snorm)
	   cchoice(i,j,ng,k,:) = c_nadj(i,j,ng,k,snorm)
	   END IF
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


! Age<trest+twork
! ---------------
DO age = ng-1,1,-1

  IF (age>=twork) THEN
 ! When retired
 ! ------------
 IF (age==ng-1) THEN
  !$OMP PARALLEL DO
	  DO j=1,nD
	   Dp(j,1,1) = Dnodes(j) / gnodes(age+1)
	   CALL sub_intpnode(nD,Dnodes,Dp(j,1,1),Dp_nodes(j,1,1),Dp_w(j,1,1))
           DO k=1,ndp
	     Dp_nadj(j,k,1,1) = (1.d0-delta(k)*(1-gamma))*Dnodes(j) / gnodes(age+1)
  	     CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,k,1,1),Dp_nadj_nodes(j,k,1,1),Dp_nadj_w(j,k,1,1))
           END DO
	 DO i=1,na
	    IF (anodes(i) >= eta*Dnodes(j)) THEN
	    xp(i,j,1,1,1) = r*anodes(i) / gnodes(age+1) + u_ret
	    ELSE
	    xp(i,j,1,1,1) = (r*anodes(i) + rk*(anodes(i)-eta*Dnodes(j)) ) &
				/ gnodes(age+1) + u_ret
	    END IF
	    CALL sub_intpnode(nx,xnodes,xp(i,j,1,1,1),xpnodes(i,j,1,1,1),xp_w(i,j,1,1,1))
            DO k=1,ndp
	     IF ( anodes(i) >= eta*(1.d0-delta(k)*(1.d0-gamma))*Dnodes(j) ) THEN
	     xp_nadj(i,j,k,1,1,1) = r*anodes(i) / gnodes(age+1) + u_ret
	     ELSE
	     xp_nadj(i,j,k,1,1,1) = (r*anodes(i) + &
				rk*(anodes(i)-eta*(1.d0-delta(k)*(1.d0-gamma))*Dnodes(j)) ) &
				/ gnodes(age+1) + u_ret
	     END IF
	     CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,k,1,1,1),xp_nadj_nodes(i,j,k,1,1,1),xp_nadj_w(i,j,k,1,1,1))
           END DO
	  END DO
	 END DO
  !$OMP END PARALLEL DO
 END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold)
  DO j=1,nD
    DO i=1,na

        V_hold(1) =     xp_w(i,j,1,1,1)*Dp_w(j,1,1)*Vnoadjust(xpnodes(i,j,1,1,1),Dp_nodes(j,1,1),age+1,ndp,1) + &
	 		xp_w(i,j,1,1,1)*(1.d0-Dp_w(j,1,1))*Vnoadjust(xpnodes(i,j,1,1,1),Dp_nodes(j,1,1)+1,age+1,ndp,1) + &
			(1.d0-xp_w(i,j,1,1,1))*Dp_w(j,1,1)*Vnoadjust(xpnodes(i,j,1,1,1)+1,Dp_nodes(j,1,1),age+1,ndp,1) + &
			(1.d0-xp_w(i,j,1,1,1))*(1.d0-Dp_w(j,1,1))*Vnoadjust(xpnodes(i,j,1,1,1)+1,Dp_nodes(j,1,1)+1,age+1,ndp,1)
        V_hold(2) =     xp_w(i,j,1,1,1)*Dp_w(j,1,1)*Vadjust(xpnodes(i,j,1,1,1),Dp_nodes(j,1,1),age+1,ndp,1) + &
	 		xp_w(i,j,1,1,1)*(1.d0-Dp_w(j,1,1))*Vadjust(xpnodes(i,j,1,1,1),Dp_nodes(j,1,1)+1,age+1,ndp,1) + &
			(1.d0-xp_w(i,j,1,1,1))*Dp_w(j,1,1)*Vadjust(xpnodes(i,j,1,1,1)+1,Dp_nodes(j,1,1),age+1,ndp,1) + &
			(1.d0-xp_w(i,j,1,1,1))*(1.d0-Dp_w(j,1,1))*Vadjust(xpnodes(i,j,1,1,1)+1,Dp_nodes(j,1,1)+1,age+1,ndp,1)
        EV(i,j,:)   =   beta * betanodes(age)*(gnodes(age+1)**(1.d0-psi)) * MAXVAL( V_hold ,1 )

     DO i2=1,ndp
	EVn(i,j,i2,:)=0.d0
         DO k=1,ndp
        V_hold(1) =     xp_nadj_w(i,j,i2,1,1,1)*Dp_nadj_w(j,i2,1,1)* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1,1),Dp_nadj_nodes(j,i2,1,1),age+1,k,1) + &
	 		xp_nadj_w(i,j,i2,1,1,1)*(1.d0-Dp_nadj_w(j,i2,1,1))* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1,1),Dp_nadj_nodes(j,i2,1,1)+1,age+1,k,1) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1,1))*Dp_nadj_w(j,i2,1,1)* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1,1)+1,Dp_nadj_nodes(j,i2,1,1),age+1,k,1) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1,1))*(1.d0-Dp_nadj_w(j,i2,1,1))* &
			  Vnoadjust(xp_nadj_nodes(i,j,i2,1,1,1)+1,Dp_nadj_nodes(j,i2,1,1)+1,age+1,k,1)
        V_hold(2) =     xp_nadj_w(i,j,i2,1,1,1)*Dp_nadj_w(j,i2,1,1)* &
			  Vadjust(xp_nadj_nodes(i,j,i2,1,1,1),Dp_nadj_nodes(j,i2,1,1),age+1,k,1) + &
	 		xp_nadj_w(i,j,i2,1,1,1)*(1.d0-Dp_nadj_w(j,i2,1,1))* &
			  Vadjust(xp_nadj_nodes(i,j,i2,1,1,1),Dp_nadj_nodes(j,i2,1,1)+1,age+1,k,1) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1,1))*Dp_nadj_w(j,i2,1,1)* &
		 	  Vadjust(xp_nadj_nodes(i,j,i2,1,1,1)+1,Dp_nadj_nodes(j,i2,1,1),age+1,k,1) + &
			(1.d0-xp_nadj_w(i,j,i2,1,1,1))*(1.d0-Dp_nadj_w(j,i2,1,1))* &
			  Vadjust(xp_nadj_nodes(i,j,i2,1,1,1)+1,Dp_nadj_nodes(j,i2,1,1)+1,age+1,k,1)
        EVn(i,j,i2,:)  = EVn(i,j,i2,:) + beta * betanodes(age)* Probdp(i2,k)* (gnodes(age+1)**(1.d0-psi)) * MAXVAL( V_hold ,1 )

      END DO

    END DO

   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  ELSE
 ! When working
 ! ------------

 !$OMP PARALLEL DO
 DO j=1,nD
   DO k=1,ne
    DO l=1,ns
   Dp(j,k,l) = Dnodes(j) / ( gnodes(age+1)*enodes(k,l) )
   CALL sub_intpnode(nD,Dnodes,Dp(j,k,l),Dp_nodes(j,k,l),Dp_w(j,k,l))
   DO m=1,ndp
    Dp_nadj(j,m,k,l) = (1.d0-delta(m)*(1.d0-gamma))*Dnodes(j) / ( gnodes(age+1)*enodes(k,l) )
    CALL sub_intpnode(nD,Dnodes,Dp_nadj(j,m,k,l),Dp_nadj_nodes(j,m,k,l),Dp_nadj_w(j,m,k,l))
    END DO
   END DO
  END DO

  DO i=1,na
   DO k=1,ne
    DO l=1,nu
     DO m=1,ns
    IF (anodes(i) >= eta*Dnodes(j)) THEN
    xp(i,j,k,l,m) = r*anodes(i) / (gnodes(age+1)*enodes(k,m)) + unodes(l,m)
    ELSE
    xp(i,j,k,l,m) = ( r*anodes(i) + rk*(anodes(i)-eta*Dnodes(j) ) ) &
		/ (gnodes(age+1)*enodes(k,m)) + unodes(l,m)
    END IF
    CALL sub_intpnode(nx,xnodes,xp(i,j,k,l,m),xpnodes(i,j,k,l,m),xp_w(i,j,k,l,m))
     DO n=1,ndp
      IF (anodes(i) >= eta*(1.d0-delta(n)*(1.d0-gamma))*Dnodes(j)) THEN
      xp_nadj(i,j,n,k,l,m) = r*anodes(i) / (gnodes(age+1)*enodes(k,m)) + unodes(l,m)
      ELSE
      xp_nadj(i,j,n,k,l,m) = ( r*anodes(i) + rk*( anodes(i)-eta*(1.d0-delta(n)*(1.d0-gamma))*Dnodes(j) ) ) &
		/ (gnodes(age+1)*enodes(k,m)) + unodes(l,m)
      END IF
      CALL sub_intpnode(nx,xnodes,xp_nadj(i,j,n,k,l,m),xp_nadj_nodes(i,j,n,k,l,m),xp_nadj_w(i,j,n,k,l,m))
     END DO
     END DO
    END DO
   END DO
  END DO
 END DO
 !$OMP END PARALLEL DO

  !$OMP PARALLEL
  !$OMP DO PRIVATE(V_hold)
  DO j=1,nD
    DO i=1,na
     DO i2=1,ns
      EV(i,j,i2) = 0.d0

      DO k = 1,ne
       DO l = 1,nu
        DO m = 1,ns
        V_hold(1) =   xp_w(i,j,k,l,m)*Dp_w(j,k,m)* &
			Vnoadjust(xpnodes(i,j,k,l,m),Dp_nodes(j,k,m),age+1,ndp,m) + &
	 		xp_w(i,j,k,l,m)*(1.d0-Dp_w(j,k,m))* &
			Vnoadjust(xpnodes(i,j,k,l,m),Dp_nodes(j,k,m)+1,age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l,m))*Dp_w(j,k,m)* &
			Vnoadjust(xpnodes(i,j,k,l,m)+1,Dp_nodes(j,k,m),age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l,m))*(1.d0-Dp_w(j,k,m))* &
			Vnoadjust(xpnodes(i,j,k,l,m)+1,Dp_nodes(j,k,m)+1,age+1,ndp,m)
        V_hold(2) =     xp_w(i,j,k,l,m)*Dp_w(j,k,m)* &
			Vadjust(xpnodes(i,j,k,l,m),Dp_nodes(j,k,m),age+1,ndp,m) + &
	 		xp_w(i,j,k,l,m)*(1.d0-Dp_w(j,k,m))* &
			Vadjust(xpnodes(i,j,k,l,m),Dp_nodes(j,k,m)+1,age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l,m))*Dp_w(j,k,m)* &
			Vadjust(xpnodes(i,j,k,l,m)+1,Dp_nodes(j,k,m),age+1,ndp,m) + &
			(1.d0-xp_w(i,j,k,l,m))*(1.d0-Dp_w(j,k,m))* &
			Vadjust(xpnodes(i,j,k,l,m)+1,Dp_nodes(j,k,m)+1,age+1,ndp,m)
        EV(i,j,i2) = EV(i,j,i2) + beta * betanodes(age)*Probe(1,k,m)*Probu(1,l,m)*Probs(i2,m)* &
			 (gnodes(age+1)*enodes(k,m))**(1.d0-psi) * MAXVAL( V_hold ,1 )
        END DO
       END DO
      END DO

      DO j2=1,ndp
      EVn(i,j,j2,i2) = 0.d0

      DO k = 1,ne
       DO l = 1,nu
        DO n = 1,ndp
         DO m = 1,ns

        V_hold(1) =     xp_nadj_w(i,j,j2,k,l,m)*Dp_nadj_w(j,j2,k,m)* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l,m),Dp_nadj_nodes(j,j2,k,m),age+1,n,m) + &
	 		xp_nadj_w(i,j,j2,k,l,m)*(1.d0-Dp_nadj_w(j,j2,k,m))* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l,m),Dp_nadj_nodes(j,j2,k,m)+1,age+1,n,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l,m))*Dp_nadj_w(j,j2,k,m)* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l,m)+1,Dp_nadj_nodes(j,j2,k,m),age+1,n,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l,m))*(1.d0-Dp_nadj_w(j,j2,k,m))* &
			Vnoadjust(xp_nadj_nodes(i,j,j2,k,l,m)+1,Dp_nadj_nodes(j,j2,k,m)+1,age+1,n,m)
        V_hold(2) =     xp_nadj_w(i,j,j2,k,l,m)*Dp_nadj_w(j,j2,k,m)* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l,m),Dp_nadj_nodes(j,j2,k,m),age+1,n,m) + &
	 		xp_nadj_w(i,j,j2,k,l,m)*(1.d0-Dp_nadj_w(j,j2,k,m))* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l,m),Dp_nadj_nodes(j,j2,k,m)+1,age+1,n,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l,m))*Dp_nadj_w(j,j2,k,m)* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l,m)+1,Dp_nadj_nodes(j,j2,k,m),age+1,n,m) + &
			(1.d0-xp_nadj_w(i,j,j2,k,l,m))*(1.d0-Dp_nadj_w(j,j2,k,m))* &
			Vadjust(xp_nadj_nodes(i,j,j2,k,l,m)+1,Dp_nadj_nodes(j,j2,k,m)+1,age+1,n,m)
        EVn(i,j,j2,i2) = EVn(i,j,j2,i2) + beta * betanodes(age)*Probe(1,k,m)*Probu(1,l,m)*Probs(i2,m)* Probdp(j2,n)* &
			 (gnodes(age+1)*enodes(k,m))**(1.d0-psi) * MAXVAL( V_hold ,1 )
         END DO
	END DO
       END DO
      END DO

     END DO

    END DO
   END DO
  END DO
  !$OMP END DO
  !$OMP END PARALLEL

  END IF

  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,choice,index1,adj_hold)
   DO j=1,nz
    DO k=1,ns
      DO i2=1,na
       DO j2=1,nD
       index1 = (i2-1)*nD + j2
       C = znodes(j)-(1.d0-eta)*Dnodes(j2)-anodes(i2)
       IF (C>0.d0) THEN
       adj_hold(index1) = fel( C,Dnodes(j2), eqvnodes(age) ) + EV(i2,j2,k)
       ELSE
       adj_hold(index1) = vmin
       END IF
       END DO
      END DO
      choice = MAXLOC( adj_hold, 1)
      Vadjust_z(j,k) = adj_hold(choice)
      a_adj_z(j,k) = anodes( dummy_choice_a(choice) )
      D_adj_z(j,k) = Dnodes( dummy_choice_D(choice) )
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


  !$OMP PARALLEL
  !$OMP DO PRIVATE(C,D_hold,choice,nadj_hold)
   DO j=1,nD
    DO i=1,nx
     DO l=1,ndp
      DO k=1,ns
      DO i2=1,na
       C = xnodes(i) - anodes(i2) + &
	     ( eta * (1-delta(l)*(1.d0-gamma) - r ) - delta(l)*gamma )*Dnodes(j)
       D_hold = (1-delta(l)*(1.d0-gamma))*Dnodes(j)
         IF (C>0.d0) THEN
         nadj_hold(i2) = fel( C, D_hold, eqvnodes(age) )+ EVn(i2,j,l,k)
         ELSE
         nadj_hold(i2) = vmin
         END IF
      END DO
       choice = MAXLOC( nadj_hold, 1)
       Vnoadjust(i,j,age,l,k) = nadj_hold(choice)
       a_nadj(i,j,age,l,k) = anodes( choice )
       c_nadj(i,j,age,l,k) = xnodes(i) - a_nadj(i,j,age,l,k) + &
	     ( eta * (1-delta(l)*(1.d0-gamma) - r) - delta(l)*gamma )*Dnodes(j)
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL

  !$OMP PARALLEL
  !$OMP DO
   DO j=1,nD
    DO i=1,nx
     DO l=1,ndp
      DO k=1,ns
       Vadjust(i,j,age,l,k) = zweight(i,j,l)*Vadjust_z( z_intnodes(i,j,l),k) + &
		            (1.d0-zweight(i,j,l))*Vadjust_z( z_intnodes(i,j,l)+1,k)
       a_adj(i,j,age,l,k) = zweight(i,j,l)*a_adj_z( z_intnodes(i,j,l),k) + &
		            (1.d0-zweight(i,j,l))*a_adj_z( z_intnodes(i,j,l)+1,k)
       D_adj(i,j,age,l,k) = zweight(i,j,l)*D_adj_z( z_intnodes(i,j,l),k) + &
		            (1.d0-zweight(i,j,l))*D_adj_z( z_intnodes(i,j,l)+1,k)
       c_adj(i,j,age,l,k) = adjust_resource(i,j,l) - a_adj(i,j,age,l,k) - (1.d0-eta)*D_adj(i,j,age,l,k)

	   IF (Vadjust(i,j,age,l,k) >= Vnoadjust(i,j,age,l,k)) THEN
	   V(i,j,age,l,k) = Vadjust(i,j,age,l,k)
	   cchoice(i,j,age,l,k) = c_adj(i,j,age,l,k)
	   ELSE
	   V(i,j,age,l,k) = Vnoadjust(i,j,age,l,k)
	   cchoice(i,j,age,l,k) = c_nadj(i,j,age,l,k)
	   END IF
      END DO
     END DO
    END DO
   END DO
  !$OMP END DO
  !$OMP END PARALLEL


END DO

DEALLOCATE(c_adj, c_nadj)

END SUBROUTINE sub_valueiterate
